-- MySQL dump 10.13  Distrib 5.1.49, for Win32 (ia32)
--
-- Host: localhost    Database: ttrss
-- ------------------------------------------------------
-- Server version	5.1.49-community

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `ttrss_access_keys`
--

DROP TABLE IF EXISTS `ttrss_access_keys`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_access_keys` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `access_key` varchar(250) NOT NULL,
  `feed_id` varchar(250) NOT NULL,
  `is_cat` tinyint(1) NOT NULL DEFAULT '0',
  `owner_uid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_access_keys`
--

LOCK TABLES `ttrss_access_keys` WRITE;
/*!40000 ALTER TABLE `ttrss_access_keys` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_access_keys` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_archived_feeds`
--

DROP TABLE IF EXISTS `ttrss_archived_feeds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_archived_feeds` (
  `id` int(11) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  `title` varchar(200) NOT NULL,
  `feed_url` text NOT NULL,
  `site_url` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_archived_feeds`
--

LOCK TABLES `ttrss_archived_feeds` WRITE;
/*!40000 ALTER TABLE `ttrss_archived_feeds` DISABLE KEYS */;
INSERT INTO `ttrss_archived_feeds` VALUES (1,1,'Tiny Tiny RSS: Forum','http://tt-rss.org/forum/rss.php',''),(2,1,'Tiny Tiny RSS: New Releases','http://tt-rss.org/releases.rss','');
/*!40000 ALTER TABLE `ttrss_archived_feeds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_cat_counters_cache`
--

DROP TABLE IF EXISTS `ttrss_cat_counters_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_cat_counters_cache` (
  `feed_id` int(11) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  `value` int(11) NOT NULL DEFAULT '0',
  `updated` datetime NOT NULL,
  KEY `ttrss_cat_counters_cache_owner_uid_idx` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_cat_counters_cache`
--

LOCK TABLES `ttrss_cat_counters_cache` WRITE;
/*!40000 ALTER TABLE `ttrss_cat_counters_cache` DISABLE KEYS */;
INSERT INTO `ttrss_cat_counters_cache` VALUES (0,1,1,'2013-06-24 13:48:45');
/*!40000 ALTER TABLE `ttrss_cat_counters_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_counters_cache`
--

DROP TABLE IF EXISTS `ttrss_counters_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_counters_cache` (
  `feed_id` int(11) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  `value` int(11) NOT NULL DEFAULT '0',
  `updated` datetime NOT NULL,
  KEY `ttrss_counters_cache_feed_id_idx` (`feed_id`),
  KEY `ttrss_counters_cache_owner_uid_idx` (`owner_uid`),
  KEY `ttrss_counters_cache_value_idx` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_counters_cache`
--

LOCK TABLES `ttrss_counters_cache` WRITE;
/*!40000 ALTER TABLE `ttrss_counters_cache` DISABLE KEYS */;
INSERT INTO `ttrss_counters_cache` VALUES (3,1,1,'2013-06-24 13:48:45');
/*!40000 ALTER TABLE `ttrss_counters_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_enclosures`
--

DROP TABLE IF EXISTS `ttrss_enclosures`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_enclosures` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content_url` text NOT NULL,
  `content_type` varchar(250) NOT NULL,
  `post_id` int(11) NOT NULL,
  `title` text NOT NULL,
  `duration` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `post_id` (`post_id`),
  KEY `ttrss_enclosures_post_id_idx` (`post_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_enclosures`
--

LOCK TABLES `ttrss_enclosures` WRITE;
/*!40000 ALTER TABLE `ttrss_enclosures` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_enclosures` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_entries`
--

DROP TABLE IF EXISTS `ttrss_entries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_entries` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` text NOT NULL,
  `guid` varchar(255) NOT NULL,
  `link` text NOT NULL,
  `updated` datetime NOT NULL,
  `content` longtext NOT NULL,
  `content_hash` varchar(250) NOT NULL,
  `cached_content` longtext,
  `no_orig_date` tinyint(1) NOT NULL DEFAULT '0',
  `date_entered` datetime NOT NULL,
  `date_updated` datetime NOT NULL,
  `num_comments` int(11) NOT NULL DEFAULT '0',
  `plugin_data` longtext,
  `comments` varchar(250) NOT NULL DEFAULT '',
  `author` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `guid` (`guid`),
  KEY `ttrss_entries_date_entered_index` (`date_entered`),
  KEY `ttrss_entries_guid_index` (`guid`),
  KEY `ttrss_entries_updated_idx` (`updated`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_entries`
--

LOCK TABLES `ttrss_entries` WRITE;
/*!40000 ALTER TABLE `ttrss_entries` DISABLE KEYS */;
INSERT INTO `ttrss_entries` VALUES (1,'Never work for money? Du Libre dans une copie du BAC d\'anglais !','SHA1:5085446f5de471517dd546c6a2c42e2c51e61259','http://www.framablog.org/index.php/post/2013/06/24/bac-anglais-logiciel-libre','2013-06-24 06:40:00','\n\n      \n      	   <p>Nous avons reçu ce mail qui nous a particulièrement touché.</p>\n\n\n<p>Cela mérite une bonne note, non&#160;? ;)</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/official-us-navy-imagery_cc-by.jpg\" alt=\"Official U.S. Navy Imagery - CC by\" style=\"display:block; margin:0 auto;\" title=\"Official U.S. Navy Imagery - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<p>Bonjour Framasoft,</p>\n\n\n<p>Je m&#8217;appelle <em>XXX</em> et j&#8217;ai maintenant passé le BAC (en espérant l&#8217;avoir réussi pour décrocher l&#8217;INSA à Rouen). Il se trouve que l&#8217;un des sujets d&#8217;expression d&#8217;Anglais LV1<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/24/bac-anglais-logiciel-libre#pnote-1662-1\" id=\"rev-pnote-1662-1\">1</a>]</sup> était&#160;:</p>\n\n\n<p><strong>&#8220;I once promised myself I would never work for money,&#8221; (Document B, 1.12). How easy is it to stick to such a decision?</strong></p>\n\n\n<p>Fervent croyant en le logiciel libre que je suis, j&#8217;ai écrit un texte sur la culture libre et le logiciel libre. Je me permets aujourd&#8217;hui de vous en faire part.</p>\n\n\n<p>Vous êtes bien sûr libre d&#8217;en faire ce que vous voulez, comme me le «&#160;corriger&#160;», me le commenter, le publier (message subliminal).</p>\n\n\n<p>Cependant, je dois vous prévenir que comme le nom de votre association se trouve dans mon texte, le correcteur de doit pas être capable de m&#8217;identifier, ce qui implique que soit l&#8217;hypothétique publication ne doit pas se trouver avant la date des résultats du BAC (5 juillet) ou que mon nom ne soit figuré nul part, du moins jusqu&#8217;aux résultats (si vous avez besoin d&#8217;un pseudonyme, utilisez «&#160;minijackson&#160;»)</p>\n\n\n<p>Voici donc le contenu du dit texte, quelque peu altéré suite à une courte réflexion postérieure&#160;:</p>\n\n\n<blockquote><p>In our commercial society, where everybody is looking for a well-paid job, not too much painful, and maybe if possible that we like, is there a place for &#8220;not for money&#8221; works&#160;?</p>\n<p>\nI would like to explain this issue through an underestimated and under-explained topic&#160;: the free culture.</p>\n<p>\nThe free culture was at first named &#8220;free software&#8221; for it was applied to softwares only. But this situation has evolved and now is extent to books, pictures and musics.</p>\n<p>\nBut what is it&#160;? It is the idea of giving freely informations or culture. But this &#8220;free&#8221; doesn&#8217;t mean &#8220;free&#8221; like in &#8220;free shipping&#8221;, but &#8220;free&#8221; like in &#8220;freedom&#8221; or &#8220;free speech&#8221;.</p>\n<p>\nIt gives the person the ability to share, remix and share the remix of a piece of culture. It is very rare to see an artist giving the ability to share and remix his piece of work. And so was created the community of free culture.</p>\n<p>\nConcerning the free softwares, developers works hard to give a good software knowing that they do not work for money. How do they do? There is mainly three cases&#160;: Either the developer has a work and spend his free time developing, or the person works for a non-profit organization that provides free software(s) like Mozilla or The Linux Foundation.</p>\n<p>\nBut it is very rare to see someone living with donations only. It is also very hard for free software developers because of organizations like Microsoft or Apple who makes everything to make the user believe that they are the only ones who can make such products.</p>\n<p>\nBut it isn&#8217;t true. Every free software developers works hard to give free and best softwares with one goal&#160;: make an open world.</p>\n<p>\nWindows and Mac are beaten by Linux, Microsoft Office is beaten by LibreOffice and Internet Explorer is beaten by Firefox.</p>\n<p>\nSome associations are also trying to spread the word, getgnulinux or Framasoft.</p>\n<p>\nFinally I would say that it is always hard to stick to that promise but we are trying. And because we are a huge community we will succeed.</p></blockquote>\n\n\n<p>En espérant que cela vous plaise et que je n&#8217;aie pas écrit de bêtises, toute critique constructive est acceptée avec plaisir.</p>\n\n\n<p>Merci et bonne continuation,</p>\n\n\n<p>minijackson</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/usnavy/5518035282/\">Official U.S. Navy Imagery</a> (Creative Commons By)</em></p>\n<div class=\"footnotes\"><h4>Notes</h4>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/24/bac-anglais-logiciel-libre#rev-pnote-1662-1\" id=\"pnote-1662-1\">1</a>] Le sujet <a href=\"http://fr.scribd.com/doc/148746654/Bac-2013-LV1-Anglais\">dans son intégralité</a> sur Sribd.</p></div>\n          ','SHA1:99433eeebf2138cd046f07891f624338d3c85a92','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(2,'Sortie du documentaire Terms And Conditions May Apply','SHA1:208fd93a878e663b86114310a530c5394232cace','http://www.framablog.org/index.php/post/2013/06/24/terms-and-conditions-may-apply','2013-06-24 05:33:00','\n\n      \n      	   <p><a href=\"http://tacma.net/\">Terms And Conditions May Apply</a>, est le titre d&#8217;un documentaire qui semble tout aussi intéressant que salutaire, a fortiori après l&#8217;affaire PRISM.</p>\n\n\n<p>Lorsque l&#8217;on crée <em>gratuitement</em> un compte sur Google, YouTube, Facebook, Twitter, Amazon (dont la typographie compose le titre de l&#8217;image ci-dessous), on accepte également de souscrire à un contrat d&#8217;utilisation qui, s&#8217;il était lu et compris jusqu&#8217;au bout, devrait normalement nous faire rebrousser chemin.</p>\n\n\n<p>Mais comme «&#160;personne ne lit ces contrats&#160;» et que «&#160;tout le monde se trouve sur ces réseaux sociaux&#160;», alors on participe nous aussi à nourrir ces <em>monstres</em> qui sucent en toute légalité nos données.</p>\n\n\n<p>En attendant sa sortie le mois prochain, nous en avons traduit l&#8217;accueil sur le site officiel. Et peut-être même, qui sait, que nous participerons à son sous-titrage.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/tacma.jpg\" alt=\"Terms And Conditions May Apply\" style=\"display:block; margin:0 auto;\" title=\"Terms And Conditions May Apply\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Termes et conditions applicables</h3>\n\n\n<p><strong><a href=\"http://tacma.net/\">Terms And Conditions May Apply</a></strong></p>\n\n\n<p><em>(Traduction&#160;:  Lamessen, sinma, calou, Asta)</em></p>\n\n\n<p>En cliquant sur le bouton de la page précédente, vous avez accepté de regarder la bande-annonce suivante&#160;:</p>\n\n\n<p><br /></p>\n\n<iframe src=\"http://player.vimeo.com/video/57182041?byline=0&amp;portrait=0\" width=\"500\" height=\"281\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe> <p><a href=\"http://vimeo.com/57182041\">Terms and Conditions May Apply Preview</a> from <a href=\"http://vimeo.com/hyraxfilms\">Hyrax Films Private</a> on <a href=\"http://vimeo.com\">Vimeo</a>.</p>\n\n\n\n<p><br /></p>\n\n\n<p>De plus, vous acceptez de voir le film <a href=\"http://tacma.net/\">à l&#8217;une de ces séances</a>.</p>\n\n\n<p>Vous avez également accepté les termes et conditions suivants&#160;:</p>\n\n\n<p>1) Tout ce que vous faites ici nous appartient</p>\n\n<ul>\n<li>Tout ce que vous publiez ou fournissez sur ce site sera considéré comme la propriété des auteurs de ce site pour toujours.</li>\n<li>Si dans le futur, il nous devient possible de lire vos pensées, nous avons le droit, mais non l&#8217;obligation, de les prendre également.</li>\n</ul>\n\n<p>2) Nous ne sommes responsables de rien</p>\n\n<ul>\n<li>Nous ne sommes pas responsables de toute confusion qui pourrait résulter de ces termes, que nous reconnaissons avoir été écrits pour être aussi confus que possible.</li>\n<li>Si vous êtes blessé d&#8217;une quelconque manière ou mourrez lors de l&#8217;usage de ce site, ou en regardant «&#160;Termes et conditions applicables&#160;», nous n&#8217;en sommes responsables sous aucun motif.</li>\n<li>Si votre souffrance mène à notre souffrance, vous pouvez être tenu responsable des dommages.</li>\n</ul>\n\n<p>3) Comment nous partageons vos informations</p>\n\n<ul>\n<li>Nous ne partagerons vos informations qu&#8217;à l&#8217;intérieur de notre propre système, et avec nos filiales.</li>\n<li>Nos filiales pourront partager vos informations avec des tierces personnes.</li>\n<li>Ces tierces personnes pourront partager vos informations avec d&#8217;autres, et ainsi de suite.</li>\n</ul>\n\n<p>4) Pour votre sécurité</p>\n\n<ul>\n<li>Nous pouvons êtres amenés à partager votre adresse IP, votre localisation, l&#8217;heure de votre visite et d&#8217;autres informations que vous nous donnez en connaissance de cause ou non avec des entités gouvernementales.</li>\n<li>Nous pouvons être contraints de ne pas vous informer et vous renoncez à tout besoin d&#8217;excuses.</li>\n<li>En utilisant ces services, vos informations peuvent être stockées par des entités légales en Utah, ou d&#8217;autres installations. Nous ne sommes pas responsables de quoi que ce soit.</li>\n</ul>\n\n<p>5) Délicieuses collations</p>\n\n<ul>\n<li>Tout cookie que nous installerons sur votre navigateur pourra vous tracker et voir où vous allez sur le Web. La suppression de ces-dits cookies pourra provoquer la régénération de ceux-ci, puisque nous voulons vraiment savoir où vous avez été et ce que vous faites.</li>\n<li>À partir de ce moment, ceux-ci seront appelés «&#160;cookies zombies&#160;».</li>\n</ul>\n\n<p>6) En échange de ces services</p>\n\n<ul>\n<li>En échange de votre visite sur ce site, vous avez consenti à publier un message indiquant que vous avez visité ce site sur Facebook. Ne pas le faire peut entraîner des poursuites judiciaires.</li>\n<li>En outre, et avec les même peines applicables, vous avez aussi accepté de regarder le film «&#160;Termes et conditions applicables&#160;», en tout ou partie des moyens suivants&amp;nbsp;: théâtre, VOD, SVOD, DVD, avion, bateau de croisière, hôtel ou mur de bâtiment.</li>\n</ul>\n\n<p>7) Résiliation</p>\n\n\n<p>Si vous estimez ces conditions d&#8217;utilisation non raisonnables, ou pour savoir quels autres usages vous avez accepté en utilisant un téléphone portable, un site Web ou une application, <a href=\"http://drivedrm.com/tacma/privacytools.php\">cliquez ici maintenant</a>.</p>          ','SHA1:16fc002d44211f90abdcb46a0b5e8a7f1141b4e3','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(3,'Ceci est une page Web (avec juste des mots à lire)','SHA1:553ffebdf313c8cca1148122f373cfa2d0790995','http://www.framablog.org/index.php/post/2013/06/23/ceci-est-une-page-web','2013-06-23 10:33:00','\n\n      \n      	   <p>Nous avons décidé d&#8217;apporter notre traduction française à <a href=\"http://justinjackson.ca/words.html\">une simple page Web</a> (à voir dans sa version originale épurée).</p>\n\n\n<p>Parce qu&#8217;il est vrai qu&#8217;on a parfois tendance à se perdre dans la forme et oublier les fondamentaux&#8230;</p>\n\n\n<h3>Ceci est une page Web</h3>\n\n\n<p><strong><a href=\"http://justinjackson.ca/words.html\">This is a web page</a></strong></p>\n\n\n<p><em>Justin Jackson - Juin 2013 - Site personnel</em><br />\n<em>(Traduction&#160;: Lamessen, Asta, Pascal + anonymes)</em></p>\n\n\n<p>Il n&#8217;y a pas grand-chose ici.</p>\n\n\n<p>Juste des mots.</p>\n\n\n<p><strong>Et vous êtes en train de les lire.</strong></p>\n\n\n<p>Nous devenons obsédés par les dessins fantaisistes, les mises en forme adaptatives et les scripts qui font des choses magiques.</p>\n\n\n<p><strong>Mais l&#8217;outil le plus puissant sur le Web reste les mots.</strong></p>\n\n\n<p>J&#8217;ai écrit ces mots, et vous êtes en train de les lire&#160;: c&#8217;est magique.</p>\n\n\n<p>Je suis dans une petite ville de Colombie-Britannique&#160;: vous êtes sans doute ailleurs. J&#8217;ai écrit ceci le matin du 20 juin 2013&#160;: vous lisez probablement ceci à un autre moment. J&#8217;ai écrit ceci sur mon ordinateur portable&#160;: vous pourriez être en train de le lire sur votre téléphone, votre tablette ou votre PC.</p>\n\n\n<p>Vous et moi pouvons nous connecter parce que <em>j&#8217;ai écrit ceci et que vous êtes en train de le lire</em>. <strong>C&#8217;est ça, le Web</strong>. Malgré nos emplacements différents, monnaies et fuseaux horaires, nous pouvons nous connecter <em>ici</em>, sur une simple page HTML.</p>\n\n\n<p>J&#8217;ai écrit ceci dans un éditeur de texte. C&#8217;est 4&#160;kb. Je n&#8217;avais pas besoin d&#8217;un CMS (système de gestion de contenu), d&#8217;un graphiste ou d&#8217;un développeur. Il n&#8217;y a pas vraiment de code sur cette page, simplement des balises pour les paragraphes, la hiérarchie et la mise en forme.</p>\n\n\n<p>Je me rappelle avoir enseigné le code HTML à ma fille, elle avait 8 ans. La première chose qu&#8217;elle a écrit était <a href=\"http://bizbox.ca/kidlet/\">une histoire à propos d&#8217;un écureuil</a>. Elle n&#8217;écrivait pas de l&#8217;HTML&#160;; <strong>elle partageait quelque chose avec le monde</strong>. Elle ne pouvait pas croire qu&#8217;elle pouvait écrire une histoire sur son ordinateur personnel et le publier pour que le monde le voit. Elle n&#8217;en avait rien à faire de l&#8217;HTML, elle souhaitait partager ses histoires.</p>\n\n\n<p><strong>Vous êtes toujours en train de lire.</strong></p>\n\n\n<p>Pensez à toutes les choses que vous pourriez communiquer avec une simple page comme celle-ci. Si vous êtes dans les affaires, vous pourriez vendre quelque chose. Si vous êtes un enseignant, vous pourriez enseigner quelque chose. Si vous êtes un artiste, vous pourriez montrer quelque chose que vous avez créé. <strong>Et si vos mots sont valables, ils seront lus</strong>.</p>\n\n\n<p>Si vous êtes un web designer ou un client qui travaille avec un designer, j&#8217;aimerais vous défier de réfléchir à vos mots en premier. Au lieu de commencer avec style guide ou une maquette Photoshop, <em>commencez avec des mots sur une page</em>.</p>\n\n\n<p>Qu&#8217;avez-vous à dire&#160;? Si vous ne le savez pas, vous n&#8217;avez aucun intérêt à ajouter toutes les autres fioritures. <strong>Commencez simplement avec une seule page</strong>, avec un seul objectif. Écrivez et publiez-le, puis réitérez l&#8217;expérience. À chaque fois que vous ajouterez quelque chose, demandez-vous&#160;: Est-ce que ceci m&#8217;aide à mieux communiquer&#160;? Est-ce que ce style additionnel, cette image ou ce lien me permet de mieux me faire comprendre par mon audience&#160;? Si la réponse est «&#160;non&#160;», ne l&#8217;ajoutez pas.</p>\n\n\n<p><strong>En son cœur,  le design web devrait concerner des mots</strong>. Les mots ne viennent pas après le design. Les mots sont le commencement, le noyau, la focalisation.</p>\n\n\n<p>Commencez par des mots.</p>\n\n\n<p>Amicalement,<br />\nJustin Jackson</p>          ','SHA1:9b36dc832fd6942678290ceac8302a0b9449ddf5','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(4,'Quand des partis pirates invitent l\'Europe à réagir à l\'affaire PRISM','SHA1:8f72fb152d294d4e5375b694e02ec6140f4885bd','http://www.framablog.org/index.php/post/2013/06/22/prism-europe-parti-pirate','2013-06-22 18:45:00','\n\n      \n      	   <p>Nous avons participé à la traduction d&#8217;un article co-signé par un certain nombre de partis pirates européens qui intime l&#8217;Europe à ne pas rester passive face à ce qu&#8217;il vient de se produire du côté de la NSA&#8230;</p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/antiprism.jpg\" alt=\"Anti PRISM\" style=\"display:block; margin:0 auto;\" title=\"Anti PRISM\" /></p>\n\n\n<h3>Anti PRISM</h3>\n\n\n<p><strong><a href=\"http://antiprism.eu/\">URL d&#8217;origine du document</a></strong></p>\n\n\n<p><em>(Traduction&#160;: Lgodard, Yoann, kenoris, zer0chain, AmarOk, Asta + anonymes)</em></p>\n\n\n<p><strong>Nous sommes consternés</strong> de découvrir une <strong>surveillance sans précédent des utilisateurs d’Internet</strong> de par le monde via PRISM et les programmes du même ordre. Des capacités de surveillance globale de telles sortes — tout particulièrement lorsqu’elles sont mises en œuvre sans accord des citoyens — sont <strong>une atteinte sérieuse aux Droits de l’Homme, à la liberté d’expression ainsi qu’à la vie privée, tous trois éléments fondateurs de nos démocraties</strong>.</p>\n\n\n<p><strong>Nous applaudissons <a href=\"http://fr.wikipedia.org/wiki/Edward_Snowden\">Edward Snowden</a></strong> pour ses actions de dénonciation. Quand un gouvernement est réellement par le peuple et pour le peuple, on ne peut considérer comme un crime de diffuser des informations sur le but et l&#8217;étendue des actions que le gouvernement engage au nom de ces citoyens, dans le but revendiqué de les protéger. Un gouvernement représentatif dans une démocratie repose sur le consentement de son peuple. Cependant, un tel consentement ne peut exister lorsque les citoyens ne sont pas complètement informés.</p>\n\n\n<p>Nous notons avec inquiétude l&#8217;absence totale de considération que le gouvernement américain montre pour les droits des citoyens européens et, plus généralement, à toute personne qui utilise les services de communication et infrastructures américains. Nous notons également l&#8217;effet négatif sur ses alliés, la souveraineté des pays concernés et la compétitivité de leurs entreprises.</p>\n\n\n<p><strong>L’Europe se doit de répondre</strong> à ces révélations avec la détermination nécessaire. À la lumière de ces informations, il devient nécessaire pour l’Union Européenne de ne pas rester complice de ces abus de pouvoir aux lourdes répercussions, et de s&#8217;élever au rang de <strong>pionner dans les domaines des droits numériques, de la protection de la vie privée, de la transparence gouvernementale et de la protection des lanceurs d&#8217;alertes</strong>.</p>\n\n\n<p><strong>Nous demandons</strong>&#160;:</p>\n\n\n<h4>1. Asile et Protection aux lanceurs d&#8217;alertes</h4>\n\n\n<p>Le gouvernement des USA a démontré - dans le cas de Bradley Manning et d&#8217;autres - que son traitement des lanceurs d&#8217;alertes est une cause de préoccupation grave. L&#8217;étiquetage public d&#8217;Edward Snowden qui apparaît comme un &#8220;traître&#8221; pour les différents responsables et les médias a créé un climat dans lequel il ne peut avoir droit à procès équitable. Il pourrait être le sujet de persécutions pour sa politique de gouvernement transparent, et sera certainement en danger de recevoir des peines ou des traitements inhumains ou dégradants, y compris la menace de la peine de mort.</p>\n\n\n<p>Nous demandons à  tous les gouvernements d&#8217;Europe de <strong>traiter avec bienveillance les demandes d&#8217;asile politique ou le statut de protection subsidiaires</strong> de M. Edward Snowden et d&#8217;autres lanceurs d&#8217;alertes, en faisant avancer rapidement d&#8217;éventuelles demandes de ce type.</p>\n\n\n<h4>2. Découvrir les faits</h4>\n\n\n<p>Il est inacceptable que des programmes secrets de surveillance <strong>contournent toute procédure démocratique</strong> et empêchent l&#8217;engagement critique et rationnel nécessaire à une démocratie pour déterminer si une action est justifiée ou non.</p>\n\n\n<p>Nous appelons le Parlement Européen à constituer un comité d&#8217;investigation, en accord avec l&#8217;article 185 de ses règles de procédure. Les faits à établir et publier sont&#160;:</p>\n\n<ul>\n<li>Quelles sont les véritables capacités de PRISM&#160;?</li>\n<li>Quels sont les flux de données et les sources qu&#8217;il utilise&#160;?</li>\n<li>Quels corps administratifs de l&#8217;UE et ses états membres ont eu connaissance ou accès à PRISM et aux programmes similaires, ou à des données issues de ces derniers&#160;?</li>\n<li>À quel point la Charte des Droits Fondamentaux, la Directive 95/46/CE sur la protection des données personnelles, la Directive du 12 juillet 2002 sur la protection de la vie privée dans le secteur des communications électroniques, ou d&#8217;autres lois européennes ont-elles été violées&#160;?</li>\n</ul>\n\n<p>Nous adressons cet appel à tous les parlements nationaux - afin de déterminer si les constitutions nationales, les lois de protection des données et les lois d&#8217;espionnage ont été violées.</p>\n\n\n<h4>3. Forte protection des données européennes</h4>\n\n\n<p>La proposition de loi <a href=\"http://en.wikipedia.org/wiki/General_Data_Protection_Regulation\">General Data Protection Regulation</a> en cours d&#8217;examen doit être renforcé afin d&#8217;assurer une protection plus large et plus profonde des données privées et professionnelles. Aux efforts de lobbying opposés il faut résister.</p>\n\n\n<p>En particulier, <strong>les données des citoyens européens ne doivent pas être sciemment remises aux services d’espionnage des États-Unis d’Amérique</strong>. L’article 42 issu de la première fuite de proposition de loi, qui portait sur les mesures de protection des lois extra territoriales de pays tiers comme le Patriot Act ou encore le Foreign Intelligence Surveillance Act des USA en posant des barrières aux autorités étrangères lors de l’accès aux données européennes, doit être réintroduit. Les méta données ainsi que les pseudonymes doivent également être protégés.</p>\n\n\n<p>D&#8217;après les principes de la &#8220;Sphère de sécurité&#8221; relatifs à la protection de la vie privée, les entreprises américaines doivent informer leurs clients lorsqu&#8217;elles permettent à des tiers d&#8217;accéder à leurs données. Il semble que les entreprises associées au programme PRISM ont violé ces dispositions. En conséquence, l&#8217;UE doit <strong>révoquer son accord</strong> à ces principes (décision n°2000/520/EC de la Commission), de telle sorte que les entreprises concernées soient soumises à la justice européenne si elles ne cessent pas ces pratiques immédiatement. La &#8220;Sphère de sécurité&#8221; doit soit être renégociée en intégrant des mesures de protection plus efficaces et plus de moyens de recours, soit être remplacée par un nouvel accord international sur la protection des données, par exemple basé sur la proposition de loi &#8220;General Data Protection Regulation&#8221;.</p>\n\n\n<h4>4. Traité international sur la Liberté sur Internet</h4>\n\n\n<p>Pour assurer qu&#8217;Internet reste une force d&#8217;autonomisation et de démocratisation plutôt que continuer d&#8217;être utilisé comme un outil limitant et réduisant la démocratie et la liberté individuelle, l&#8217;Union Européenne devrait être le fer de lance d&#8217;un <strong>traité international sur la Liberté sur Internet</strong>. Un tel traité devrait protéger fortement la confidentialité des communications, la liberté d&#8217;expression et l&#8217;accès à l&#8217;information (en particulier ce qui touche à l&#8217;Internet) ainsi que la neutralité du net.</p>\n\n\n<h4>5. Financement de logiciels respectueux de la vie privée</h4>\n\n\n<p>Afin de constituer une nouvelle ligne de défense de la vie privée, les utilisateurs doivent pouvoir <strong>choisir des logiciels et services qui respectent vraiment leur vie privée</strong>. De tels logiciels devraient garantir l&#8217;anonymat de leurs utilisateurs, offrir un système fort de chiffrement de bout-en-bout, des architectures pair-à-pair, la possibilté d&#8217;héberger soi-même ses données, un code source visible de tous, etc.</p>\n\n\n<p>Nous nous réjouissons de voir que «&#160;protéger la vie privée et la liberté des internautes&#160;» fait partie des propositions soumises en ce moment au programme <a href=\"http://fr.wikipedia.org/wiki/Horizon_2020\">Horizon 2020</a>. Nous demandons à l&#8217;Union Européenne, d&#8217;une part d&#8217;allouer <strong>une part bien plus significative</strong> des fonds de recherche à la diversification de l&#8217;offre logicielle qu&#8217;aux projets ayant le but contraire, par exemple le développement des outils de surveillance et d&#8217;exploration des données, et d&#8217;autre part de rejeter fermement des propositions dont le but explicite est la surveillance généralisée ne se basant sur aucune suspicion fondée.</p>\n\n\n<h4>6. Prévention contre un PRISM européen</h4>\n\n\n<p>Nous proposons des moyens législatifs visant à <strong>renforcer la défense contre les organismes similaires à travers toute l&#8217;Europe</strong>.</p>\n\n\n<p>Les <strong>écoutes directes</strong> des agences gouvernementales des communications au cœur du réseau Internet — comme celles ayant été reportées comme installées par la NSA dans le cadre du programme BLARNEY — doivent être explicitement déclarées hors-la-loi. De telles écoutes autorisent le stockage et l’analyse de données de toutes les communications ayant lieu sur Internet, outrepassant toutes les procédures et contrôles existants, mettant ainsi en péril la confidentialité de toutes données et la vie privée de chacun. Porter atteinte à l&#8217;intégrité du réseau d&#8217;une manière aussi révoltante empêche tout un chacun de lui faire confiance, et nous prive de tous les points positifs que l&#8217;on peut y trouver.</p>\n\n\n<p>Nous renouvelons donc notre appel pour la <strong>révocation de la directive sur la conservation des données</strong>. Les juridictions constitutionnelles tchèque, serbe et roumaine ont explicitement conclu que la collecte à grande échelle et sans suspicions de données personnelles est une violation fondamentale des droits de l&#8217;homme. Par la collecte généralisée de grandes quantités de données sans l&#8217;accord d&#8217;un tribunal, les programmes de conservation de données permettent au pouvoir exécutif d&#8217;outrepasser ses attributions au travers de plate-formes telles que PRISM, menaçant du même coup la séparation des pouvoirs exécutif et judiciaire, qui est le fondement de nos démocraties.</p>          ','SHA1:592036f6fee31d3684036be01966083bf5c89d0c','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(5,'Quand la connaissance rencontre le Libre ça donne un livre exemplaire','SHA1:640b4c9a6e1a93ad42a72863aa4a05899f2e56e3','http://www.framablog.org/index.php/post/2013/06/22/livre-libre-connaissance-universite-maths','2013-06-22 13:05:00','\n\n      \n      	   <p>Un <a href=\"http://www.lulu.com/shop/univalent-foundations-project/homotopy-type-theory-hardcover/hardcover/product-21076997.html\">livre</a> sur la théorie homotopique des types vient d&#8217;être publié par des mathématiciens. A priori ça ne concerne que les spécialistes du sujet&#8230;</p>\n\n\n<p>Et pourtant ça concerne <em>tout le monde</em>, tant sa conception originale et les leçons qui en sont tirées ci-dessous ont valeur d&#8217;exemplarité.</p>\n\n\n<p>Du Libre à tous les étages (LaTeX, Creative Commons By-Sa&#8230;) mais surtout dans son état d&#8217;esprit de partage et de collaboration. Un projet et un article passionnants, à faire lire dans la sphère académique et bien au-delà.</p>\n\n\n<p><em>Remarque&#160;: Pour commencer, on pourra voir cette courte <a href=\"http://vimeo.com/68761218\">vidéo</a> «&#160;making-of&#160;» du livre.</em></p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/termiigroupphoto.jpg\" alt=\"Homotopy Type Theory - The team\" style=\"display:block; margin:0 auto;\" title=\"Homotopy Type Theory - The team\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Le livre HoTT</h3>\n\n\n<p><strong><a href=\"http://audrey.fmf.uni-lj.si/hott.html\">The HoTT book</a></strong></p>\n\n\n<p><em>Andrej Bauer - 20 juin 2013 - Blog personnel</em><br />\n<em>(Traduction&#160;: Lgodard, Ilphrin, tcit, Guillaume, igor_d, Yaf, ronanov, fif + anonymes)</em></p>\n\n\n<p>Le livre HoTT est terminé&#160;!</p>\n\n\n<p>Depuis le printemps, et même avant, j&#8217;ai participé à un super effort collaboratif pour écrire un livre à propos de la <a href=\"http://en.wikipedia.org/wiki/Homotopy_type_theory\">Théorie homotopique des types</a> <em>(NdT&#160;: HoTT en anglais pour Homotopy Type Theory)</em>. Il est enfin terminé et accessible au public. Vous pouvez obtenir le livre <a href=\"http://homotopytypetheory.org/book/\">librement et gratuitement</a>. Mike Shulman a écrit <a href=\"http://golem.ph.utexas.edu/category/2013/06/the_hott_book.html\">à propos du contenu de ce livre</a>, donc je ne vais pas répéter cela ici. À la place, je voudrais commenter les aspects socio-technologiques de la création du livre, et en particulier de ce que nous avons appris de la communauté open source sur la recherche collaborative.</p>\n\n\n<p>Nous sommes un groupe de deux douzaines de mathématiciens qui avons écrit un livre de 600 pages en moins de 6 mois. C&#8217;est assez impressionnant, d&#8217;autant que les mathématiciens n&#8217;ont pas l&#8217;habitude de travailler ensemble au sein de grands groupes. Dans un petit groupe ils peuvent s&#8217;en sortir en utilisant des technologies obsolètes, comme envoyer aux autres un fichier source LaTeX par email, mais avec deux douzaines de personnes, même Dropbox ou n&#8217;importe quel autre système de synchronisation de fichier aurait échoué lamentablement. Par chance, beaucoup d&#8217;entre nous sont des chercheurs en Informatique déguisés en mathématiciens, donc nous savions comment attaquer les problèmes de logistique. Nous avons utilisé <a href=\"http://git-scm.com/\">git</a> et <a href=\"https://github.com/\">github.com</a>.</p>\n\n\n<p>Au début, il a fallu convaincre les gens, et se faire à l&#8217;outil. Malgré tout, cela n&#8217;a pas été trop difficile.  À la fin, le dépôt sur le serveur n&#8217;était pas seulement une archive pour nos fichiers, mais également un point central pour notre planification et nos discussions. Durant plusieurs mois j&#8217;ai consulté GitHub plus souvent que mes emails ou Facebook. Github <em>était</em> mon Facebook (sans les petits chats mignons). Si vous ne connaissez rien aux outils comme git mais que vous écrivez des articles scientifiques (ou que vous créez n&#8217;importe quel type de contenu numérique) vous devriez vraiment, vraiment vous renseigner sur des <a href=\"https://fr.wikipedia.org/wiki/Gestion_de_versions\">systèmes de gestion de versions</a>. Même en tant que seul auteur d&#8217;un article, vous allez gagner à apprendre comment en utiliser un, sans même parler des <a href=\"https://vimeo.com/68761218\">belles vidéos</a> que vous pouvez produire sur la manière dont vous avez écrit votre papier.</p>\n\n\n<p>Mais de manière plus importante, c&#8217;est l&#8217;esprit collaboratif qui imprégnait notre groupe à l&#8217;<a href=\"http://www.ias.edu/\">Institute for Advanced Study</a> (Princeton) qui était incroyable. Nous ne nous sommes pas éparpillés. Nous avons discuté, partagé des idées, <a href=\"http://video.ias.edu/taxonomy/term/78\">expliqué certains éléments</a> les uns aux autres, et avons totalement oublié qui avait fait quoi (à tel point que nous avons dû faire des efforts pour reconstruire un historique de peur que ce ne soit oublié pour toujours). Le résultat final a été une augmentation considérable de notre productivité.</p>\n\n\n<p>Il y a une leçon à en tirer (mis à part le fait que l&#8217;Institute for Advanced Study est évidemment le meilleur institut de recherche au monde), à savoir que les mathématiciens ont à gagner à devenir un peu moins possessifs vis-à-vis de leurs idées et leurs résultats. Je sais, je sais, une carrière académique dépend de la juste répartition des mérites de chacun et ainsi de suite, mais ce sont seulement les idiosyncrasies de notre époque. Si nous pouvons faire en sorte que les mathématiciens partagent des idées à moitié développées, ne s&#8217;inquiètent pas de savoir qui a apporté quelle contribution à un article, ou même qui en sont les auteurs, alors nous atteindrons un nouveau niveau de productivité encore jamais imaginé. Le progrès est le fait de ceux qui osent enfreindre les règles.</p>\n\n\n<p>Les milieux de recherche vraiment ouverts ne peuvent être gênés par le copyright, les éditeurs qui s&#8217;accaparent le profit, les brevets, les secrets commerciaux, et les programmes de financement qui sont basés sur des outils de mesures de réussite défectueux. Malheureusement nous sommes tous coincés dans un système qui souffre de ces maux. Mais nous avons fait un premier pas dans la bonne direction en mettant le code source du livre <a href=\"https://github.com/HoTT/book\">disponible librement</a> sous une licence permissive Creative Commons (la CC-By-Sa). N&#8217;importe qui peut prendre le livre et le modifier, nous envoyer des améliorations et des corrections, le traduire, ou même le vendre sans même nous donner le moindre sou (si cette dernière phrase vous a quelque peu crispé c&#8217;est que vous avez été conditionné par le système).</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/homotopy-type-theory_cover.jpg\" alt=\"Homotopy Type Theory - Couverture\" style=\"display:block; margin:0 auto;\" title=\"Homotopy Type Theory - Couverture\" /></p>\n\n\n<p><br /></p>\n\n\n<p>Nous avons décidé de ne pas faire publier le livre par un éditeur académique pour le moment car nous voulions qu&#8217;il soit accessible à tous, rapidement et sans frais. Le livre peut être téléchargé gratuitement, ou bien acheté à peu de frais avec une couverture <a href=\"http://www.lulu.com/shop/univalent-foundations-project/homotopy-type-theory-hardcover/hardcover/product-21076997.html\">rigide</a> ou <a href=\"http://www.lulu.com/shop/univalent-foundations-project/homotopy-type-theory-paperback/paperback/product-21077021.html\">souple</a> sur <a href=\"http://lulu.com/\">lulu.com</a> (quand avez-vous pour la dernière fois payé moins de 30$ pour une monographie de 600 pages à couverture rigide&#160;?). Une fois de plus, j&#8217;entends déjà certaines personnes dire&#160;: «&#160;oh mais un vrai éditeur universitaire est synonyme de qualité&#160;». Cette façon de penser rappelle les arguments opposant Wikipédia et Britannica, et nous savons tous comment cette histoire s&#8217;est terminée. Oui, la bonne qualité de la recherche doit être assurée. Mais une fois que nous acceptons le fait que n&#8217;importe qui peut publier n&#8217;importe quoi sur Internet permettant au monde entier de le consulter et en faire un livre bon marché à l&#8217;air professionnel, nous réalisons rapidement que la censure n&#8217;est plus efficace. À la place, nous avons besoin d&#8217;un système décentralisé d&#8217;approbation qui ne pourrait pas être manipulé par des groupes d’intérêts spéciaux. Les choses sont en train de bouger dans cette direction, avec la création récente du <a href=\"https://selectedpapers.net/\">Selected Papers Networks</a> (Réseaux d&#8217;écrits sélectionnés) et d&#8217;autres projets similaires. J&#8217;espère qu&#8217;ils auront un bel avenir.</p>\n\n\n<p>Cependant, il y a quelque chose d&#8217;autre que nous pouvons faire. C&#8217;est plus radical, mais aussi plus utile. Plutôt que de laisser les gens se contenter d&#8217;évaluer les articles, pourquoi ne pas leur donner une chance de participer et aussi d&#8217;améliorer ces articles&#160;? Mettez tous vos articles sur GitHub et laissez les autres en discuter, poser des questions, les utiliser comme bases pour leur travail (fork), les améliorer, et vous envoyer des corrections. Est-ce que cela paraît fou? Bien sûr que oui, l<em>&#8216;open source</em> paraissait également une idée folle lorsque Richard Stallman <a href=\"https://groups.google.com/group/net.unix-wizards/msg/4dadd63a976019d7?dmode=source&amp;hl=en\">a lancé son manifeste</a>. Soyons honnêtes, qui va vous voler votre code source LaTeX&#160;? Il y a bien d&#8217;autres choses de valeur susceptibles d&#8217;être volées. Si vous êtes un professeur titulaire vous pouvez vous permettre d&#8217;ouvrir le chemin. Faites-vous enseigner git par vos thésards et mettez vos trucs dans un endroit public. N&#8217;ayez pas peur, ils vous ont titularisé pour que vous fassiez des choses comme ça.</p>\n\n\n<p>Donc nous invitons tout le monde à améliorer le livre en participant sur GitHub. Vous pouvez laisser des commentaires, signaler des erreurs, et même mieux, faire des corrections par vous-même&#160;! Nous n&#8217;allons pas nous inquiéter de savoir qui vous êtes et combien vous contribuez et qui devrait recevoir les honneurs. La seule chose qui importe est de savoir si vos contributions sont bonnes.</p>\n\n\n<p>Ma dernière observation est à propos de la formalisation des mathématiques. Les mathématiciens aiment imaginer que leurs publications peuvent en principe être formalisées dans la <a href=\"http://fr.wikipedia.org/wiki/Th%C3%A9orie_des_ensembles\">Théorie des Ensembles</a>. Ceci leur donne un sentiment de sécurité, qui n&#8217;est pas différente de celui ressenti par un croyant entrant dans une cathédrale d&#8217;âge canonique. C&#8217;est une forme de foi professée par les logiciens. La Théorie homotopique des types est un fondement alternatif à la Théorie des Ensembles. Nous revendiquons nous aussi que les mathématiques ordinaires peuvent en principe être formalisées en Théorie homotopique des types . Mais devinez quoi, vous n&#8217;avez pas à nous croire sur parole&#160;! Nous avons formalisé les parties les plus complexes du livre HoTT et vérifié les preuves avec des assistants de preuve électroniques. Pas <a href=\"https://github.com/HoTT/HoTT\">une fois</a> mais <a href=\"https://github.com/HoTT/HoTT-Agda\">deux</a>. Et nous avons formalisé en premier lieu, puis nous avons écrit le livre car c&#8217;était plus simple de formaliser. Nous sommes gagnants sur tous les plans (s&#8217;il y a une compétition).</p>\n\n\n<p>J&#8217;espère que le livre vous plaira, il contient une impressionnante quantité de mathématiques inédites.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/.torus-rainbow_m.jpg\" alt=\"Homotopy Type Theory - Tor\" style=\"display:block; margin:0 auto;\" title=\"Homotopy Type Theory - Tor\" /></p>          ','SHA1:33b90f8627bad5ce2f2a82840a706d1896ec39b3','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(6,'L\'ADULLACT, l\'AFUL et Framasoft soutiennent l\'amendement limitant les racketiciels du groupe GDR défendu par Mme Fraysse','SHA1:1f5d1ccb42d15675bbb2b40910ea458266fb518e','http://www.framablog.org/index.php/post/2013/06/22/racketiciels-aful-adullact-framasoft','2013-06-22 07:54:00','\n\n      \n      	   <p><span class=\"date-effective\" style=\"font-size: 12px; font-weight: normal;\">21/06/2013&#160;18:20 (</span><span style=\"font-size: 12px; font-weight: normal;\">Dernière modification&#160;: 21/06/2013&#160;19:51)</span></p>\n<p><em>Dans le cadre du projet de loi relatif à la consommation, L&#8217;ADULLACT, l&#8217;AFUL et Framasoft apportent leur soutien, sans réserve, à l&#8217;amendement 711 déposé par le groupe GDR et défendu par Jacqueline Fraysse. Cet amendement va dans la bonne voie pour mettre un terme au scandale des racketiciels, c&#8217;est-à-dire à la vente forcée de logiciels non demandés lors de l&#8217;achat de matériel informatique.</em></p>\n<p><strong><img src=\"http://www.framablog.org/public/_img/others/camembert_materiel_licences_2013_cp_fraysse_003_250x215.png\" alt=\"\" style=\"float: right; margin: 0 0 1em 1em;\" />Les associations du logiciel libre appellent donc tous les députés,\nde toute tendance politique, à soutenir vivement <a href=\"http://www.assemblee-nationale.fr/14/amendements/1156/AN/711.asp\">cet\namendement</a>&#160;!</strong></p>\n<h2>Au dernier épisode…</h2>\n<p>À l&#8217;automne 2011, le gouvernement de François Fillon avait proposé un projet\nde loi de protection du consommateur. Plusieurs députés avaient proposé des\namendements censés apporter une meilleure protection du consommateur face aux\npratiques commerciales déloyales de vente forcée des logiciels inclus dans le\nmatériel informatique. Comme l&#8217;AFUL l&#8217;avait souligné à l&#8217;époque, <a href=\"http://aful.org/communiques/amendement-432-propose-legaliser-racketiciels\">le\nremède était pire que le mal</a> puisque après une lecture juridique attentive,\nces textes aboutissaient à un résultat totalement opposé au but recherché.</p>\n<p>Lors des débats, <a href=\"http://aful.org/communiques/vente-subordonnee-la-legislation-actuelle-conservee\">\nles députés avaient bien identifié les faiblesses juridiques des uns et la\ndangerosité des autres et avaient finalement laissé la législation en\nl&#8217;état</a> afin de réfléchir à de meilleures rédactions pour la seconde\nlecture. Seconde lecture qui n&#8217;a jamais eu lieu suite au retrait du texte par\nle gouvernement.</p>\n<p>Aujourd&#8217;hui, un <a href=\"http://www.assemblee-nationale.fr/14/dossiers/projet_de_loi_consommation.asp\">nouveau\nprojet de loi de consommation</a> est présenté à la nouvelle législature. Forts\nde l&#8217;enseignement tiré des débats de 2011 et des arguments issus des divers\nbancs, le groupe Gauche démocrate et républicaine sous l&#8217;impulsion de <a href=\"http://www.assemblee-nationale.fr/14/tribun/fiches_id/1364.asp\">Jacqueline\nFraysse, députée de la 4e circonscription des Hauts-de-Seine</a>, propose un\namendement ayant pour objectif de mettre fin aux pratiques commerciales\ndéloyales de l&#8217;informatique grand public, dans le respect de la législation\neuropéenne.</p>\n<h2>Analyse de l&#8217;amendement proposé</h2>\n<p>L&#8217;amendement propose d&#8217;ajouter des obligations d&#8217;informations à la charge\ndes professionnels dans un nouvel article L. 113-6 du Code de la\nconsommation.</p>\n<blockquote>\n<p>Après l’article L. 113-5 du Code de la consommation, insérer l’article\nsuivant&#160;:</p>\n<p>«&#160;Le matériel informatique proposé à la vente avec des logiciels\nintégrés constitue une <strong>vente par lots</strong>.</p>\n<p>Tout professionnel vendeur de matériel informatique fournissant des\nlogiciels intégrés doit, avant tout paiement du prix par le consommateur,\nl<strong>&#8216;informer par voie d&#8217;affichage</strong> des caractéristiques\nessentielles et du prix public toutes taxes comprises du lot ainsi que du\nprix de chacun des logiciels composant individuellement le lot. L&#8217;indication\nde ces prix doit figurer sur la facture remise au consommateur.</p>\n<p>La violation de ces dispositions entre dans le champ d&#8217;application de\nl&#8217;article L. 122-3 du Code de la consommation.&#160;»</p>\n</blockquote>\n<h3>Vente par lots</h3>\n<p>Tout d&#8217;abord, l&#8217;alinéa 1 aborde la question de la vente par lots en\nprécisant désormais expressément que le matériel informatique vendu avec des\nlogiciels préchargés constitue une vente par lots.</p>\n<p>En effet, si la jurisprudence applique depuis longtemps ce principe\n(notamment depuis un <a href=\"http://www.legifrance.gouv.fr/affichJuriJudi.do?idTexte=JURITEXT000007070696\">arrêt\nde 2005</a> de la Cour de cassation), il est régulièrement contesté devant les\ntribunaux, forçant les consommateurs qui <em>estent</em> en justice à expliquer\nencore et toujours pourquoi matériel et logiciels constituent deux produits\nparfaitement distincts (l&#8217;un est un bien meuble, l&#8217;autre une prestation de\nservices). En précisant désormais clairement qu&#8217;il s&#8217;agit d&#8217;une vente par lots,\nla réglementation spécifique à l&#8217;information due par les professionnels sur les\nlots, issue de l&#8217;article 7 de <a href=\"http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000689147&amp;idArticle=LEGIARTI000006883553&amp;dateTexte=20130618\">\nl&#8217;arrêté du 3 décembre 1987</a>, s&#8217;appliquera.</p>\n<h3>Obligations d&#8217;information</h3>\n<p>L&#8217;alinéa 2 détaille les obligations d&#8217;information nécessaires&#160;: informer le\nconsommateur par voie d&#8217;affichage des caractéristiques essentielles des\nproduits proposés dans le lot.</p>\n<p>Les caractéristiques essentielles sont l&#8217;ensemble des éléments permettant au\nconsommateur d&#8217;effectuer un choix éclairé&#160;: par exemple, préciser que le\nmatériel et les logiciels peuvent être vendus séparément, que les logiciels ne\nsont que des options non obligatoires ou encore que les logiciels fournis sont\npayants. S&#8217;agissant du prix des produits, il devra fait l&#8217;objet d&#8217;une\ninformation précise, non seulement pour le prix des produits composant le lot,\nmais également le prix de chacun des éléments du lot. La facture qui sera\nremise au consommateur comprendra donc le prix détaillé de tous les produits.\nLes procès initiés par les consommateurs ont mis en évidence que le prix des\nlogiciels fournis préchargés, jusque là vendu de force, pouvaient représenter\nplus de 30&#160;% du prix de la machine seule.</p>\n<h3>Sanctions</h3>\n<p>Le 3e alinéa aborde la question des sanctions. La <a href=\"http://eur-lex.europa.eu/LexUriServ/LexUriServ.do?uri=OJ:L:2005:149:0022:0039:FR:PDF\">\ndirective 2005/29/CE</a> du 11 mai 2005 rappelle, au paragraphe 29 de son\nannexe 1, que la vente forcée est une pratique commerciale déloyale «&#160;en toutes\ncirconstances&#160;» c&#8217;est-à-dire qu&#8217;il suffit théoriquement à un juge de constater\nque le professionnel a exigé un paiement sans commande expresse et préalable du\nconsommateur pour que la pratique soit déclarée déloyale. Cette disposition a\nété intégrée dans le Code de la consommation par les lois des 3 janvier et 4\naoût 2008. Les textes ont d&#8217;ailleurs été remaniés avec la loi Warsman de 2011\nqui a proposé une lecture plus claire de l&#8217;article <a href=\"http://www.framablog.org/index.php/post/2013/06/22/L.%20122-3\">L.\n122-3</a> du Code de la consommation. Cet article prévoit des sanctions civiles\nde nullité du contrat avec une obligation de remboursement, ainsi que des\nsanctions pénales. Le texte est donc parfaitement adapté à la situation et\npermet aux consommateurs d&#8217;agir autant par la voie civile que par la voie\npénale et d&#8217;espérer avoir ainsi du poids face aux entreprises concernées, le\nplus souvent multinationales.</p>\n<h2>Voter ce texte malgré les pressions</h2>\n<p>C&#8217;est ce texte qui doit être favorisé et que les députés sont encouragés à\nadopter massivement. Il faut tout de même rappeler qu&#8217;à l&#8217;occasion du précédent\nprojet de loi consommation de 2011, <a href=\"http://www.assemblee-nationale.fr/13/cri/2011-2012/20120003.asp#INTER_ADT_43\">des\ndéputés s&#8217;étaient plaints des pressions qu&#8217;ils subissaient</a> pour ne pas\nvoter ces textes favorables aux consommateurs et le député de la 5<sup>e</sup>\ncirconscription d&#8217;Isère, François BROTTES, avait clairement dénoncé cette\nsituation inadmissible. Sous la présente législature, <strong>c&#8217;est aujourd&#8217;hui\nque se mesurera le courage politique et l&#8217;engagement des députés pour l&#8217;intérêt\ngénéral</strong>.</p>\n<h2>L&#8217;intérêt général d&#8217;abord&#160;!</h2>\n<p>L&#8217;intérêt du consommateur et l&#8217;ouverture du marché à tous les acteurs,\nnotamment français, étant la priorité des élus de la nation, nous sommes\nconfiants dans le fait que l&#8217;ensemble des députés verront le point d&#8217;équilibre\natteint par cet amendement et qu&#8217;ils le soutiendront unanimement.</p>\n<p>Cyprien Gay, membre du groupe de travail «&#160;<a title=\"le but de notre action\" href=\"http://non.aux.racketiciels.info/but-site\">non aux racketiciels</a>&#160;» de\nl&#8217;AFUL indique «&#160;<em>Voilà 15 ans que nous interpellons les politiques de\ntoutes tendances sur cette question. Depuis le début des années 2000&#160;<a title=\"Questions écrites au gouvernement\" href=\"http://non.aux.racketiciels.info/documentation/positions#pouvoirs-publics\">ce\nsujet est évoqué à l&#8217;Assemblée</a>. Cependant, la pression des éditeurs qui\nbénéficient de cette vente forcée a réussi jusqu&#8217;ici à conserver un statu quo\nqui leur est favorable, avec la <a title=\"déclarations des membres du gouvernement\" href=\"http://non.aux.racketiciels.info/promesses\">complicité inexplicable</a> des\ndivers gouvernements.</em>&#160;»</p>\n<p>Christophe Masutti, président de Framasoft, déclare «&#160;<em>Il est est plus\nque nécessaire de clarifier les pratiques de vente liée qui maintiennent une\ntension évidente entre d&#8217;un côté le droit du consommateur à l&#8217;information et de\nl&#8217;autre côté le recours providentiel aux directives européennes qui empêche les\nÉtats membres d&#8217;interdire les &#8220;offres conjointes&#8221; assimilées à une pratique\ncommerciale comme une autre, bien que la &#8220;vente forcée&#8221; soit, elle,\ncondamnable. Ceci constitue un frein artificiellement entretenu au déploiement\ndu formidable potentiel compétitif du logiciel libre.</em>&#160;»</p>\n<p>Dimitri Robert, administrateur de l&#8217;AFUL souligne «&#160;<em>Les logiciels vendus\nde force avec les matériels informatiques sont édités hors d&#8217;Europe par des\nentreprises réputées pour leur évasion fiscale et l&#8217;évitement à l&#8217;impôt sur\nleurs activités en France. Il n&#8217;y a donc aucun intérêt pour la France ou pour\nl&#8217;Europe d&#8217;<a title=\"un milliard par an\" href=\"http://non.aux.racketiciels.info/nouvelles/niches-encore-rente-milliard-france\">entretenir\nleur rente</a> sur le dos du consommateur Français.</em>&#160;»</p>\n<p>Également interrogé, l&#8217;avocat de l&#8217;AFUL, Maître Frédéric CUIF, estime que «\n<em>Il s&#8217;agit d&#8217;un texte de consensus qui devrait à la fois permettre une\nmeilleure information des consommateurs mais aussi leur offrir la possibilité\nde dénoncer moins difficilement ces pratiques commerciales déloyales devant les\ntribunaux. Bien sûr, il faudra toujours passer par un juge pour faire cesser la\npratique commerciale déloyale de vente forcée, mais c&#8217;est un premier pas\névident en faveur des consommateurs en attendant une véritable prise de\nconscience nationale sur la question.</em>&#160;»</p>\n<p>Laurent Séguin, président de l&#8217;AFUL conclut&#160;: «&#160;<em><em>Il est temps de\nfaire cesser cette situation de <a title=\"moins de choix que les autres\" href=\"http://non.aux.racketiciels.info/moins-choix-autres\">concurrence faussée</a>\noù l&#8217;on impose, depuis trop longtemps, un choix uniforme aux consommateurs. Des\nacteurs européens et français portent d&#8217;ores et déjà des solutions concurrentes\ncrédibles et innovantes, notamment sous licence libre, aux logiciels vendus de\nforce avec du matériel informatique. Malheureusement, ces racketiciels les\nempêchent d&#8217;accéder au marché sur un pied d&#8217;égalité.</em> Aujourd&#8217;hui, avec ces\ntextes justes et équilibrés, <em>les parlementaires ont</em>\nl&#8217;opportunité de faire triompher enfin l&#8217;intérêt général en faisant en sorte\nqu&#8217;en France, les effets de ce <a title=\"Roberto Di Cosmo\" href=\"http://www.dicosmo.org/HoldUp/\">hold-up planétaire</a> soient amoindris.</em>\n»</p>\n<h2><img src=\"http://www.framablog.org/public/_img/others/adullact.png\" alt=\"\" style=\"float: right; margin: 0 0 1em 1em;\" />À propos de l&#8217;Adullact (<a href=\"http://adullact.org/\">http://adullact.org/</a>)</h2>\n<p>Née fin 2002, l&#8217;Association des Développeurs et Utilisateurs de Logiciels\nLibres pour les Administrations et les Collectivités Territoriales s&#8217;est donnée\npour tâche de constituer, développer et promouvoir un patrimoine commun de\nlogiciels libres métiers, afin que l&#8217;argent public ne paie qu&#8217;une fois.\nL&#8217;Adullact dispose d&#8217;une équipe permanente, pour encourager et aider les\nmembres à mutualiser leurs développements sur la forge adullact.net, qui compte\naussi les projets de la forge admisource. Structure unique en son genre,\nl&#8217;Adullact était accréditée pour le Sommet Mondial de Tunis.</p>\n<h2><img src=\"http://www.framablog.org/public/_img/others/AFUL_logo_100x100_FondTransparent.png\" alt=\"\" style=\"float: right; margin: 0 0 1em 1em;\" />À propos de l&#8217;AFUL (<a href=\"http://aful.org/\">http://aful.org/</a>)</h2>\n<p><em>Association Francophone des Utilisateurs de Logiciels\nLibres</em>, l&#8217;AFUL a pour principal objectif de promouvoir les logiciels\nlibres ainsi que l&#8217;utilisation des standards ouverts. Ses membres,\nutilisateurs, professionnels du logiciel libre, entreprises ainsi que d&#8217;autres\nassociations, sont issus d&#8217;une dizaine de pays ou de régions francophones\n(France, Belgique, Suisse, Afrique francophone, Québec).</p>\n<p>Interlocuteur de nombreux médias, l&#8217;AFUL est présente sur nombre\nde salons, conférences et rencontres. Elle agit notamment activement contre la\nvente liée (site <a href=\"http://non.aux.racketiciels.info/\">Non aux\nRacketiciels</a>, comparatif <a href=\"http://bons-vendeurs-ordinateurs.info/\">bons-vendeurs-ordinateurs.info</a> et\n<a href=\"http://bons-constructeurs-ordinateurs.info/\">bons-constructeurs-ordinateurs.info</a>),\npour l&#8217;interopérabilité (<a href=\"http://aful.org/gdt/interop/aful-afnor\">membre de l&#8217;AFNOR</a>, participation\naux référentiels d&#8217;interopérabilité et d&#8217;accessibilité de la DGME, site\n<a href=\"http://www.formats-ouverts.org/\">formats-ouverts.org</a>, etc.),\nintervient sur les problématiques du <a href=\"http://aful.org/droit-auteur\">droit d&#8217;auteur</a> ainsi que pour la promotion\nde l&#8217;utilisation de logiciels et ressources pédagogiques libres pour\nl&#8217;éducation entendue au sens large.</p>\n<h2><img src=\"http://www.framablog.org/public/_img/others/Logo_Framasoft.png\" alt=\"\" style=\"float: right; margin: 0 0 1em 1em;\" />À propos de Framasoft (<a href=\"http://framasoft.org/\">http://framasoft.org/</a>)</h2>\n<p>Issu du monde éducatif, Framasoft est un réseau d’éducation populaire\nconsacré principalement au logiciel libre et s’organise en trois axes sur un\nmode collaboratif&#160;: promotion, diffusion et développement de logiciels libres,\nenrichissement de la culture libre et offre de services libres en ligne.&nbsp;\nPour plus d’informations, vous pouvez vous rendre sur le site Web à l’adresse\nsuivante&#160;: <a href=\"http://www.framasoft.org/ \">http://www.framasoft.org/</a> et nous contacter par notre formulaire de\ncontact <a href=\"http://contact.framasoft.org/\">http://contact.framasoft.org/</a>.&nbsp;</p>\n<p>&nbsp;</p>\n<h3>Contacts presse&#160;:</h3>\n<ul class=\"spaceBottom\">\n<li>Laurent Séguin, président de l&#8217;AFUL, <a href=\"mailto:laurent.seguin@aful.org\">laurent.seguin@aful.org</a> +33 (0)6&#160;63&#160;94\n87&#160;16</li>\n<li>Me Frédéric Cuif, avocat au barreau de Poitiers, +33 (0)5&#160;49&#160;88&#160;70\n61</li>\n<li>Cyprien Gay, membre <abbr title=\"groupe de travail Racketiciel\">GdT\nRacketiciel</abbr>, <a href=\"mailto:cyprien.gay@aful.org\">cyprien.gay@aful.org</a> +33 (0)6&#160;61&#160;89&#160;49\n82</li>\n<li>Alexis Kauffmann, fondateur et chargé de mission Framasoft, <a href=\"mailto:aka@framasoft.org\">aka@framasoft.org</a> +33 (0)6&#160;95&#160;01&#160;04&#160;55</li>\n<li>Relations presse - AFUL&#160;: <a href=\"mailto:presse@aful.org\">presse@aful.org</a></li>\n</ul>          ','SHA1:4e69df1495ebfe831a929f81ff56b8bf1fadad4d','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(7,'Geektionnerd : DuckDuckGo','SHA1:3e6c74ce87c4ca0ea6e8e636fbd877f5b5e26a9e','http://www.framablog.org/index.php/post/2013/06/21/geektionnerd-duckduckgo','2013-06-21 13:11:00','\n\n      \n      	   <p><img src=\"http://www.framablog.org/public/_img/geektionnerd/geektionnerd_151-1_simon-gee-giraudot_cc-by-sa.jpg\" alt=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/geektionnerd/geektionnerd_151-2_simon-gee-giraudot_cc-by-sa.jpg\" alt=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/geektionnerd/geektionnerd_151-3_simon-gee-giraudot_cc-by-sa.jpg\" alt=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" /></p>\n\n\n<p>Source&#160;:</p>\n\n<ul>\n<li><a href=\"http://www.telerama.fr/medias/prism-le-moteur-de-recherche-duck-duck-go-profite-des-scandales-d-espionnage,98955.php\">PRISM&#160;: le moteur de recherche Duck Duck Go profite du scandale (Télérama)</a></li>\n</ul>\n\n<p><em>Crédit&#160;: <a href=\"http://geektionnerd.net/\">Simon Gee Giraudot</a> (Creative Commons By-Sa)</em></p>          ','SHA1:7d5c2761c76c1700e676ee8bc0b31ad5ce386b77','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(8,'Anthony Goubard, l\'homme qui coda seul en 30 jours une suite bureautique libre','SHA1:15c38c4a6adf53dd0bc131c17fb001ecd5a6c12b','http://www.framablog.org/index.php/post/2013/06/20/joffice-anthony-goubard','2013-06-20 06:46:00','\n\n      \n      	   <p>Vous connaissiez la suite bureautique libre <strong><a href=\"http://www.joeffice.com/\">Joeffice</a></strong>&#160;?</p>\n\n\n<p>Nous, non&#160;! Et quand nous avons appris qu&#8217;elle avait été conçue en 30 jours par un développeur (qui plus est français), nous avons évidemment eu envie d&#8217;en savoir plus&#8230;</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/anthony-goubard.png\" alt=\"Anthony Goubard\" style=\"display:block; margin:0 auto;\" title=\"Anthony Goubard\" /></p>\n\n\n<p><br /></p>\n\n\n<p><strong>Bonjour Anthony, peux-tu te présenter succinctement&#160;? Quel a été ton parcours de développeur&#160;?</strong></p>\n\n\n<p>Bonjour, je m&#8217;appelle <a href=\"http://www.jroller.com/agoubard/\">Anthony Goubard</a>, j&#8217;ai 40 ans et j&#8217;habite à Amsterdam. J&#8217;ai commencé Java durant ma dernière année d&#8217;ingénieur avec la version 1.0 alpha puis j&#8217;ai fait du détachement sur la région parisienne. Il y a 14 ans je suis allé travailler pour une start-up aux Pays-Bas puis pour Wanadoo Pays-Bas et il y a 5 ans je me suis mis à mon compte.</p>\n\n\n<p><strong>Alors Joeffice c&#8217;est quoi exactement&#160;? Comment et pourquoi est né le projet&#160;?</strong></p>\n\n\n<p><a href=\"http://www.joeffice.com/\">Joeffice</a> est une suite bureautique open source écrite en <a href=\"http://fr.wikipedia.org/wiki/Java_(langage)\">Java</a>. L&#8217;idée m&#8217;est venue il y a environ 2 ans lorsque je me suis aperçu que c&#8217;était galère d&#8217;avoir 10 documents d&#8217;ouverts avec Microsoft Office ou Libre Office alors que ce n&#8217;est pas un problème d&#8217;avoir 30 documents ouverts dans <a href=\"http://fr.wikipedia.org/wiki/Eclipse_(projet)\">Eclipse</a> ou <a href=\"http://fr.wikipedia.org/wiki/NetBeans\">NetBeans</a>.</p>\n\n\n<p><strong>Dans quel sens évoques-tu une version «&#160;online&#160;» et «&#160;offline&#160;»&#160;?</strong></p>\n\n\n<p>Les logiciels Java peuvent être installés sur un ordinateur comme un logiciel classique ou bien être lancé en ligne dans le navigateur avec l&#8217;aide du plugin Java. C&#8217;est ce qu&#8217;on appelle le mode Applet. Il suffit donc d&#8217;aller à l&#8217;URL et le logiciel s&#8217;installe et se lance dans le navigateur automatiquement. J&#8217;ai donc décidé d&#8217;offrir les deux possibilités. La version «&#160;online&#160;» est soumise à un abonnement.</p>\n\n\n<p><strong>Pourquoi le choix Java&#160;?</strong></p>\n\n\n<p>Java offre beaucoup d&#8217;avantages. Il est portable sur plusieurs OS, il est relativement facile à lire, beaucoup d&#8217;étudiants apprennent Java et il est très utilisé dans le monde de l&#8217;entreprise. Beaucoup de projets open source utilisent Java. Joeffice offre aux étudiants et développeurs Java la possibilité de travailler sur un projet assez visuel et utile.</p>\n\n\n<p><strong>Pourquoi le choix de la licence libre&#160;?</strong></p>\n\n\n<p>L&#8217;union fait la force.Tous les développeurs Java que je connais se servent de temps en temps d&#8217;une suite bureautique. Avoir un projet bien mené par un grand groupe de contributeurs permettra à long terme de créer un bien meilleur logiciel qu&#8217;avec une petite équipe. En plus, beaucoup d&#8217;entreprises et de pays en voix de développement sont attirés par l&#8217;open source et mon but est de toucher le plus de personnes possible.. Le premier groupe d&#8217;utilisateurs pour Joeffice est donc l&#8217;entreprise. Dans ce cas la licence Apache 2.0 donne beaucoup de liberté, plus que GPL et LGPL. Cette licence est par exemple utilisée pour le <a href=\"http://fr.wikipedia.org/wiki/Spring_framework\">framework Spring</a>.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/joeffice-screenshot.png\" alt=\"Joeffice\" style=\"display:block; margin:0 auto;\" title=\"Joeffice\" /></p>\n\n\n<p><br /></p>\n\n\n<p><strong>Comment se positionne Joeffice, aujourd&#8217;hui et demain, par rapport à des «&#160;monstres&#160;» comme Google Docs, Microsoft Office ou LibreOffice&#160;?</strong></p>\n\n\n<p>Joeffice est moins complet que ces autres offices mais il a aussi des atouts que d&#8217;autres n&#8217;ont pas. Il est donc open source sous licence Apache. Il est développé entièrement en Java. Il peut s&#8217;installer  «&#160;offline&#160;» ou «&#160;online&#160;». Il est facilement portable. Il n&#8217;a pas une fenêtre par document mais un système d&#8217;onglet et d&#8217;amarrage ou les documents peuvent être l&#8217;un à côté de l&#8217;autre ou détachés en groupe. Les mises à jour et plugins, même si pour l&#8217;instant non utilisés, peuvent se faire en ligne. Toutes les librairies Java peuvent être facilement utilisées pour créer des actions spéciales, afin par exemple de remplir un document.</p>\n\n\n<p><strong>La légende dit que tu l&#8217;aurais codé tout seul en moins d&#8217;un mois&#160;? La légende dit vrai&#160;?</strong></p>\n\n\n<p>Je l&#8217;ai codé en 30 jours. Mais ce sont 30 jours non consécutifs. Pour chaque journée j&#8217;ai fait une vidéo que j&#8217;ai <a href=\"http://www.youtube.com/playlist?list=PLsezR6w8oWsJAKvFuv3JI34PLFFMIxLVA\">postée sur YouTube</a>. Il a fallu que je sois efficace sur le code et pragmatique sur certains choix.</p>\n\n\n<p><strong>En France, on vient d&#8217;introduire cette année l&#8217;informatique comme discipline à part entière au lycée (pour le moment en option de Terminale S). Bonne ou mauvaise idée&#160;?</strong></p>\n\n\n<p>Bien sûr, je trouve ça une bonne idée. Même en n&#8217;étant pas informaticien, les gens ont de plus en plus besoin de savoir développer. Par exemple un plug-in, une macro ou un site Web.</p>\n\n\n<p><strong>Joeffice se présente en version alpha. Que lui manque-t-il exactement pour une première version&#160;?</strong></p>\n\n\n<p>Je me sers de la librairie open source <a href=\"http://fr.wikipedia.org/wiki/Apache_POI\">Apache POI</a> pour lire les documents malheureusement il manque encore certaines parties. Chaque partie du logiciel doit être améliorée pour avoir quelque chose de plus utilisable pour l&#8217;utilisateur final. Cette version alpha est plus destinée aux développeurs et aux entreprises qui ont des besoins spécifiques. Le but pour la version 1.0 est de s&#8217;approcher de ce que peut faire Google Docs.</p>\n\n\n<p><strong>Et comment vois-tu le futur du projet&#160;? Un appel à lancer&#160;?</strong></p>\n\n\n<p>Tous les développeurs qui veulent participer à ce projet ou à une des librairies dont Joeffice se sert sont les bienvenus. Le code se trouve <a href=\"https://bitbucket.org/agoubard/joeffice/src\">sur BitBucket</a>.</p>          ','SHA1:32945b196714cd5c65400dd25bbb36bc814f21b8','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(9,'Un peu de libre dans la formation des professeurs des écoles','SHA1:ee5472c68b5dfe2f470265dd5f735f477fbf5795','http://www.framablog.org/index.php/post/2013/06/19/framadvd-ecole-formation-professeur','2013-06-19 14:33:00','\n\n      \n      	   <p>Ces derniers mois de nombreux signes ministériels encouragent l’utilisation et la réalisation de logiciels et de ressources éducatives libres.</p>\n\n\n<p>La <a href=\"http://circulaire.legifrance.gouv.fr/pdf/2012/09/cir_35837.pdf\">circulaire Ayrault</a> a montré la voie en septembre 2012.\nLe <a href=\"http://www.education.gouv.fr/cid72307/point-d-etape-de-l-entree-de-l-ecole-dans-l-ere-du-numerique.html\">10 juin dernier</a> , Vincent Peillon a notamment annoncé la réalisation de ressources vidéos disponibles en «&#160;OpenData&#160;» (Attendons de voir quelle sera exactement cette licence). On peut évidemment regretter que la priorité aux logiciels libres et aux formats ouverts ait été retoquée dans le projet de loi d’orientation et de programmation pour la refondation de l’école de la République. Le contexte reste toutefois globalement positif.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/cyrille/.DSCN8871_m.jpg\" alt=\"Des FramaDVD École\" style=\"display:block; margin:0 auto;\" title=\"Des FramaDVD École\" /></p>\n\n\n<p><br /></p>\n\n\n<p>Décréter l&#8217;utilisation de ressources libres c&#8217;est bien, mais, une décision ministérielle  ne s&#8217;applique pas comme cela, d&#8217;un claquement de doigts. Il faut l&#8217;accompagner par des actions de formation des enseignants.\nDes académies entières, comme celle de <a href=\"http://www.tice.ac-versailles.fr/logicielslibres/\">Versailles</a> et certains formateurs TICE, n&#8217;ont d&#8217;ailleurs pas attendu les récentes décisions politiques pour faire la promotion du libre dans leurs formations.</p>\n\n\n<p>Framasoft a choisi de participer modestement à cet élan.</p>\n\n\n<p>Ce matin, en Seine et Marne,  une formation autour de l&#8217;utilisation des TICE était proposée aux tous nouveaux professeurs des écoles stagiaires, ceux qui viennent juste d&#8217;avoir leur concours et qui auront la responsabilité d&#8217;une classe dès l&#8217;année prochaine.  Nous leur avons rapidement expliqué l&#8217;intérêt de ressources libres et un <a href=\"http://www.framadvd.org/\">FramaDVD École</a> ainsi qu&#8217;une plaquette présentant les principaux acteurs du libre pour l&#8217;école primaire leur ont été offerts.</p>\n\n\n<p><br /></p>\n\n\n<p><a href=\"http://www.framablog.org/public/cyrille/ressources_educatives_libres.png\" title=\"Plaquette de ressources éducatives libres pour l&#039;école primaire\"><img src=\"http://www.framablog.org/public/cyrille/.ressources_educatives_libres_m.jpg\" alt=\"Plaquette de ressources éducatives libres pour l&#039;école primaire\" style=\"display:block; margin:0 auto;\" title=\"Plaquette de ressources éducatives libres pour l&#039;école primaire\" /></a></p>\n\n\n<p><br /></p>\n\n<ul>\n<li>Source&#160;: <a href=\"http://www.framablog.org/public/cyrille/ressources_educatives_libres.svg\">format SVG</a></li>\n</ul>\n\n<p><em>Merci à M. Josselyn Bellicaud, Conseiller pédagogique TICE auprès de l&#8217;IENA et M. Jean-Charles POCHET, Inspecteur de l&#8217;Éducation Nationale TICE qui nous ont permis de réaliser ce temps d&#8217;information.</em></p>          ','SHA1:c75592066e903839e4f2e6a6f112c2d7ad29bc59','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','clargillier'),(10,'PRISM NSA : pourquoi nous devrions nous sentir concernés, par Doctorow','SHA1:c795424dd4fe98c47656337081a67e7fcd997a87','http://www.framablog.org/index.php/post/2013/06/19/prism-nsa-doctorow','2013-06-19 10:19:00','\n\n      \n      	   <p>Vous devriez vous sentir concerné par votre vie privée car&#8230;</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/digitale-gesellschaft_cc-bysa.jpg\" alt=\"Digitale Gesellschaft - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Digitale Gesellschaft - CC by-sa\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>PRISM de la NSA&#160;: pourquoi nous devrions nous sentir concernés</h3>\n\n\n<p><strong><a href=\"http://www.guardian.co.uk/technology/blog/2013/jun/14/nsa-prism\">The NSA&#8217;s Prism: why we should care</a></strong></p>\n\n\n<p><em>Cory Doctorow - 14 juin - The Guardian</em><br />\n<em>(Traduction&#160;: KaTeznik, fany, b:v, genma, Mowee, Adcaelo, Metal-Mighty, letchesco, Asta, Gatitac, Yaf, tcit + anonymes)</em></p>\n\n\n<p>Les politiciens nous disent que ceux qui n&#8217;ont rien à se reprocher n&#8217;ont rien à craindre des écoutes à leur insu. Pourtant, leurs décisions menacent la vie privée et bien au-delà..</p>\n\n\n<p>Certains se demandent pourquoi faire tant d&#8217;histoires à propos des révélations sur PRISM et des autres formes de surveillance de masse de la NSA. Quand <a href=\"http://fr.wikipedia.org/wiki/William_Hague\">William Hague</a> nous dit que les innocents n&#8217;ont rien à craindre de ces écoutes, on est en droit de se poser des questions&#160;: à partir de quand la surveillance peut-elle nuire&#160;? que peut-il se produire lorsque l&#8217;on est épié&#160;? Voici quelques raisons pour lesquelles vous devriez vous sentir concernés par votre vie privée, sa divulgation et la surveillance.</p>\n\n\n<p>Nous ne sommes pas forcément sensibles aux problèmes de vie privée parce que les conséquences des révélations sur la vie privée sont éloignées dans le temps et l&#8217;espace des révélations elles-mêmes. C&#8217;est comme essayer de devenir bon au cricket en balançant la batte et en fermant les yeux avant de voir où part la balle, pour que l&#8217;on vous raconte, des mois plus tard, dans un autre lieu, où la balle a finalement atterri. Nous appréhendons mal ces problématiques&#160;: la plupart des révélations sur notre vie privée sont inoffensives, mais certaines d&#8217;entre elles provoquent des dégâts colossaux et quand cela se produit, c&#8217;est tellement éloigné dans le temps que nous ne pouvons en tirer aucune leçon véritable.</p>\n\n\n<p>Vous devriez vous sentir concerné par votre vie privée car la vie privée n&#8217;est pas secrète. Je sais ce que vous faites aux toilettes, mais pour autant cela ne veut pas dire que vous ne vouliez pas fermer la porte quand vous êtes sur le trône.</p>\n\n\n<p>Vous devriez vous sentir concerné par votre vie privée car si les données disent que vous faites quelque chose de mal, celui qui les analysera interprétera tout le reste à la lumière de cette information. Le documentaire <a href=\"http://www.journey.webbler.co.uk/?lid=65226&amp;bid=2\">Naked Citizens</a> <em>(NdT&#160;: Citoyens nus)</em> montre ainsi plusieurs cas effrayants de policiers alertés par des ordinateurs que quelqu&#8217;un pouvait préparer des actes délictueux, et qui ont alors interprété tout ce qu&#8217;ils apprenaient par la suite comme des preuves de délit.</p>\n\n\n<p>Par exemple, quand un programmeur du nom de <a href=\"http://www.guardian.co.uk/world/2005/sep/22/terrorism.july7\">David Mery</a> est entré dans le métro avec une veste alors qu&#8217;il faisait chaud, un algorithme de vidéosurveillance l&#8217;a signalé à un opérateur humain comme suspect. Quand Mery a laissé passer un train sans embarquer, l&#8217;opérateur a décidé que son comportement était alarmant. Il a été arrêté, a fait l&#8217;objet d&#8217;une perquisition et on lui a demandé de justifier chaque bout de papier de son appartement. Un gribouillage de traits aléatoires a été interprété comme un plan de la station de métro. Même s&#8217;il n&#8217;a jamais été reconnu coupable, Mery est toujours sur la liste des terroristes potentiels huit ans après et ne peut obtenir de visa pour quitter son pays. Une fois qu&#8217;un ordinateur signale un suspect, tout le reste de sa vie devient louche et presque un faisceau d&#8217;indices.</p>\n\n\n<p>Vous devriez vous sentir concerné par la chape de plomb de la surveillance de masse car dans sa recherche d&#8217;aiguilles dans les bottes de foin, la police bénéficie alors de plus grosses bottes et d&#8217;aiguilles qui restent proportionnellement moins nombreuses. La Commission d&#8217;enquête sur le 11 septembre a relevé que les services secrets des États-Unis avaient toutes les informations pour prédire les attaques, mais que celles-ci ont été perdues dans tout le bruit dû à la trop grande quantité de données collectées. Depuis, la collecte excessive est passée à la vitesse supérieure&#160;: les bottes de foin sont énormes, mais elles contiennent toujours le même nombre d&#8217;aiguilles. Je veux que mon ciel soit sûr et je souhaite, tout comme vous, que nos services secrets fassent bien leur travail, mais pas en aspirant toutes les données dans l&#8217;espoir qu&#8217;elles leur soient un jour utiles.</p>\n\n\n<p>Vous devriez vous sentir concerné par la surveillance car vous connaissez des gens qui peuvent être exposés&#160;: des gays qui sont au placard, des malades en phase terminale, des personnes qui sont liées à une autre qui aurait notoirement commis un crime horrible. Il peut s&#8217;agir de vos amis, de vos voisins, peut-être même de vos enfants&#160;: ils méritent autant que vous une vie sans tracas et sans cadavre dans le placard.</p>\n\n\n<p>Vous devriez vous sentir concerné par la surveillance parce qu&#8217;une fois que le système de surveillance est intégré au réseau et aux terminaux téléphoniques, des flics corrompus ou mal intentionnés peuvent l&#8217;utiliser contre vous. En Grèce, la porte dérobée utilisée par la police pour accéder aux communications de l&#8217;opérateur national a été détournée pour mettre sur écoute le Premier ministre durant la candidature aux Jeux Olympiques de 2005. Des services secrets chinois ont hacké le système d&#8217;interception légal de Google pour pirater Gmail et découvrir avec qui les dissidents communiquaient. Nos systèmes de communication sont plus sécurisés lorsqu&#8217;ils sont conçus pour empêcher les tierces parties d&#8217;y accéder – et l&#8217;ajout d&#8217;une seule porte dérobée à ces systèmes réduit à néant toutes les mesures de sécurité. Vous ne pouvez pas être <em>à moitié</em> enceinte, de même les ordinateurs dans votre poche, au bureau ou chez vous ne peuvent être <em>à moitié</em> sécurisés. Dès lors que ces appareils sont conçus pour la surveillance, n&#8217;importe qui peut soudoyer une autorité policière ou se faire passer pour telle et accéder aux données.</p>\n\n\n<p>Revenons à M. Hague (Ministre des Affaires Étrangères britannique)&#160;: si les innocents n&#8217;ont rien à craindre de l&#8217;espionnage de leur vie privée, alors pourquoi son propre gouvernement exige-t-il la mise en place d&#8217;un système sans précédent de tribunaux secrets, où l&#8217;on pourrait entendre les preuves de l&#8217;implication des services secrets britanniques dans des enlèvements illégaux et des actes de torture&#160;? Apparemment, la confidentialité est absolument essentielle pour les puissants mais sans intérêt pour le reste d&#8217;entre nous.</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/digitalegesellschaft/9076965410/\">Digitale Gesellschaft</a> (Creative Commons By-Sa)</em></p>          ','SHA1:166eec0f87e2368552ebcb71d6f84af4fcd58a00','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(11,'Les pages man de MySQL ne sont plus libres (bye bye GPL)','SHA1:2f73aef3896eb4e030a841f904a4a2ebacd0e815','http://www.framablog.org/index.php/post/2013/06/19/mysql-man-pages-no-libre','2013-06-19 08:57:00','\n\n      \n      	   <p><strong>Edit&#160;: en fait <a href=\"http://bugs.mysql.com/bug.php?id=69512\">c&#8217;était un bug</a> (mais un bug troublant quand même). Fausse alerte donc, le contenu du billet ci-dessous n&#8217;est plus pertinent.</strong></p>\n\n\n<p>Quand on saute d&#8217;une version 5.5.30 à la 5.5.31, il ne se passe généralement pas grand chose mis à part quelques bugs fixés.</p>\n\n\n<p>Sauf qu&#8217;ici on a décidé <em>en catimini</em> de changer la licence des <a href=\"http://fr.wikipedia.org/wiki/Man_(Unix)\">pages man</a> de <a href=\"http://fr.wikipedia.org/wiki/MySQL\">MySQL</a> et ce n&#8217;est pas très <em>fair-play</em> de la part de son propriétaire <a href=\"http://fr.wikipedia.org/wiki/Oracle_Corporation\">Oracle</a>.</p>\n\n\n<p>Heureusement qu&#8217;on a le fork <a href=\"http://fr.wikipedia.org/wiki/MariaDB\">MariaDB</a>, d&#8217;où est d&#8217;ailleurs issue cette traduction.</p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/mysql-logo.jpg\" alt=\"MySQL Logo\" style=\"display:block; margin:0 auto;\" title=\"MySQL Logo\" /></p>\n\n\n<h3>Les pages man de MySQL changent discrètement de licence pour ne plus être sous GPL</h3>\n\n\n<p><strong><a href=\"https://blog.mariadb.org/mysql-man-pages-silently-relicensed-away-from-gpl/\">MySQL man pages silently relicensed away from GPL</a></strong></p>\n\n\n<p><em>Colin Charles - 18 juin 2013 - MariaDB Blog</em><br />\n<em>(Traduction&#160;: Lgodard, ehsavoie, Asta, rou, BastienLQ)</em></p>\n\n\n<p>On nous a récemment rapporté que la licence des pages man de MySQL a été modifiée. Le changement a été fait <em>en douce</em> lors du passage de MySQL 5.5.30 à MySQL 5.5.31. Cela affecte toutes les pages du répertoire man/ du code source.</p>\n\n\n<p>On peut voir que ces changements sont intervenus durant cette courte période (5.5.30-&gt;5.5.31). Les anciennes pages du manuel étaient publiées sous la licence suivante&#160;:</p>\n\n\n<blockquote><p>Cette documentation est un logiciel libre&#160;: vous pouvez la redistribuer et/ou la modifier uniquement sous les termes de la licence GNU GPLv2 telle que publiée par la Free Software Foundation.</p></blockquote>\n\n\n<p>Les nouvelles pages man (5.5.31 et ultérieures &#8212; toujours en vigueur pour 5.5.32) sont sous la licence suivante&#160;:</p>\n\n\n<blockquote><p>Ce logiciel et la documentation rattachée sont soumis à un accord de licence contenant des restrictions sur leur utilisation et leur divulgation et sont protégés par les lois sur la propriété intellectuelle. Sauf autorisation expresse dans cet accord de licence ou par la loi, vous ne pouvez pas utiliser, copier, reproduire, traduire, diffuser, modifier, changer de licence, transmettre, distribuer, exposer, publier ou montrer une quelconque partie, quelque soit sa forme ou les moyens utilisés. Il est interdit de faire de la rétroingénierie, désassembler ou décompiler ce logiciel, sauf si la loi le requiert pour l&#8217;interopérabilité&#8230;</p></blockquote>\n\n\n<p>Ce n&#8217;est clairement pas une marque d&#8217;affection pour MySQL de la part d&#8217;Oracle. La nouvelle licence est également devenue bien plus longue (en clair ce n&#8217;est pas sous licence GPL). Tandis que ce qui suit a été récupéré de l&#8217;outil resolveip, le copyright est le même pour toutes les pages man. Vous pouvez comparer <a href=\"http://pastebin.com/gnJg1hv4\">la page man de la version 5.5.30</a> et <a href=\"http://pastebin.com/FRbHRdAN\">celle de la version 5.5.31</a>.</p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/.comparison1_m.jpg\" alt=\"License man page MySQL\" style=\"display:block; margin:0 auto;\" title=\"License man page MySQL\" /></p>          ','SHA1:d41e580c0e0b0195a25b9b65dc8a651516dcdda7','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(12,'Prothèse de main : de dix mille à cent cinquante dollars grâce à l\'impression 3D','SHA1:849ddc13c800d58b0f5f5c427df132dac87b3c3a','http://www.framablog.org/index.php/post/2013/06/19/impression-3d-prothese-libre','2013-06-19 07:35:00','\n\n      \n      	   <p>Quand l&#8217;association de l&#8217;<a href=\"http://fr.wikipedia.org/wiki/Impression_tridimensionnelle\">impression 3D</a> et de <em>l&#8217;esprit Libre</em> donnent des choses extraordinaires&#8230;</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/robohand-2.png\" alt=\"Robohand - MakerBot\" style=\"display:block; margin:0 auto;\" title=\"Robohand - MakerBot\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Des prothèses de main <em>open source</em> peuvent être imprimées en 3D pour 150$</h3>\n\n\n<p><strong><a href=\"http://www.psfk.com/2013/05/robohand-3d-printed-prosthetic.html\">Open Source Prosthetic Hand Can Be 3D Printed For $150</a></strong></p>\n\n\n<p><em>John Pugh - 26 mai 2013 - psfk.com</em><br />\n<em>(Traduction&#160;: Goofy, Calou, nicolas, MatElGran, GPif, Asta, Pascal, audionuma)</em></p>\n\n\n<p><a href=\"http://www.makerbot.com/blog/2013/05/07/robohand/\">Robohand</a> est une main mécanique à bas coût qui peut être fabriquée avec une imprimante MakerBot3D.</p>\n\n\n<p>Pour les patients souffrant d&#8217;une blessure traumatique ayant entraîné la perte d&#8217;un membre, ou les enfants nés avec un handicap tel que le syndrome des brides amniotiques (dont la conséquence  est souvent que l&#8217;enfant naît avec un ou plusieurs doigts manquants), une nouvelle prothèse a le potentiel de changer littéralement leur vie quotidienne. Cependant, les technologies actuelles de prothèse sont très compliquées et onéreuses, pouvant coûter jusqu&#8217;à 10&#160;000 $ pour une prothèse de doigt basique. Imaginez qu&#8217;au lieu d&#8217;avoir recours à des produits complexes et coûteux, nous puissions simplement imprimer une prothèse complète confortablement à la maison&#160;!</p>\n\n\n<p>Robohand est une main mécanique qui peut être imprimée en 3D avec une imprimante <a href=\"http://www.makerbot.com/\">MakerBot</a>. À l&#8217;origine de l&#8217;idée, Richard Van As, un menuisier sud-africain qui a perdu quatre doigts lors d&#8217;un accident en 2011. Suite à cet accident, il commença à travailler avec le designer de mains mécaniques Ivan Owen (Seattle) pour concevoir un modèle de prothèse peu coûteux et capable de fonctionner aussi convenablement qu&#8217;une main ou que de doigts réels. Se basant sur leur concept, MakerBot a fait don d&#8217;une imprimante 3D <a href=\"https://store.makerbot.com/replicator2.html\">Replicator 2 Desktop</a><sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/19/impression-3d-prothese-libre#pnote-1653-1\" id=\"rev-pnote-1653-1\">1</a>]</sup> à leur équipe, accélérant ainsi la création de prototypes fonctionnels, tout en réduisant les coûts de production.</p>\n\n\n<p><br /></p>\n\n<iframe width=\"640\" height=\"360\" src=\"http://www.youtube.com/embed/WT3772yhr0o\" frameborder=\"0\" allowfullscreen></iframe>\n\n\n\n<p><br /></p>\n\n\n<p>Au total, le coût des pièces de la Robohand fabriquées avec l&#8217;imprimante MakerBot3D s&#8217;élève seulement à 2,50$ de matériel et on obtient une prothèse fonctionnelle complète, incluant le matériel non imprimable, pour environ 150$. En plus d&#8217;une économie importante, Van As a compris à quel point cette méthode lui permet d&#8217;affiner rapidement sa conception en fonction des besoins spécifiques d&#8217;un individu. Suite à la diffusion de son histoire, il a reçu des courriels et des messages sur Facebook de parents d&#8217;enfants atteints du syndrome des brides amniotiques voulant explorer le potentiel d&#8217;une conception par impression 3D. Cette technologie est d&#8217;autant plus décisive pour les enfants que leur croissance est rapide, ils nécessitent de multiples prothèses au cours de leur croissance. À la suite de ces conversations sur le réseau social, au moins trois enfants ont été sélectionnés et ont reçu leurs nouvelles mains.</p>\n\n\n<p>Le projet est entièrement <em>open source</em>, ce qui signifie que n&#8217;importe qui ayant accès à une imprimante 3D peut <a href=\"http://www.thingiverse.com/thing:44150\">télécharger le fichier de conception</a> gratuitement et créer sa propre main robotique. Alors que ce projet est toujours en cours de finalisation, les équipements d&#8217;impression 3D montrent un vaste potentiel pour notre santé. En facilitant l&#8217;accès à tous et en réduisant fortement le coût de production, ces équipements vont permettre à des patients qui s&#8217;en sortent difficilement, du fait d&#8217;un manque d&#8217;accès aux prothèses, de pouvoir vivre un vie normale.</p>\n<div class=\"footnotes\"><h4>Notes</h4>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/19/impression-3d-prothese-libre#rev-pnote-1653-1\" id=\"pnote-1653-1\">1</a>] À propos de cette nouvelle imprimante, <em>et sans vouloir troller</em>, on pourra lire&#160;: <a href=\"http://www.framablog.org/index.php/post/2012/09/24/makerbot-vs-materiel-libre\">Polémique&#160;: la nouvelle imprimante 3D de MakerBot a-t-elle trahi l&#8217;open hardware&#160;?</a></p></div>\n          ','SHA1:a78991076a8748e1dcf43eec8a2a90d441c78da8','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(13,'Le discours de Fleur Pellerin dans les nouveaux locaux Mozilla à Paris','SHA1:d713f15c060cae426567f7dd2a942aac68e9695e','http://www.framablog.org/index.php/post/2013/06/15/fleur-pellerin-logiciel-libre-mozilla','2013-06-15 13:38:00','\n\n      \n      	   <p>Vibrante allocution en faveur du logiciel libre, la ministre <a href=\"http://fr.wikipedia.org/wiki/Fleur_Pellerin\">Fleur Pellerin</a> a prononcé un discours remarqué lors de l’inauguration des nouveaux locaux Mozilla le 13 juin dernier à Paris.</p>\n<p><em>Ira-t-on plus loin que ses belles paroles&#160;? Seront-elles véritablement suivies de faits et d’effets&#160;?</em></p>\n<p>Une vidéo tournée par <a href=\"http://www.dicosmo.org/\">Roberto Di Cosmo</a>. et éditée par <a href=\"http://fermigier.com/\">Stéfane Fermigier</a></p>\n<h4>Transcript</h4>\n<p><em>(Merci à Goofy, aKa, Z, Asta, Peekmo)</em></p>\n<p>Madame la présidente, chère <a href=\"http://fr.wikipedia.org/wiki/Mitchell_Baker\">Mitchell</a>, madame la vice-présidente, chère <a href=\"http://www.linkedin.com/in/debbiecohen\">Debbie</a>,</p>\n<p>Mesdames et messieurs, il y a vingt ans <a href=\"http://fr.wikipedia.org/wiki/Tim_Berners-Lee\">un grand chercheur</a> a, je le cite, «&#160;pris le principe d’hypertexte et l’a relié au principe du TCP et du DNS, et alors <em>boom</em>, ce fut le World Wide Web.&#160;»</p>\n<p>Et en 1993, donc, le <a href=\"http://fr.wikipedia.org/wiki/Organisation_europ%C3%A9enne_pour_la_recherche_nucl%C3%A9aire\">CERN</a>, cet organisme de recherche européen qui avait inventé le Web a décidé de donner cette invention au monde, en la distribuant sous ce qu’on n’appelait pas encore une «&#160;licence libre&#160;». Ce choix, anodin en apparence, a changé la face du monde.</p>\n<p>Il y a 10 ans, la <a href=\"http://fr.wikipedia.org/wiki/Mozilla_Foundation\">fondation Mozilla</a> naissait et quelques mois plus tard, cher <a href=\"http://fr.wikipedia.org/wiki/Tristan_Nitot\">Tristan Nitot</a>, vous fondiez sa branche européenne. J’imagine combien cela doit vous faire plaisir d’être ici 10 ans après, dans ce magnifique hôtel particulier du XVIII<sup>e</sup> siècle, ancienne demeure de l’ambassadeur d’Autriche, m’avez-vous dit tout à l’heure. Mozilla Firefox, construit sur <a href=\"http://fr.wikipedia.org/wiki/Netscape_Navigator\">l’ancien Netscape</a>, et œuvrant inlassablement pour promouvoir les standards du Web, a aussi changé le Web et par là la manière dont nous nous informons et dont nous innovons.</p>\n<p>Je suis donc très fière d’inaugurer ce soir les nouveaux bureaux de la fondation Mozilla à Paris. Pourquoi être venue inaugurer ces nouveaux locaux&#160;?</p>\n<p>D’abord en raison des valeurs de la fondation Mozilla, et du logiciel libre. Ces valeurs, ce sont l’accès à la connaissance pour tous, la confiance ou encore l’amplification des aspects d’intérêt publics d’internet. Ce sont aussi les valeurs sociales qui portent un modèle de société vertueux, ouvert, participatif, où toute donnée est d’abord considérée comme un bien accessible au plus grand nombre, et une source de connaissances que chacun peut utiliser, améliorer, partager. Le logiciel libre, les formats ouverts, c’est enfin une communauté de personnes qui constitue un véritable patrimoine de connaissances qu’est le code, sans cesse inachevé, toujours à enrichir. Au-delà des innovations et des technologies permises par le Web, des acteurs comme <a href=\"http://fr.wikipedia.org/wiki/Wikimedia\">Wikimedia</a> ou la fondation Mozilla ont démontré que l’innovation et le progrès peuvent aussi passer par le partage, l’absence de propriété. C’est une victoire essentielle sur les esprits qui nous permet aujourd’hui d’avancer dans d’autres domaines&#160;: je pense à l’<a href=\"http://fr.wikipedia.org/wiki/Innovation_ouverte\">open innovation</a> ou à l’<a href=\"http://fr.wikipedia.org/wiki/Donn%C3%A9es_ouvertes\">open data</a>. Je sais que Mozilla n’est pas une formation politique, mais toutes ces valeurs résonnent particulièrement doux à une ministre de gauche comme moi, et je pense que le monde politique a des choses à apprendre de cette réussite.</p>\n<p>Par ailleurs le logiciel libre est aussi un atout décisif pour notre économie. À plus d’un titre il permet d’abord de lutter contre les phénomènes de dépendance technologique envers tous ces acteurs qui sont propriétaires de nos outils informatiques quotidiens, et est donc un véritable garant de la souveraineté numérique. De plus comme on le voit aujourd’hui, et contrairement à certaines idées reçues, le libre et l’<em>open source</em> sont créateurs d’emploi. Des modèles d’affaire originaux ont été créés et c’est un facteur important de productivité et de compétitivité pour les entreprises et les administrations. En effet elles peuvent ainsi mieux maîtriser leurs patrimoines respectifs et concentrer leurs efforts sur ce qui représente pour elles la valeur ajoutée. Enfin le logiciel libre remet en cause les rentes de situation, peu favorables à l’innovation, et par là-même aide à l’émergence de nouveaux champions économiques. L’émergence de Firefox et des navigateurs est emblématique de cette capacité.</p>\n<p>La France est souvent citée comme un des pays les plus actifs au monde dans le domaine du logiciel libre. La croissance soutenue dans ce secteur le confirme. Les chiffres sont éloquents&#160;: ce marché représentait en 2011 plus de 2 milliards d’euros, soit plus de 6% de la demande de logiciels et de services informatiques. Par ailleurs, il y a là un formidable levier d’emplois, environ 10&nbsp;000 supplémentaires dans les 3 ans à venir, si les estimations de croissance du marché sont confirmées. Bref, ce sont des enjeux extrêmement importants. La décision de Mozilla, un acteur mondial de référence sur le logiciel libre, de s’implanter dans ces locaux, confirme l’attractivité de Paris comme place incontournable du numérique. Elle confirme l’excellence des formations françaises dans le domaine informatique et je suis certaine que les développeurs du monde entier seront attirés par les conditions d’accueil ici, dans ces magnifiques locaux.</p>\n<p>Mon objectif est bien sûr de renforcer encore ces atouts avec notamment le projet de <a href=\"http://www.redressement-productif.gouv.fr/quartiers-numeriques\">quartiers numériques</a> que nous allons créer dans une quinzaine de villes. Enfin, nous avons en France une communauté parmi les plus dynamiques dans le monde pour la conception et l’utilisation des logiciels libres, un atout à évidemment ne pas négliger. Avec les <a href=\"http://www.redressement-productif.gouv.fr/assises-entrepreneuriat\">Assises de l’Entreprenariat</a>, nous avons souhaité aller encore plus loin pour renforcer notre attractivité en mobilisant notamment toutes les compétences de France et d’ailleurs. C’est pour accompagner ce mouvement que le gouvernement travaille ardemment à la création d’un <em>visa entrepreneur</em> et d’un <em>visa talent</em>, car il est impératif d’attirer les talents créateurs du monde entier en leur offrant des conditions d’installation très rapides et simplifiées. Je dois aussi rappeler que le gouvernement prête une attention toute particulière à l’utilisation des logiciels libres. Par notre action nous visons à la renforcer. Le recours au logiciel libre est un levier d’action pour moderniser et rationaliser l’action publique.</p>\n<p>Le Libre n’est pas toujours la bonne ou la seule solution mais la <a href=\"http://circulaire.legifrance.gouv.fr/pdf/2012/09/cir_35837.pdf\">circulaire</a> du Premier Ministre de septembre 2012 concernant l’utilisation des logiciels libres dans l’administration fixe une ligne claire sur les cas où ces types de logiciels doivent être privilégiés. Les atouts du logiciel libre sont notamment, je cite, «&#160;un moindre coût, une souplesse d’utilisation, et un levier de discussion avec les éditeurs&#160;». Il s’agit là d’une avancée majeure pour le logiciel libre dans les systèmes d’information de l’État, qui permet d’engager de véritables politiques publiques en matière de logiciel libre et d’<em>open source</em>.</p>\n<p>Pour conclure, je voudrais juste insister sur un point important que j’ai déjà évoqué mais que je tiens à marteler&#160;: l’<em>open source </em>est avant tout un vecteur d’innovation et de changement, un véritable gisement de productivité et de compétitivité pour les entreprises, et garantit la pérennité et l’indépendance de l’État. C’est pour cela que je souhaite que la France continue de jouer un rôle moteur dans le développement de ce secteur, et je suis sûre que la présence de Mozilla à Paris nous y aidera. J’ai parlé de 1993, de 2003, quoi de neuf en 2013&#160;? Cette année Mozilla lance son système d’exploitation pour mobiles et tablettes, <a href=\"http://fr.wikipedia.org/wiki/Firefox_OS\">Firefox OS</a>, sur le même constat&#160;: promouvoir les formats ouverts et empêcher les systèmes fermés de contrôler notre environnement informatique. C’est une ambition un peu folle, mais probablement pas plus folle que de s’attaquer au marché des navigateurs qui était contrôlé à 95% par un seul acteur. Je vous souhaite donc le même succès que Firefox, et comme il sera en partie développé ici, je n’ai pas de doute sur la réussite de ce projet. Merci à tous.</p>          ','SHA1:652d1cf139d88aca1ad2d5eac415978207bac2ae','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(14,'Geektionnerd : Première coupure Hadopi','SHA1:7b7800ff2c4d02f58a468d83ec95ed93615e6aca','http://www.framablog.org/index.php/post/2013/06/14/geektionnerd-hadopi-1ere-coupure','2013-06-14 15:08:00','\n\n      \n      	   <p><img src=\"http://www.framablog.org/public/_img/geektionnerd/geektionnerd_150-1_simon-gee-giraudot_cc-by-sa.jpg\" alt=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/geektionnerd/geektionnerd_150-2_simon-gee-giraudot_cc-by-sa.jpg\" alt=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Geektionnerd - Simon Gee Giraudot - CC by-sa\" /></p>\n\n\n<p>Sources&#160;:</p>\n\n<ul>\n<li><a href=\"http://www.pcinpact.com/news/80487-hadopi-600-d-amende-et-quinze-jours-suspension-pour-abonne.htm\">Hadopi&#160;: 600&#160;€ d’amende et quinze jours de suspension pour un abonné (PC Inpact)</a></li>\n<li><a href=\"http://www.klaire.fr/2013/06/10/ivre-hadopi-adopte-le-label-pur-foutage-de-gueule/\">Ivre, Hadopi adopte le label PUR foutage de gueule (Klaire fait grr)</a></li>\n</ul>\n\n<p><em>Crédit&#160;: <a href=\"http://geektionnerd.net/\">Simon Gee Giraudot</a> (Creative Commons By-Sa)</em></p>          ','SHA1:5a600f096bea07d48325ea78df6a43654f1ebb93','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(15,'Stop Watching Us, une pétition soutenue par Mozilla suite à l\'affaire Prism','SHA1:9701089c360686777f182fed6cc02d19575a9b22','http://www.framablog.org/index.php/post/2013/06/12/stop-watching-us-mozilla','2013-06-12 09:31:00','\n\n      \n      	   <p>Mozilla a <a href=\"https://blog.mozilla.org/blog/2013/06/11/stopwatching-us-mozilla-launches-massive-campaign-on-digital-surveillance/\">lancé</a> hier la pétition <strong><a href=\"http://stopwatching.us/\">Stop Watching Us</a></strong> suite à la retentissante affaire de la collecte de données privées d&#8217;internautes par le renseignement américain.</p>\n\n\n<p>Nous en avons traduit la lettre adressée au Congrès qui apparaît en accueil de l&#8217;initiative.</p>\n\n\n<p>Il va sans dire que cela nous concerne tous et pas seulement les Américains (à fortiori si vous avez déjà laissé des traces chez Google, Facebook, Twitter, Apple, Amazon, etc.)</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/digital-cat_cc-by.jpg\" alt=\"Digital cat - CC by\" style=\"display:block; margin:0 auto;\" title=\"Digital cat - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Arrêtez de nous regarder</h3>\n\n\n<p><strong><a href=\"https://optin.stopwatching.us/\">Stop Watching Us</a></strong></p>\n\n\n<p><em>Mozilla - 11 juin 2013</em><br />\n<em>(Traduction&#160;: Mowee, Cyb, MFolschette + anonymes)</em></p>\n\n\n<p><strong>Les révélations sur l&#8217;appareil de surveillance de la National Security Agency, si avérées, représentent un abus stupéfiant de nos droits fondamentaux. Nous réclamons que le Congrès américain révèle l&#8217;étendue des programmes d&#8217;espionnage de la NSA.</strong></p>\n\n\n<p>Chers membres du Congrès,</p>\n\n\n<p>Nous vous écrivons pour exprimer notre préoccupation à propos des rapports récemment publiés dans le Guardian et le Washington Post, et reconnus par l&#8217;administration Obama, qui révèlent l&#8217;espionnage secret par la NSA d&#8217;enregistrements téléphoniques et de l&#8217;activité sur Internet du peuple des États-Unis.</p>\n\n\n<p>Le Washington Post et le Guardian ont récemment publié des rapports basés sur les informations fournies par un agent du renseignement, montrant comment la NSA et le FBI peuvent aisément accéder aux données collectées par neuf des principales sociétés américaines de l&#8217;Internet et partager ces données avec les gouvernements étrangers. Le rapport mentionne l&#8217;extraction par le gouvernement américain de données audio, vidéo, de photos, de courriels, de documents et d&#8217;historiques de connexion permettant aux analystes de suivre les mouvements et contacts des personnes au cours du temps. Il en résulte que les contenus des communications des personnes aussi bien résidant aux États-Unis qu&#8217;étrangères peuvent être parcourus sans aucune suspicion de crime ou d&#8217;association avec une organisation terroriste.</p>\n\n\n<p>Ces rapports, également publiés par le Guardian et avérés par l&#8217;administration, révèlent que la NSA tire abusivement profit d&#8217;une section controversée du Patriot Act pour collecter les enregistrements d&#8217;appels de millions d’utilisateurs de Verizon. Les données collectées par la NSA incluent chaque appel, l&#8217;heure à laquelle il a été effectué, sa durée, et d&#8217;autres «&#160;informations d&#8217;identification&#160;» pour ces millions d’utilisateurs de Verizon, et ce pour l&#8217;ensemble des appels internes aux États-Unis, que les utilisateurs soient ou non suspectés de crime. Le Wall Street Journal rapporte que certains des principaux fournisseurs d&#8217;accès à Internet comme AT&amp;T ou Sprint, sont sujets à de tels agissements secrets.</p>\n\n\n<p>Ce type de collecte généralisée de données par le gouvernement est en contradiction avec le fondement des valeurs américaines de liberté et de vie privée. Cette surveillance massive viole le Premier et le Quatrième Amendement de la Constitution des États-Unis, laquelle protège le droit de parole des citoyens et leur anonymat et prémunit contre les perquisitions et saisies afin de protéger leur droit à la vie privée.</p>\n\n\n<p>Nous appelons le Congrès à prendre des mesures immédiates pour mettre fin à cette surveillance et fournir publiquement toutes les données collectées par le programme de la NSA et du FBI. Nous appelons donc le Congrès à immédiatement et publiquement&#160;:</p>\n<ol>\n<li>Réformer la <a href=\"https://en.wikipedia.org/wiki/Section_summary_of_the_Patriot_Act,_Title_II#Section_205:_Employment_of_translators_by_the_FBI\">section 215</a> du <a href=\"http://fr.wikipedia.org/wiki/Patriot_Act\">Patriot Act</a>, le privilège du secret d&#8217;état ainsi que les amendements de la loi <a href=\"http://fr.wikipedia.org/wiki/Foreign_Intelligence_Surveillance_Act\">FISA</a>. L&#8217;objectif est de bien faire comprendre que la surveillance de l&#8217;activité sur Internet ainsi que l&#8217;enregistrement de toutes les conversations téléphoniques de toute personne résidant au sein des États-Unis sont interdits par la loi et constituent des violations pouvant être jugées par des autorités compétentes tel qu&#8217;un tribunal public.</li>\n<li>Mettre en place une commission spéciale qui, après investigation, publiera de façon publique l&#8217;étendue de cet espionnage domestique. Cette commission devrait de plus recommander des réformes juridiques et règlementaires spécifiques afin de mettre un terme à cette surveillance inconstitutionnelle.</li>\n<li>Demander des comptes aux principaux fonctionnaires responsables de cette surveillance.</li>\n</ol>\n\n<p>Je vous remercie de l&#8217;attention que vous porterez à ce sujet.</p>\n\n\n<p>Cordialement,</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/14646075@N03/3048801532/\">Digital Cat</a> (Creative Commons By)</em></p>          ','SHA1:cd32c6e524258682f68513d78622e2566cec1815','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(16,'Comment aider le logiciel libre quand on ne sait pas coder','SHA1:7a24fd808c1041f05d32240543273f9d32acf3ea','http://www.framablog.org/index.php/post/2013/06/12/logiciel-libre-aider-sans-programmer','2013-06-12 07:27:00','\n\n      \n      	   <p>Ce n&#8217;est pas Framasoft qui vous dira le contraire, on peut contribuer au logiciel libre et faire ainsi partie de sa communauté sans être nécessairement un développeur de logiciel libre.</p>\n\n\n<p>Rédiger de la documentation, signaler un bug, traduire, donner, etc. il y a plein de manières de participer, à commencer par les utiliser et le faire savoir.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/gozamos_cc-by-sa.jpg\" alt=\"Gozamos - CC by-sa\" style=\"display:block; margin:0 auto;\" title=\"Gozamos - CC by-sa\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Comment les non-programmeurs peuvent contribuer aux projets open source</h3>\n\n\n<p><strong><a href=\"http://duncanmckean.com/how-non-programmers-can-contribute-to-open-source-projects/\">How non-programmers can contribute to open source projects</a></strong></p>\n\n\n<p><em>Duncan McKean - 4 juin 2013 - Blog personnel</em><br />\n<em>(Traduction&#160;: «&#160;Anonymes&#160;», nos excuses car un bug Framapad empêche de citer tous les traducteurs/ices que nous remercions au passage)</em></p>\n\n\n<p>Beaucoup de gens intéressés par l&#8217;idée d&#8217;apporter leur aide à des projets open source mais n&#8217;ayant absolument aucune compétence en programmation m&#8217;ont demandé ce qu&#8217;ils pouvaient faire. Eh bien, voici quelques moyens pour ces non-programmeurs de contribuer à de tels projets.</p>\n\n\n<p><em>Il est important de noter qu&#8217;il est bon de contribuer aux projets des logiciels que vous utilisez. Ainsi, vous pourrez vous-même bénéficier de vos contributions.</em></p>\n\n\n<h4>Utilisez le logiciel</h4>\n\n\n<p>Le meilleur moyen de contribuer à des projets open source est d&#8217;utiliser les produits eux-mêmes. Écrivez votre livre avec <a href=\"https://www.libreoffice.org/features/writer/\">Libre Office Writer</a>. Dessinez vos images avec <a href=\"http://krita.org/\">Krita</a>. Créez des choses à imprimer en 3D avec <a href=\"http://www.freecadweb.org/\">FreeCAD</a> ou <a href=\"http://www.blender.org/\">Blender</a>. Réservez vos tickets de concert en ligne via <a href=\"https://www.mozilla.org/en-US/firefox/new/\">Firefox</a>. Faites vos comptes avec <a href=\"http://sourceforge.net/projects/grisbi/\">Grisbi</a>. Jouez à <a href=\"http://www.flightgear.org/\">Flightgear</a>, <a href=\"http://www.wesnoth.org/\">Battle for Wesnoth</a>, <a href=\"http://vegastrike.sourceforge.net/\">Vega Strike</a>, <a href=\"http://ufoai.org/wiki/News\">UFO&#160;: Alien Invasion</a>.</p>\n\n\n<h4>Traquez les bugs</h4>\n\n\n<p>Maintenant que vous utilisez le logiciel, vous pouvez éventuellement rencontrer des bugs quand vous essayez de faire quelque chose. Ou alors, le logiciel peut avoir un comportement autre que celui qui était attendu.</p>\n\n\n<p>Entrez en contact avec les développeurs et prévenez-les. Les développeurs travaillent sur les retours de leurs utilisateurs, ceci les aide à perfectionner le produit. De plus, les sources étant libres, les bugs sont en général rapidement corrigés.</p>\n\n\n<p>Chaque projet aura un lien pour signaler un bug. Allez-y, identifiez-vous et décrivez ce bug dans les détails. N&#8217;oubliez pas d&#8217;indiquer quelle version du logiciel vous utilisez ainsi que les caractéristiques de votre ordinateur.</p>\n\n\n<h4>Écrivez de la documentation</h4>\n\n\n<p>Contribuer à écrire la documentation d&#8217;un projet pour le rendre plus clair et plus simple à comprendre.</p>\n\n\n<p>La plupart du temps, les développeurs sont trop occupés à coder et la documentation a besoin d&#8217;un peu d&#8217;attention. Vous pouvez la mettre en forme afin qu&#8217;elle soit plus claire, ajouter des images ou des tutoriels. Si certaines parties du projet ne sont pas claires, il suffit de demander sur les listes de diffusion. Ainsi, lorsque vous recevrez une réponse, vous pourrez l&#8217;ajouter à la documentation. Dès que les personnes qui maintiennent le projet saisiront ce que vous faites, leurs réponses seront encore plus efficaces et utiles.</p>\n\n\n<h4>Traduisez</h4>\n\n\n<p>Il y a beaucoup de personnes dans le monde qui utilisent ce projet et certaines d&#8217;entre elles pourraient ne pas parler la langue dans laquelle celui-ci a été distribué. Si vous parlez couramment un langage peu connu, contactez les développeurs/l&#8217;équipe de documentation et offrez vos services. Vous pourriez participer à la traduction de l&#8217;interface, de la documentation ou encore du site web.</p>\n\n\n<h4>Offrez vos compétences</h4>\n\n\n<p>Regardez les projets individuels et voyez ce dont ils ont besoin. Vous pouvez apporter quelque chose&#160;? Vous êtes designer sonore et pourriez créer quelques sons pour un jeu vidéo open source&#160;? Concepteur d&#8217;interface&#160;? Vous pourriez aider en remaniant l&#8217;interface utilisateur pour la rendre plus ergonomique. Il est également possible de lancer des entreprises viables utilisant ou formant aux logiciels open source.</p>\n\n\n<p>Vous pouvez aussi contribuer à la culture du libre en publiant ce que vous créez sous certaines licences Creative Commons. Vos créations peuvent ainsi aider à promouvoir le logiciel pour lequel elles ont été créées. Ceci inclut&#160;:</p>\n<ul>\n<li>les images&#160;;</li>\n<li>les programmes&#160;;</li>\n<li>les tutoriels&#160;;</li>\n<li>les manuels d&#8217;installation et de documentation&#160;;</li>\n<li>les livres.</li>\n</ul>\n\n<p>Utilisez la licence <a href=\"https://creativecommons.org/licenses/by-sa/2.0/\">CC BY-SA</a> pour que chaque réutilisation de votre travail soit elle aussi placée sous licence libre, <a href=\"https://creativecommons.org/licenses/by/2.0/\">CC BY</a> si la façon dont il est réutilisé vous importe peu.\nVous trouverez plus d&#8217;informations à ce sujet sur le <a href=\"https://creativecommons.org/\">site</a> des Creative Commons.</p>\n\n\n<h4>Prêchez la bonne parole</h4>\n\n\n<p>Aider à la prise de conscience des projets open-source est très important. N&#8217;agressez pas tout le monde, faites juste savoir quels projets vous utilisez. Créé avec <a href=\"http://mypaint.intilinux.com/\">MyPaint</a> sous <a href=\"http://www.linuxmint.com/\">LinuxMint</a>. Écrit en <a href=\"https://code.google.com/p/sigil/\">Sigil</a> sous <a href=\"http://www.ubuntu.com/\">Ubuntu</a>. Je suis fier d&#8217;utiliser <a href=\"https://wordpress.org/\">WordPress</a>. Toutes ces mentions sont utiles.</p>\n\n\n<h4>Faites des dons</h4>\n\n\n<p>Enfin, leur donner de l&#8217;argent. Avec de l&#8217;argent, le projet peut embaucher des développeurs supplémentaires qui pourront corriger des bugs plus rapidement, créer de nouveau outils, les améliorer pour vous. Certains projets proposent des dons occasionnels, alors que d&#8217;autres vous permettent de payer de petites sommes mensuellement. C&#8217;est une meilleure idée car cela aide les développeurs à mieux gérer leurs revenus quand ils savent quelle somme d’argent ils reçoivent de façon sûre.</p>\n\n\n<h4>Soyez professionnel</h4>\n\n\n<p>L&#8217;une des principales critiques faites aux logiciels open source est le manque de professionnalisme. Peu importe la manière dont vous contribuez à un projet open source, <strong>mettez un point d&#8217;honneur à le faire de façon professionnelle</strong>. L&#8217;élévation du niveau de qualité d&#8217;un projet commence avec ses utilisateurs. Assurez-vous que vous agissez de manière professionnelle lorsque vous discutez de projets avec d&#8217;autres et créez des contributions de qualité quand vous utilisez des logiciels open source.</p>\n\n\n<p>Maintenant que vous savez tout ça, lancez-vous et allez aider à rendre les projets open source géniaux.</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/gozamos/6308374832/\">Gozamos</a> (Creative Commons By-Sa)</em></p>          ','SHA1:8c795d1f3122f246c8f8dac18c89b1b62e71be44','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(17,'Wikipédia face aux institutions, par Éric Bruillard','SHA1:4915c0c759223000389b4a3d2b6e26ad933751b0','http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard','2013-06-12 06:15:00','\n\n      \n      	   <p><a href=\"http://www.stef.ens-cachan.fr/annur/bruillard.htm\">Éric Bruillard</a> est professeur au <a href=\"http://www.stef.ens-cachan.fr/\">STEF – ENS Cachan</a>.</p>\n\n\n<p>L&#8217;article ci-dessous reprend une <a href=\"http://www.dailymotion.com/video/xzpgqs_rencontres-wikimedia-2012-wikipe-dia-face-aux-institutions-e-ric-bruillard_tech\">présentation</a> faite le 15 décembre 2012 lors des <a href=\"http://rencontres.wikimedia.fr/\">Rencontres Wikimédia</a>, à l’université Paris Descartes.</p>\n\n\n<p><em>Remarque&#160;: Vous pouvez également accéder directement à la version <a href=\"http://www.framablog.org/public/_docs/eric-bruillard_wikipedia-face-aux-institutions_v12.odt\">ODT</a> et <a href=\"http://www.framablog.org/public/_docs/eric-bruillard_wikipedia-face-aux-institutions_v12.pdf\">PDF</a> du document.</em></p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/kalexanderson_cc-by.jpg\" alt=\"Kalexanderson - CC by\" style=\"display:block; margin:0 auto;\" title=\"Kalexanderson - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Wikipédia face aux institutions</h3>\n\n\n<p><em>Éric Bruillard - décembre 2012</em></p>\n\n\n<h4>Introduction</h4>\n\n\n<p>Il y a cinq ans, en mars 2007, j’avais écrit un article intitulé <a href=\"http://www.stef.ens-cachan.fr/annur/bruillard/eb_wikipedia_medialog.pdf\">«&#160;Wikipédia&#160;: la rejeter ou la domestiquer&#160;»</a>. J’avançais l’idée, qui a souvent été mal comprise, que Wikipédia ne pouvait pas «&#160;avoir une présence reconnue dans l’enseignement en France, ses principes mêmes (neutralité) n’étant pas compatibles avec les valeurs de l’école laïque et républicaine française, valeurs qui conduisent à privilégier certains points de vue et à en interdire d’autres&#160;». J’ajoutais que Wikipédia pouvait cependant avoir une place, d’une part comme projet encyclopédique avec des participations actives à ce projet, comme faire écrire des articles à des élèves, et, d’autre part, comme une encyclopédie à laquelle beaucoup auraient recours, dans une posture de consommateur.</p>\n\n\n<p>Ces deux directions ont été effectivement suivies, et des utilisations constructives sont repérables dans l’enseignement secondaire ou supérieur, quoique la «&#160;consommation&#160;» est certainement beaucoup plus développée que la participation. Mais Wikipédia aurait-elle maintenant une présence <em>reconnue</em> dans l’éducation&#160;?</p>\n\n\n<p>Dans un premier temps, nous allons tenter de situer les discours généraux sur Wikipédia, notamment dans l’éducation nationale. Ensuite, nous verrons en quoi Wikipédia est maintenant une véritable institution, statut qui n’est pas sans poser de nouvelles questions. Enfin nous traiterons la question de l&#8217;évaluation des articles de cette encyclopédie&#160;: une évaluation interne s’est installée alors que l&#8217;évaluation externe ne semble pas beaucoup progresser&#160;: serait-ce révélateur de relations encore difficiles avec un projet collectif que l’on a toujours du mal à appréhender&#160;?</p>\n\n\n<h4>Wikipédia&#160;: quoi de neuf depuis 2007&#160;?</h4>\n\n\n<p>Le premier constat que l’on peut faire, sans avoir spécialement besoin de l’étayer, est celui de la croissance impressionnante du projet Wikipédia&#160;: une présence très importante (notamment via Google), des utilisations qui se multiplient, notamment dans l’éducation, de nouveaux projets associés…</p>\n\n\n<p>Pourtant, face à ce formidable déploiement, on s’aperçoit, notamment à travers le discours d’étudiants ou d’enseignants, d’une méconnaissance persistante du fonctionnement de Wikipédia, d’idées reçues tenaces, d’utilisations contestées, d’interrogations sur la fiabilité…</p>\n\n\n<p>Wikipedia nous aide d’ailleurs à cerner ce que qu’est une <a href=\"http://fr.wikipedia.org/wiki/Id%C3%A9e_re%C3%A7ue\">idée reçue</a>&#160;: «&#160;une opinion, située entre le stéréotype, le cliché et le lieu commun&#160;», précisant qu’elle a «&#160;la particularité de s&#8217;admettre aisément&#160;» parce qu’elle est «&#160;très répandue, que celui qui la transmet la considère très souvent comme évidemment démontrée&#160;; elle est agréable à admettre, parce qu&#8217;elle répond (le plus souvent simplement) à une question redondante, ou gênante, ou complexe&#160;: elle aide à ne plus réfléchir et s&#8217;impose insidieusement&#160;». Justement, un peu de réflexion s’impose.</p>\n\n\n<p>Comme il est possible à n’importe qui de créer ou modifier le contenu d’un article, que ce n’est pas réservé à des spécialistes, il ne semble pas possible qu’il y ait des articles de qualité et on ne peut en aucun cas s’en remettre à Wikipédia. Ce discours de sagesse populaire continue à être très souvent énoncé. Prenons juste un seul <a href=\"http://techcenter009.blogspot.fr/2011/01/how-to-evaluate-wikipedia.html\">exemple</a>&#160;: <em>“Wikipedia is a free, web-based, collaborative, multilingual encyclopedia project. Anybody is able to change, add or remove articles on Wikipedia. This of course is prone to many problems as some authors may be: biased, vandalise the article or write incorrect information.”</em></p>\n\n\n<p>Les études comparatives qui ont été menées attestent <a href=\"http://www.nature.com/nature/journal/v438/n7070/full/438900a.html\">du contraire</a> et l’expérience quotidienne de nombre d’entre nous montre qu’on lui fait malgré tout confiance. Peu d’études nouvelles sont disponibles. La seule <a href=\"http://upload.wikimedia.org/wikipedia/commons/2/29/EPIC_Oxford_report.pdf\">étude</a> récente est intitulée <em>Assessing the accuracy and quality of Wikipedia entries compared to popular online encyclopaedias A preliminary comparative study across disciplines in English, Spanish and Arabic</em>. Mais les auteurs remercient la Wikimedia Foundation pour son soutien financier. D’autres institutions ne sont sans doute intéressées à financer une évaluation des articles de Wikipedia, préférant laisser planer le doute et les idées reçues.</p>\n\n\n<h4>Quelle présence <em>officielle</em> dans l’éducation&#160;?</h4>\n\n\n<p>Si la neutralité de l’éducation nationale française l’invite à ne pas citer de marque ou de nom de produit dans ses programmes officiels, sauf exception, elle est conduite à veiller sur ce qui est proposé. Une recherche sur le site officiel Eduscol atteste de la présence de Wikipédia.</p>\n\n\n<p>On trouve des revues de presse&#160;; un dossier déjà ancien sur les usages pédagogiques&#160;; des recommandations, des définitions issues de Wikipédia, le fait que Wikipedia offre une nouvelle fonctionnalité (l&#8217;exportation de pages au format <em>epub</em>, ce qui permet de constituer une sélection d&#8217;articles à consulter hors ligne sur une liseuse ou sur smartphone).</p>\n\n\n<p>On trouve également référence à Wikipedia dans des sujets de bac, des ressources pour la résolution de problèmes, des dossiers pédagogiques… mais avec le plus souvent des modes de citation approximatifs (cf page 2 de ce <a href=\"http://www.phychim.ac-versailles.fr/IMG/pdf/TS_annales_zero_2012_-_specifique_sujet_1_217742.pdf\">document</a>). Dans <a href=\"http://cache.media.eduscol.education.fr/file/SPC/50/8/Resolution_de_problemes_221508.pdf\">les ressources</a> pour la classe terminale générale et technologique, Physique-chimie, Série S (Eduscol), on trouve 10 références à Wikipédia.</p>\n\n\n<p>Ce bref tour d’horizon nous en apprend plus sur le système éducatif que sur Wikipédia. Cette dernière apparaît pratique et très utile, mais demeure un motif récurrent de complaintes, attestant des difficultés (ou de l’incapacité&#160;?) du système éducatif à traiter les évolutions en cours sur les savoirs, leur diffusion, leur mise en question… Une utilisation parfois «&#160;honteuse&#160;», que l’on peut rapprocher des usages des calculatrices en collège il y a quelques années<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#pnote-1646-1\" id=\"rev-pnote-1646-1\">1</a>]</sup>&#160;: une sur utilisation, une maîtrise très diversifiée et un manque de formation des élèves. Au début du collège, utiliser la calculatrice est considéré comme une tricherie, il ne faudrait s’en servir que pour contrôler les résultats des opérations que l’on fait à la main. Mais dès la 4e, la tricherie est quelque sorte légalisée, notamment avec les fonctions trigonométriques, et ceux qui ont acquis une bonne maîtrise des calculatrices, sont alors avantagés. Le système éducatif prend peu en charge, voire pas du tout, la formation des élèves à cette maîtrise.</p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/others/wikipedia-eduscol.png\" alt=\"Wikipédia - Eduscol\" style=\"display:block; margin:0 auto;\" title=\"Wikipédia - Eduscol\" /></p>\n\n\n<p><em>Wikipédia dans le site Eduscol – 10 décembre 2012</em></p>\n\n\n<p>Les objets informatiques spécifiques du système éducatif ne sont pas bien traités par Wikipédia. Ainsi, l’article ENT est encore une ébauche de piètre qualité. On retrouve une même ébauche, non signalée comme telle, sur l’expression «&#160;manuel numérique&#160;», page modifiée pour la dernière fois le 28 juin 2010<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#pnote-1646-2\" id=\"rev-pnote-1646-2\">2</a>]</sup>. C’est une version quasi «&#160;ministérielle&#160;» qui est proposée, la page «&#160;discussion&#160;» n’est pas ouverte et aucun article dans une autre langue n’est associé. Ce n’est toutefois par mieux en anglais où l’article <a href=\"http://en.wikipedia.org/wiki/Digital_textbook\">&#8220;digital textbook”</a> est une présentation du programme de ministère de l’éducation de Corée du Sud&#160;! Les exemples sont coréens, avec des liens vers Toshiba et Fujitsu. Il s’agit d’un article sur le projet coréen, et pas sur l’<a href=\"http://www.clrn.org/fdti/\">initiative californienne</a> par exemple.</p>\n\n\n<p>Enfin, pour clore ce rapide tour d’horizon, un site de l’académie de Montpellier propose de <a href=\"http://webpeda.ac-montpellier.fr/economie-gestion/?Creer-un-manuel-numerique-a-l-aide\">«&#160;créer un manuel numérique à l’aide de Wikipédia&#160;»</a>. Il est écrit&#160;: «&#160;Wikipédia est une excellente ressource pour construire un livre numérique dans le but d’explorer un sujet ou d’entamer une recherche documentaire. Pour inciter les étudiants à utiliser Wikipédia comme outil de départ plutôt que comme finalité d’une recherche, un enseignant peut facilement fournir à ses étudiants une collection d’articles de références sous la forme d’un livre numérique. Retrouvez les différentes étapes de création d’un livre numérique dans un mode opératoire mis à disposition sur le site &#8220;Prof Web&#8221;.&#160;»</p>\n\n\n<p>Si on clique sur l’<a href=\"http://www.profweb.qc.ca/fr/actualites/chroniques/creer-un-manuel-numerique-a-laide-de-wikipedia/index.html\">adresse indiquée</a>, on retrouve le même paragraphe à la virgule près, puis un petit mode d’emploi. Tous les éléments sont présents&#160;: citation et même copié-collé. Un exemple mais avec la parapluie de la bonne pratique (il faut utiliser simplement comme point de départ). On se sert de Wikipedia mais d’une manière non risquée&#160;!!! On ne cherche pas à comprendre, mais à trouver une pratique que l’on considère légitime et que les autres ne pourront pas contester.</p>\n\n\n<p>Cette méfiance persistante sur un projet maintenant très établi ne cache-t-elle pas des caractéristiques encore mal connues ou mal comprises. Et Wikipedia, s’il est encore regardé de travers par les institutions, ne serait-il pas aussi une institution&#160;?</p>\n\n\n<h4>Wikipédia est une institution</h4>\n\n\n<p>En effet, pour la recherche, une simple interrogation sur Wikipedia dans Google Scholar produit de très nombreux résultats&#160;; depuis 2011&#160;: 45&#160;700 résultats&#160;; depuis 2012&#160;: 23&#160;100 résultats (à titre de comparaison, on obtient pour les mêmes dates concernant Britannica&#160;: 13100 / 7320). Dans les travaux auxquels on accède, il y a des études sur le fonctionnement même de Wikipédia&#160;: <a href=\"http://newdesign.aclweb.org/anthology-new/W/W11/W11-07.pdf#page=58\">contenus</a>, <a href=\"http://www.plosone.org/article/info%3Adoi%2F10.1371%2Fjournal.pone.0038869\">conflits</a>, <a href=\"http://papers.ssrn.com/sol3/papers.cfm?abstract_id=1960696\">participation</a>, etc.&#160;; des outils pour Wikipédia.</p>\n\n\n<p>Issus de son fonctionnement même, l’encyclopédie fournit des corpus très <a href=\"http://www.aifb.kit.edu/images/5/5c/Vrandecic11language.pdf\">utiles pour les linguistes</a>, notamment les <a href=\"http://www.lirmm.fr/~lopez/TALN2011/Longs-TALN+RECITAL/Dutrey_taln11_submission_25.pdf\">paraphrases et modifications locales</a> dans l’historique des révisions des articles, conduisant à améliorer les performances d’applications de TAL&#160;: traduction automatique, question-réponse, génération…</p>\n\n\n<p>Encore plus intéressant, dans un processus d’institutionnalisation de Wikipédia, le projet <em><a href=\"http://semanticpedia.fr/\">Semanticpedia</a></em> associe le ministère de la culture, l’INRIA et Wikimedia France. Cette collaboration <a href=\"http://semanticpedia.fr/blog/\">vise</a> à «&#160;réaliser des programmes de recherche et développement appliqués à des corpus ou des projets collaboratifs culturels, utilisant des données extraites des projets Wikimédia&#160;». Il s’agit notamment de fournir des données culturelles accessibles à tous, dans une version Web sémantique structurée&#160;; en gros devenir la référence pour la culture avec des modes d’interrogation très avancés dans des formes de déclaration sémantique.</p>\n\n\n<p>Wikipédia est même vu comme un nouvel outil d’évaluation&#160;: une évaluation de la <a href=\"http://www.doppelganger.name/2010/07/une-evaluation-de-la-reputation.html\">réputation ponctuelle</a>, la fréquentation de Wikipédia étant considéré comme outil de mesure&#160;; mais aussi, l’<a href=\"http://www.atelier.net/trends/articles/wikipedia-permet-de-mesurer-impact-un-individu-environnement\">influence</a> qu&#8217;une personne a sur un pays ou même sur une civilisation, qui pourrait être mesurée en fonction des liens menant à sa page Wikipédia.</p>\n\n\n<p>Ainsi, Wikipédia est devenu outil de référence, même s’il s’en défend. C’est déjà un attracteur très puissant pour les recherches et, selon Kien Quach Tat<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#pnote-1646-3\" id=\"rev-pnote-1646-3\">3</a>]</sup> (2011), au Vietnam, Wikipédia est ce qui permet aux lycéens de valider une information trouvée sur un autre site.</p>\n\n\n<p>Quelle implication du fait que Wikipédia est une institution&#160;? Peut-on être en dehors de Wikipédia&#160;? Comme elle devient la référence, peut-on continuer à l’ignorer, si une information nous concernant est fausse, peut-on encore traiter cela par le mépris ou l’absence de réaction n’est pas une sorte d’acquiescement&#160;? En tous cas, si Wikipedia gère très efficacement les vandalismes, on sait qu’elle est mal armée pour lutter contre des organisations qui cherchent à imposer leur point de vue. Un projet d’émancipation ne s’est-il pas transformé en un instrument de domination&#160;? On n’en est pas (encore) là&#160;! Demeure une question clé&#160;: comment évaluer un article de Wikipédia&#160;?</p>\n\n\n<h4>Comment évaluer un article de Wikipédia&#160;?</h4>\n\n\n<p>En 2007, Wikipédia précisait qu’elle n’avait pas les moyens de juger de la crédibilité d’une information et que la fondation cherchait des solutions à cette absence de validation du contenu des articles, notamment «&#160;par l’ajout de systèmes de notation, d’identification des versions non vandalisées et par des collaborations avec des chercheurs et des enseignants&#160;» (Bruillard, 2007). Des avancées importantes ont été réalisées. Wikipédia évalue elle-même les articles qu’elle produit. Ainsi, l’article <a href=\"http://fr.wikipedia.org/wiki/Projet:%C3%89valuation\">Projet :Évaluation</a> est consacré à «&#160;déterminer l&#8217;état des articles de Wikipédia selon deux critères&#160;: leur <em>importance</em> et leur <em>avancement</em>&#160;».</p>\n\n\n<h4>Mais quelle évaluation externe peut-on trouver&#160;?</h4>\n\n\n<p>Quand on lance la requête «&#160;évaluation article Wikipédia&#160;», via Google, environ 16&#160;900&#160;000 de résultats (0,42 secondes) sont fournis. Mais la grande majorité de ces résultats correspondent à des articles de Wikipedia. La requête <a href=\"http://fr.wikipedia.org/wiki/Projet:%C3%89valuation\">«&#160;évaluer un article de Wikipédia&#160;» -wikipedia.org</a> ne donne aucun résultat. Enlever les guillemets dans la requête conduit à 8 040 000 résultats (0,19 secondes). Que trouve-t-on&#160;?</p>\n\n\n<p>D’abord des <a href=\"http://upload.wikimedia.org/wikipedia/commons/8/83/Wikip%C3%A9dia,_le_rapport_aux_sources,_la_critique_des_sources.pdf\">conseils</a>, il s’agit d’évaluer le nombre et la qualité des sources, de consulter l’historique (combien de personnes y ont contribué, et quand), de consulter l&#8217;évaluation de l&#8217;article et surtout de le comparer à d&#8217;autres sources&#160;!</p>\n\n\n<p>Le tutoriel Cerise propose d’autres <a href=\"http://urfist.enc.sorbonne.fr/cerise/Module1/exemple-le-chocolat/texte-le-chocolat-utiliser-wikip-dia\">conseils</a>&#160;:</p>\n<ul>\n<li>«&#160;Voir si le plan est bien construit et détaillé</li>\n<li>Juger de la qualité de la rédaction&#160;: syntaxe, orthographe, synthèse, illustration, &#8230;</li>\n<li>Repérer les liens vers les notes et les définitions</li>\n<li>Voir s&#8217;il y a une bibliographie récente et mise à jour</li>\n<li>Voir s&#8217;il y a un portail sur le thème sélectionné.&#160;»</li>\n</ul>\n\n<p>Les guides de la BU de l’université de Rennes 2 dans une <a href=\"http://methodoc.univ-rennes2.fr/content.php?pid=105695&amp;sid=1066140\">page</a> sur «&#160;évaluer l’information&#160;» consacre un petit encart à Wikipédia en conseillant de regarder les avertissements sur les pages, la date de création (onglet &#8220;historique”) et les débats (onglet &#8220;discussion&#8221;). Cela renvoie à un <a href=\"http://www.lemonde.fr/technologies/article/2010/03/17/comment-les-etudiants-utilisent-ils-wikipedia_1320623_651865.html\">article</a> du Monde.fr et étrangemenent, aux évaluations internes de Wikipédia.</p>\n\n\n<p>Sur la Teluq, Marc Couture, dans son cours sur l’évaluation de la crédibilité des documents en ligne, <a href=\"http://benhur.teluq.uqam.ca/ST/sciences/sci1021/evalweb.htm\">traite</a> du cas particulier de «&#160;la crédibilité de Wikipédia&#160;». Il constate que les critères généraux ne s’appliquent qu’imparfaitement aux articles de Wikipédia. Ainsi, ceux reliés à l&#8217;insertion dans la littérature spécialisée&#160;: «&#160;Ce critère prendra donc une valeur toute relative compte tenu à la fois du rôle que joue une encyclopédie dans la littérature scientifique ou savante, et de la difficulté à évaluer le nombre de références à un article de Wikipédia.&#160;» Les critères sur l’auteur ne sont pas applicables, les autres (la validation du contenu, forme et la structure du document) sont soit sans garantie soit réfèrent aux classements et processus internes de Wiipédia.</p>\n\n\n<p>Cherchant dans les sources en anglais, on trouve de nouveau beaucoup de redondances, avec une référence citée, reprise, tronquée dans la Wikipedia anglaise. Un <a href=\"http://en.wikipedia.org/wiki/Wikipedia:Researching_with_Wikipedia\">article</a> intitulé <em>Wikipedia:Researching with Wikipedia</em> n’a pas d’équivalent en français avec la recommandation rituelle&#160;: <em>“Wikipedia should be a starting place for research, not an end destination and independent confirmation of any fact presented is advised”</em>.</p>\n\n\n<p>Cet article fournit un lien avec une <a href=\"http://upload.wikimedia.org/wikipedia/en/1/16/How_to_evaluate_a_Wikipedia_article.pdf\">page</a> sur l’évaluation des articles de Wikipédia, page que l’on retrouve <a href=\"http://people.lib.ucdavis.edu/psa/evaluation_handout.doc\">ici</a> (source Phoebe Ayers, en octobre 2006). En fait, ce texte donne tous les éléments pour évaluer un article, les autres sources n’en sont souvent qu’une reprise tronquée.\nAu bout du compte, c’est une source datée de 2006 (et qui est peut-être antérieure) qui donne les meilleures informations et fait le point le plus complet sur les modes d’évaluation des articles.</p>\n\n\n<p>Mais est-ce que les procédures d’évaluation préconisées sont opérationnelles&#160;? Autrement dit, peut-on appliquer ces processus dans des utilisations courantes, c’est-à-dire hors situations particulières (notamment scolaires) et de nécessités de vérification. On peut raisonnablement penser que non, si je m’en réfère à mes propres utilisations et ce que peuvent dire les étudiants. Qui confronte systématiquement ce qui est écrit dans un article de Wikipédia à d’autres sources&#160;?</p>\n\n\n<p>Ce que l’on peut regretter, c’est l’absence de cartographie thématique, alors que l’on imagine qu’il y a des zones de fiabilités différentes, des repérages a priori pourraient guider le lecteurs (les articles dans le domaine X sont plutôt fiables, alors que dans le domaine Y c’est problématique), des marques reconnaissables. Alors que l’on comprend qu’il faut consulter l’historique et les discussions, il y a peu d’outils de visualisation nous donnant une image interprétable&#160;; en conséquence, historique et discussions restent très difficiles à analyser rapidement. En effet, il s’agit de prendre en compte la dynamique collective et temporelle et de pouvoir juger une ressource de par l’histoire de sa construction et des discussions qui l’ont accompagnée. Mais comment le faire rapidement et de manière fiable sans instrumentation. History Flows<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#pnote-1646-4\" id=\"rev-pnote-1646-4\">4</a>]</sup> proposait des visualisations intéressantes. Mais il ne semble pas que ce travail ait été repris et il demeure mal connu.</p>\n\n\n<h4>Des enjeux de formation&#160;: guider des consommateurs via des passeurs outillés</h4>\n\n\n<p>L’évaluation dépend bien évidemment dépend de la finalité, du public visé, etc. et on pourrait refuser une sorte d’évaluation intrinsèque des articles de Wikipédia. Mais le jugement sur cette qualité a des incidences fortes, notamment sur les représentations sociales de ce projet encyclopédique. Chacun a ses propres croyances sur Wikipédia, mais il n’y a pas de «&#160;sagesse collective&#160;» ou de connaissance collective nous en donnant une image moins naïve. Comment juger de la qualité&#160;? On voit que la question est délicate&#160;: qualité proportionnelle ou inversement proportionnelle au nombre de contributeurs&#160;; processus linéaire d’accroissement avec quelques accidents ou des formes de plateau, voire des régressions&#160;? La qualité des collaborations <a href=\"http://cursus.edu/dossiers-articles/articles/4471/wikipedia-qualite-des-collaborations-joue-sur/\">aurait</a> un effet sur la qualité des articles.</p>\n\n\n<p>Selon une <a href=\"http://www-users.cs.umn.edu/~halfak/publications/The_Rise_and_Decline/halfaker12rise-preprint.pdf\">étude</a> récente, les changements apportés pour assurer la qualité des articles, avec de nouveaux contributeurs nombreux, aurait un effet négatif sur le recrutement de ces nouveaux contributeurs découragés par les mécanismes mis en place. Ainsi, incontestablement, un processus de professionnalisation a été organisé, processus qui a un effet dissuasif. D’un autre côté, on s’aperçoit que les «&#160;consommateurs&#160;», rôle que nous prenons tous à un moment ou à un autre pour Wikipédia, ont du mal à sortir d’une vision très naïve et se satisfont d’une sorte de «&#160;bonne pratique&#160;» paravent&#160;: on n’utiliserait que pour commencer une recherche, on ne s’arrêterait jamais sur un article de Wikipédia. Comportement que très peu de personnes adoptent, sauf dans des contextes très particuliers. Alors que l’on propose des modèles à discuter de perméabilité entre concepteurs et consommateurs, on s’aperçoit que pour Wikipédia, il y a d’un côté des concepteurs très instrumentés et d’un autre côté des consommateurs très peu outillés. Entre les deux, on peut s’interroger sur les connaissances, les instruments pour les «&#160;médiateurs&#160;» (enseignants, documentalistes, etc.). Ne devraient-ils pas en savoir collectivement beaucoup plus que les «&#160;simples&#160;» utilisateurs&#160;?</p>\n\n\n<p>Wikipedia est un excellent analyseur des évolutions éducatives&#160;: un discours rituel sur la nécessité de développer des utilisations du «&#160;numérique&#160;», une présence effective mais comme une espèce de sous culture, acceptable parce qu’elle rend des services, pratique mais décriée. Wikipedia est une mine pour les chercheurs, c’est aussi un projet en avance dans le domaine de la culture et dans celui du Web sémantique. Mais comment maîtriser cette technologie collective&#160;? On ne perçoit pas encore bien toutes les potentialités et limites de l’écriture collective. Une tension apparaît&#160;: si on apprend par l’écriture, des contraintes de forme trop fortes découragent, l’exigence de qualité risque de conduire à un élitisme par trop restrictif. Il faudrait professionnaliser les intermédiaires, afin de palier le manque d’instrumentation, notamment permettant de visualiser des processus de construction pour juger une production. La question de l’expertise des éducateurs se pose avec une certaine  urgence. Pourquoi n’arrive pas à se développer un regard plus professionnel sur les productions de ce travail collectif&#160;?</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/kalexanderson/8122894816/\">Kalexanderson</a> (Creative Commons By)</em></p>\n<div class=\"footnotes\"><h4>Notes</h4>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#rev-pnote-1646-1\" id=\"pnote-1646-1\">1</a>] Voir par exemple, Bruillard Éric (1994). <a href=\"http://www.stef.ens-cachan.fr/annur/bruillard/GRAND_N.pdf\">Quelques obstacles à l&#8217;usage des calculettes à l&#8217;école&#160;: une analyse</a>, Grand N, n°53, p. 67-78.</p>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#rev-pnote-1646-2\" id=\"pnote-1646-2\">2</a>] Page consultée le 6 mars 2013</p>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#rev-pnote-1646-3\" id=\"pnote-1646-3\">3</a>] Kien Quach Tat (2011).. Recherche d’information sur le web et moteurs de recherche&#160;: le cas des lycéens. Thèse soutenue le 16 décembre 2011 à l’ENS de Cachan</p>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/12/wikipedia-institutions-eric-bruillard#rev-pnote-1646-4\" id=\"pnote-1646-4\">4</a>] Viégas Fernanda B., Wattenberg Martin, Dave Kushal (2004). Studying Cooperation and Conflict between Authors with history flow Visualizations. In CHI 2004, April 24–29, 2004, Vienna, Austria. ACM.</p></div>\n          ','SHA1:098a45ad3aef71b56c634bf3e404752b7e9219b3','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(18,'Conférence de François Elie : Quelle école pour la société de l\'information ?','SHA1:0a75e38c1ea4ccbed7cf4ff936cebe266df436d7','http://www.framablog.org/index.php/post/2013/06/11/francois-elie-education-conference','2013-06-11 10:14:00','\n\n      \n      	   <p>Le 27 avril dernier <a href=\"http://fr.wikipedia.org/wiki/Fran%C3%A7ois_Elie\">François Elie</a><sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/11/francois-elie-education-conference#pnote-1645-1\" id=\"rev-pnote-1645-1\">1</a>]</sup> donnait une <a href=\"http://www.fetons-linux.ch/evenements/logiciel-libre-et-education\">conférence</a> remarquable et remarquée lors de la troisième édition de <a href=\"http://www.fetons-linux.ch/\">Fêtons Linux</a> à Genève.</p>\n\n\n<p>Nous l&#8217;avons jugée suffisamment importante pour en faire un article dédié (vidéo + transcript) et vous inviter à trouver vous aussi la demi-heure au calme pour l&#8217;écouter.</p>\n\n\n<p>Les députés ont récemment <a href=\"http://www.ecrans.fr/Education-nationale-priorite,16486.html\">abandonné la priorité du libre dans l&#8217;éducation</a>. En écoutant François Elie, vous comprendrez pourquoi cette triste décision est tout sauf anodine.</p>\n\n\n<p>Quelques extraits pour se motiver ;)</p>\n\n\n<p>«&#160;Je vais vous décevoir tout de suite parce que vous vous attendez à ce que je dise qu&#8217;il est très très important d&#8217;utiliser le logiciel libre dans les écoles. Bon ça y est je l&#8217;ai dit. On peut passer à autre chose.&#160;»</p>\n\n\n<p>«&#160;Si l&#8217;école doit être quelque chose, elle doit essayer de n&#8217;être ni l’école de l’initiation, ni l’école de l&#8217;apprentissage. Elle doit être au contraire l&#8217;école où on apprend à maîtriser les choses pour ne pas dominer les Hommes.&#160;»</p>\n\n\n<p>«&#160;Il faut cesser d&#8217;opposer l&#8217;enseignement de la programmation d&#8217;une part et l&#8217;enseignement des usages, c&#8217;est important mais ça c&#8217;est l’école des maîtres et des esclaves. Ce qu&#8217;il faut enseigner, vite et à tous, c&#8217;est la science, pas la technologie ou l&#8217;usage. C&#8217;est en amont de la programmation, l&#8217;algorithmique. C&#8217;est en amont, de telle instanciation, du codage, du chiffrement, la théorie, quelque chose qui comme les maths n&#8217;ont besoin que d&#8217;une craie et d&#8217;un tableau noir.&#160;»</p>\n\n\n<p>«&#160;Puisqu&#8217;on n&#8217;enseigne pas la physique dans une voiture, pourquoi devrait-on nécessairement apprendre l&#8217;informatique sur un ordinateur&#160;?&#160;»</p>\n\n\n<p>«&#160;L’école est le lieu, l’enjeu d’un affrontement colossal entre ceux qui voudraient ceux qui voudraient qu’elle reste l’école de la liberté et ceux qui voudraient en faire autre chose, une école qui serait cliente captive d’un marché, des industries numériques pour l’éducation.&#160;»</p>\n\n\n<p>«&#160;On peut difficilement enseigner la liberté avec des outils qui cherchent à dominer. Ça va être compliqué d&#8217;utiliser des outils qui sont faits pour ne pas être partagés pour apprendre à des élèves à partager. Ça va être compliqué d&#8217;enseigner à des élèves comment il faut protéger ses données en utilisant des réseaux sociaux qui sont faits pour justement les capturer. Bref apprendre l’ouverture avec ce qui est fait pour fermer, c&#8217;est compliqué.&#160;»</p>\n\n\n<p>«&#160;Je disais à une syndicaliste, vous aurez du mal à faire la révolution avec Word. Elle n&#8217;a pas compris&#160;! J’avais été invité à une université d&#8217;été d&#8217;Attac, et là je leur avais dit&#160;: Je ne vais plus au MacDo mais vous êtes encore sous Windows.&#160;»</p>\n\n\n<p>«&#160;L&#8217;école est l&#8217;endroit où on dit le plus de mal de Wikipédia, il faut le savoir. Par contre on dit beaucoup de bien de Diderot, de l&#8217;Encyclopédie, du siècle des Lumières. Embêtant quand même, parce que moi je suis persuadé que Diderot adorerait Wikipédia. Mais il n’adorerait pas Wikipédia pour lire mais pour écrire dedans. Il ne s&#8217;agit pas d&#8217;apprendre aux enfants à se méfier de ce qu&#8217;on lit dans Wikipédia, il faut leur apprendre à écrire dans Wikipédia. Mais ça il faut du temps.&#160;»</p>\n\n\n<p>«&#160;L&#8217;école a tout à apprendre de la culture des hackers. Il faut apprendre à travailler comme des hackers. Nietzsche a une formule magnifique il dit «&#160;Plutôt périr que travailler sans joie&#160;». On peut vouloir travailler comme un maître ou travailler comme un esclave. On peut aussi faire de sa vie quelque chose de plus joyeux, aimer son travail. On peut apprendre à aimer son travail à l&#8217;école. On peut apprendre à exister par la valeur de ce qu&#8217;on fait, par la valeur de ce qu&#8217;on montre, par l&#8217;image qu&#8217;on a, et pour ça, et bien le logiciel libre pourrait nous aider pour refonder l&#8217;école, pour apprendre à collaborer, pour apprendre à partager, pour apprendre à bricoler, produire ses propres outils, se former, se former sans cesse, être en veille permanente. Toutes ces qualités qui sont celles des hackers ce sont celles qu&#8217;on attend d&#8217;un élève.&#160;»</p>\n\n\n<p>«&#160;Alors je reviens à Marx. Au 19ème siècle, il avait posé une bonne question&#160;: «&#160;À qui appartiennent les moyens de production&#160;?&#160;» Et bien les moyens de production des contenus et des outils de l&#8217;école doivent appartenir à l&#8217;école. Donc la question du logiciel libre n&#8217;est pas une petite question, c&#8217;est la question même de l&#8217;école. Et la question n&#8217;est pas à l&#8217;utilisation. C&#8217;est de se mettre à l&#8217;école de ce mode de production, pour produire les savoirs, les contenus, pour rendre possible une éducation, une instruction des élèves qui leur permette d&#8217;accéder à la liberté, non par la technologie ou par les usages, mais par la science.&#160;»</p>\n\n\n<p><br /></p>\n\n<iframe width=\"640\" height=\"360\" src=\"http://www.youtube.com/embed/u_vT0abtP6Q\" frameborder=\"0\" allowfullscreen></iframe>\n\n\n\n<p><br /></p>\n\n\n<h3>François Elie&#160;: Quelle école pour la société de l&#8217;information&#160;? Program or be programmed&#160;?</h3>\n\n\n<h4>Transcript</h4>\n\n\n<p><em>Nous devons cette transcription à Marie-Odile de l&#8217;April<sup>[<a href=\"http://www.framablog.org/index.php/post/2013/06/11/francois-elie-education-conference#pnote-1645-2\" id=\"rev-pnote-1645-2\">2</a>]</sup>. Nous nous sommes permis d&#8217;y ajouter quelques liens.</em></p>\n\n\n<p>Bonjour à tous. On va commencer, on ne va pas attendre que les portes se ferment. Je vais me présenter rapidement. Je suis un petit peu impressionné parce que cette conférence et la suivante sont présentées comme des événements. Si je suis mauvais tant pis, enfin vous verrez. Je me présente rapidement, François Élie, j’ai un peu plus d&#8217;un demi-siècle, actuellement j&#8217;enseigne la philosophie. Je suis tombé dans l&#8217;informatique tout petit et puis il y a dix ans je suis rentré en politique un peu par hasard et j&#8217;ai fondé une association en France qui s&#8217;appelle l&#8217;<a href=\"https://fr.wikipedia.org/wiki/Association_des_d%C3%A9veloppeurs_et_utilisateurs_de_logiciels_libres_pour_les_administrations_et_les_collectivit%C3%A9s_territoriales\">Adullact</a> avec quelques-uns pour non pas simplement utiliser les logiciels libres sur fonds publics, mais pour les développer et les développer sur un segment métier, sur ces logiciels qui sont adhérants et qui empêchent de basculer vers le libre. Mais ça j&#8217;en parlerai dans la conférence suivante.</p>\n\n\n<p>L&#8217;objet ici ça va être de réfléchir sur le libre et l&#8217;éducation. Alors je vais vous décevoir tout de suite parce que vous vous attendez à ce que je dise qu&#8217;il est très très important d&#8217;utiliser le logiciel libre dans les écoles. Bon ça y est je l&#8217;ai dit. On peut passer à autre chose. Bien sûr que c&#8217;est important. On pourrait faire des listes de gens très courageux qui ont installé des salles en libre accès, des salles en libre. Mais j&#8217;ai envie de dire que ce n&#8217;est pas le plus important. Il y a beaucoup plus important. Il y a l&#8217;école elle-même.</p>\n\n\n<p>Je voudrais vous parler du rapport entre le logiciel libre et l&#8217;école et vous verrez que les enjeux sont un petit peu plus importants que ça.</p>\n\n\n<p>Pour ça il faut revenir à ce que c&#8217;est qu&#8217;une école. Alors je vous l&#8217;ai dit j&#8217;enseigne la philosophie pour manger et je vais essayer de revenir un peu en arrière, au moment où on a inventé les écoles. Ce n&#8217;est pas Charlemagne ou Jules Ferry qui ont inventé les écoles, ce sont les philosophes il y a 25 siècles.</p>\n\n\n<p>Et puis je vais vous parler un peu de Platon pour vous mettre à température en vous parlant de l&#8217;<a href=\"http://fr.wikipedia.org/wiki/All%C3%A9gorie_de_la_caverne\">allégorie de la Caverne</a>. Pour ceux qui voudraient retrouver le texte, c&#8217;est dans le livre 7 de <a href=\"http://fr.wikipedia.org/wiki/La_R%C3%A9publique\">La République</a>. Des hommes sont dans une caverne à regarder un écran, comme vous regardez un écran, regardent les images qui sont projetées. Ils sont là depuis leur enfance les jambes et le cou enchaînés de sorte qu&#8217;ils ne peuvent voir que devant eux. La lumière vient d&#8217;un feu allumé sur une hauteur loin derrière eux et entre le feu et les prisonniers passe une route élevée. Le long de cette route passe un petit mur et les long de ce petit mur des hommes font des marionnettes. Et ces hommes voient les ombres de ces objets qui passent. Alors Socrate s&#8217;adresse à son interlocuteur et lui dit mais qu&#8217;est-ce qui se passe si on les déchaîne, si on essaye de les faire sortir de la caverne. Et bien évidemment ils vont résister. Je ne sais pas si vous avez déjà vu en septembre des enfants se précipiter à l&#8217;école en disant chouette je vais apprendre à lire. En général, ils préféreraient rester avec leurs Pokémon, leurs Playmobil, leur Lego, bref leurs ombres. Et donc il y a une force de résistance. On ne veut pas le savoir. Le savoir n&#8217;est pas quelque chose de naturel. On résiste au savoir&#160;! Alors ils faut les emmener à petits pas , pas les emmener trop vite sinon on leur brûle les yeux. Si vous emmenez un élève de Terminale qui aime beaucoup les maths, si vous l&#8217;emmenez au Collège de France tout de suite, il va détester les maths. Donc il faut l&#8217;emmener à petits pas. Et puis par habitude il va progressivement s&#8217;habituer aux objets de la région supérieure. Et un jour il redescendra parce que quand il verra le soleil en dehors de la caverne il redescendra parce qu&#8217;il comprendra que le savoir n&#8217;a de valeur que s&#8217;il est partagé. Il essaiera de sortir les gens de la caverne.</p>\n\n\n<p>Alors qui sont les gens qui sont derrière le petit mur. Ce sont ceux qui sont montés et qui ne sont pas redescendus. On les appelle les <a href=\"http://fr.wikipedia.org/wiki/Sophiste\">sophistes</a>. C&#8217;est ceux qui jouent avec le savoir, c&#8217;est ceux qui ont la tentation du pouvoir. Toute la question des écoles c&#8217;est de savoir si on enseigne comme les sophistes, si on fait des marionnettes ou si on cherche à libérer par le savoir.</p>\n\n\n<p>Les premières écoles existent, elles existent avant, il y a très très longtemps. Il existe 2 types d&#8217;école. Dans les temples, il y a des écoles où on fait de l’initiation, des secrets, des arcanes, des choses qu&#8217;on ne répète pas. Et puis il y a d&#8217;autres écoles. Ce sont les écoles pour les esclaves. Pour donner de la valeur à un esclave il faut lui donner un métier. Il faut lui apprendre des choses utiles. Et on va s&#8217;arranger pour qu&#8217;à l&#8217;école il ait un bagage, quelque chose à vendre.</p>\n\n\n<p>Vous reconnaissez un peu des écoles qui sont encore aujourd’hui. Il y a encore le tentation de vouloir enseigner des secrets à quelques-uns et puis un bagage pour tous les autres.</p>\n\n\n<p>Alors il y a une école qui m&#8217;intéresse, c&#8217;est l&#8217;école de Pythagore. Ils font des mathématiques et il y a 2 écoles. Il y a l’école pour les mathématiciens, ils apprennent à faire des maths dans le secret et puis il y a l&#8217;école des <a href=\"http://fr.wikipedia.org/wiki/Pythagore\">acousmaticiens</a>, ceux qui écoutent et on leur apprend à utiliser les mathématiques, mais pas à faire des mathématiques. Et un jour les philosophes vont libérer les mathématiques pour livrer le grand secret et le grand secret c&#8217;est qu&#8217;il n&#8217;y a pas de secret, c&#8217;est que tout le monde peut faire des mathématiques.</p>\n\n\n<p>Vous voyez le rapport avec l&#8217;informatique&#160;? Alors si l&#8217;école doit être quelque chose, elle doit essayer de n&#8217;être ni l’école de l’initiation, ni l’école de l&#8217;apprentissage. Elle doit être au contraire l&#8217;école où on apprend à maîtriser les choses pour ne pas dominer les Hommes.</p>\n\n\n<p>Je voulais partir de ça pour essayer de comprendre quelles sont les écoles qui vous accueillir de l&#8217;informatique demain ou peut être aujourd&#8217;hui. L&#8217;éternel problème de l&#8217;école, Platon le disait déjà, Bourdieu appelle ça la reproduction, c&#8217;est éviter que les âmes d&#8217;or s’imaginent que leurs enfants sont des âmes d&#8217;or et permettre aux enfants des âmes de bronze, qui seraient des âmes d&#8217;or, de pouvoir percer et servir par leur mérite, par leur valeur. Alors il y a toujours le problème depuis l&#8217;origine, il y a des paramètres qui permettent de réussir&#160;: le fric, le piston, la triche, il paraît que ça existe encore dans les écoles.</p>\n\n\n<p>Je voulais revenir maintenant venir sur un principe que propose <a href=\"http://fr.wikipedia.org/wiki/Alain_(philosophe)\">Alain</a>, philosophe du début du 20ème siècle, pour dire que «&#160;l&#8217;enseignement doit être résolument retardataire&#160;», je vous lis la formule  «&#160;non pas rétrograde, tout au contraire, rétrograde ça voudrait dire partir du présent pour aller en sens inverse vers le passé. Non&#160;! Retardataire c&#8217;est partir du passé et s&#8217;acheminer à petits pas vers le présent pour savoir d&#8217;où on vient. C&#8217;est pour marcher dans le sens direct qu&#8217;il prend du recul. Prendre du recul pour aller loin et pour ensuite marcher. Pour apprendre l&#8217;histoire des sciences, pour apprendre l&#8217;histoire de la langue, pour apprendre d&#8217;où on vient et comment on a fait. Bien sûr on va le faire non pas en 25 siècles mais en quelques années. Car si l&#8217;on ne se place point dans le moment dépassé, comment le dépasser&#160;? Ce serait une folle entreprise, même pour un homme dans toute la force de prendre les connaissances en leur état dernier. Il n&#8217;aurait point d&#8217;élan ni aucune espérance raisonnable. Au contraire celui qui accourt des anciens âges est comme lancé sur le mouvement juste. il sait vaincre&#160;: cette expérience fait les esprits rigoureux.&#160;»</p>\n\n\n<p>Vous avez compris encore le rapport avec l&#8217;informatique. Si on apprend l&#8217;informatique telle qu&#8217;elle se fait aujourd&#8217;hui, si on apprend les usages de l&#8217;informatique d&#8217;aujourd&#8217;hui, on n&#8217;a rien compris. Il faut apprendre d&#8217;où ça vient, pourquoi ça a évolué comme ça, sinon et bien on sera piégé.</p>\n\n\n<p>Alors à la fin de l&#8217;allégorie de la Caverne, Platon nous dit il y a une leçon à tirer de ça. Celui qui se souvient qu&#8217;on a les yeux brûlés par l&#8217;obscurité ou par la lumière, il se souvient qu&#8217;on peut être dérangé par soit l&#8217;entrée vers l&#8217;enseignement soit l&#8217;entrée vers le savoir lui-même. Et notre première manière de nous situer par rapport à quelqu&#8217;un qui a envie de nous apprendre quelque chose ou qui au contraire a quelque chose à apprendre de nous, c&#8217;est de rire de lui. C&#8217;est de chercher à ne pas enseigner. Alors ça tombe bien il y a des tas de choses qu&#8217;ils savent déjà&#160;! Forcément&#160;! Donc il n&#8217;y a rien à leur enseigner&#160;! Et puis ça tombe bien&#160;! Il n&#8217;ont pas envie d&#8217;apprendre, alors on les livre à la séduction. Et c&#8217;est vrai Socrate le disait déjà. Un médecin a perdu d&#8217;avance devant un tribunal d&#8217;enfants contre les confiseurs, contre les gens de la séduction qui vont leur donner des objets designés, packagés, de la marque, quelque chose qui a une valeur extérieure et qui les séduira.</p>\n\n\n<p>Alors on nous rebat les oreilles avec la <a href=\"http://fr.wikipedia.org/wiki/G%C3%A9n%C3%A9ration_Y\">génération Y</a>. Ces enfants qui auraient eu des cours d&#8217;informatique intra-utérins et qui sauraient tout déjà et qui n&#8217;auraient rien à apprendre et qui en savent plus que nous. J&#8217;ai commencé avec un <a href=\"http://fr.wikipedia.org/wiki/ZX81\">ZX81</a> et je plains sincèrement ceux qui commencent avec un smartphone. Ils jouent avec, ils ont un clickodrome et avec des gigas de mémoire vive, ils en font moins que nous avec 1 kilo, j&#8217;avais même acheté 1 kilo supplémentaire pour faire plus de choses. La vrai génération Y c&#8217;est la nôtre, c&#8217;est la mienne, ce n&#8217;est pas celle d&#8217;aujourd&#8217;hui. Ce sont les gens qui ont vu naître l&#8217;informatique qui arrivait et qui quittait les gros ordinateurs, juste avant le verrouillage du PC, au moment où on échangeait du code, on apprenait, on apprenait de l’assembleur, on jouait avec.</p>\n\n\n<p>Comment apprennent-ils&#160;? Ils apprennent par imitation. Alors c&#8217;est très bien l’imitation, c&#8217;est très utile et à la différence du singe qui lui est beaucoup plus intelligent. Je vous raconte une petite histoire. Il y a une expérience qui a été faite récemment par une américaine, expérience magnifique. Elle va présenter à des jeunes singes une boîte et elle fait toutes sortes d&#8217;opérations, elle tire un tiroir, elle tourne la chevillette, elle fait des opérations bizarres et puis à la fin il y a un tiroir avec des bonbons. Elle présente ça à des singes. Ils refont, ils reproduisent tout, ils tirent le tiroir, ils prennent les bonbons. Elle met des jeunes enfants, ils font exactement la même chose. Et puis ensuite elle enlève le cache et on voit que la boîte est transparente et on voit que la plupart des opérations ne servent à rien. Il suffit d’appuyer sur un bouton et le tiroir sort. Le singe appuie sur le bouton tout de suite, il prend les bonbons et s&#8217;en va et l&#8217;enfant reproduit. Il imite. Aristote avait raison&#160;: l&#8217;homme est un animal imitateur. Et pourquoi il imite&#160;? Parce qu&#8217;on ne sait jamais, il n&#8217;a peut être pas compris, il y a peut être quelque chose, il y a du sens quelque part. Il ne compte pas sur lui. Et donc si l&#8217;imitation est importante, il faut distinguer entre le modèle et l&#8217;exemple. Il y a des enfants qui ne peuvent dessiner que s&#8217;ils ont un modèle, c&#8217;est-à-dire ils ne savent pas dessiner. Et puis il y a ceux qui ont appris par l&#8217;exemple, qui ont compris le mouvement, qui ont compris comment on utilisait l&#8217;outil et qui vont se l&#8217;approprier. Et d&#8217;ailleurs on enseigne par l&#8217;exemple, on n&#8217;enseigne pas parce ce qu&#8217;on dit, on enseigne parce qu&#8217;on montre.</p>\n\n\n<p>Alors est-ce que l&#8217;informatique est dans une situation spéciale face à la question de l&#8217;enseignement. Je vais partir d&#8217;une formule de <a href=\"http://fr.wikipedia.org/wiki/Bernard_Lang\">Bernard Lang</a>, très très éclairant, je dois beaucoup à mon ami Bernard Lang sur cette question, il n&#8217;est pas enseignant mais il a tout compris. «&#160;Comme beaucoup de disciplines scientifiques, l’informatique est à la fois une science, une technologie de l&#8217;utilisation de cette science et un ensemble d&#8217;outils qu&#8217;elle permet de réaliser. Trois pas deux&#160;! Trois. La confusion entre ces trois aspects est une première source d’incompréhension et de désaccord. Cette confusion en particulier entre la science et la technologie.</p>\n\n\n<p>Alors on nous dit qu&#8217;il n&#8217;y pas besoin d&#8217;apprendre comment fonctionne une voiture pour apprendre à conduire. Et je voudrais revenir sur cette analogie avec l&#8217;automobile pour essayer de répondre à la question&#160;: est-ce que c&#8217;est si inutile que ça de soulever le capot&#160;? Et c&#8217;est vrai qu&#8217;on n&#8217;apprend pas la mécanique auto dans les écoles. Mais on apprend la physique. On apprend la science. On n&#8217;apprend pas la technologie. Et donc si on fait cette comparaison, on s’aperçoit qu&#8217;on n&#8217;a pas besoin de soulever le capot, mais on apprend aux enfants, à tous les enfants, pas simplement ceux qui seront garagistes, pas les esclaves garagistes, mais à tous ceux qui utiliseront des objets, on leur apprend un peu de mathématique, un peu de physique pour qu&#8217;ils puissent ne pas être piégés qu&#8217;ils puissant savoir que ce n&#8217;est pas le ventilateur qui a éteint les bougies, qu&#8217;ils puissent avoir une petite idée de ce qui se passe dans la machine, que ce n&#8217;est pas magique.</p>\n\n\n<p>Alors il y a 3 fractures numériques. Il y a une fracture numérique qui est très grave qui est celle de la naïveté de ceux qui croient que c&#8217;est magique, ceux qui ne comprennent rien, ceux qui jouent avec leur smartphone. Et puis en face il y a ceux qui comprennent, qui ne savent peut-être pas comment on fait mais qui savent comment ça marche. Qui savent quels sont les enjeux qui sont derrière.</p>\n\n\n<p>Après il y a une autre fracture qui est la fracture entre ceux qui savent utiliser mais qui ne font qu&#8217;utiliser et puis ceux qui maîtrisent, ceux qui fabriquent les logiciels, ceux qui fabriquent les applications. Ça c&#8217;est une autre fracture.</p>\n\n\n<p>Et puis il y a une fracture sur l’accès&#160;: est-ce qu&#8217;on a juste la possibilité d&#8217;utiliser ou pas. Je me souviens au <a href=\"http://fr.wikipedia.org/wiki/Sommet_mondial_sur_la_soci%C3%A9t%C3%A9_de_l%27information\">SMSI</a> à Genève puis à Tunis on nous avait expliqué que le problème de l&#8217;accès c&#8217;est d&#8217;abord l&#8217;électricité dans le monde&#160;; qu&#8217;avant d&#8217;avoir des ordinateurs et du réseau, il faut d&#8217;abord avoir de l&#8217;électricité. Alors ça calme tout le monde. Mais il n&#8217;y a pas besoin d&#8217;électricité pour, au tableau noir, expliquer ce que c&#8217;est que l&#8217;informatique.</p>\n\n\n<p>Donc il y a trois savoirs, 3 savoirs différents&#160;: il y a une compréhension des processus qui touchent à l&#8217;information, comment on produit l&#8217;information, comment on la code, comment on la transporte, comment on la traite, comment on l&#8217;exploite, qui peut avoir intérêt à l’exploiter. Cette science de l&#8217;information on la confond souvent avec un savoir-faire dans le domaine de la programmation effective, alors qu&#8217;on peut très bien apprendre en pseudo code de l’algorithmique théorique avec une craie et un tableau noir. On peut expliquer ce que c&#8217;est qu&#8217;un compilateur, sans avoir de machine, sans avoir à programmer à instancier dans un langage précis ce qu&#8217;on a compris comme algorithme. Et de ce point de vue là, c&#8217;est des maths. On devrait se poser la question&#160;: mais pourquoi continue t-on à enseigner des maths à des gens qui ne vont pas les utiliser&#160;? Ben évidemment c&#8217;est parce qu&#8217;on n&#8217;est pas dans une école de l&#8217;initiation où les mathématiciens font ça entre eux et on n&#8217;est pas non plus dans une école de l’apprentissage où l&#8217;école a pour but de donner un métier, un bagage utilisable. L&#8217;école ne sert évidemment pas à ça. D&#8217;ailleurs heureusement parce que sinon on n&#8217;enseignerait pas la philosophie qui ne sert à rien à part fabriquer des profs de philosophie&#160;! Enfin il y a une troisième savoir, qui est le savoir-faire dans le domaine des usages, j&#8217;aimerais bien écrire zzusages avec 2 z, où on est devant un savoir faire qui change sans arrêt, où on est simplement dans l&#8217;adaptation du consommateur à l&#8217;offre.</p>\n\n\n<p>On retrouve nos 3 écoles&#160;: l&#8217;école de la liberté, la science pour tous et là elle n&#8217;a pas besoin d&#8217;ordinateurs&#160;; l&#8217;école des maîtres, la technologie pour quelques-uns et puis l&#8217;école des esclaves, les usages pour le plus grand nombre. Avec 3 finalités différentes. Dans le premier cas on est formé à comprendre les fins, les buts. On ne sait pas coder mais on peut décider ce qui mérite d’être codé, ce qui doit être codé, ce qu’il faudrait coder, ce qu&#8217;il faut utiliser, ce qu&#8217;il ne faut pas utiliser&#160;; on peut décider.</p>\n\n\n<p>Les autres savoirs ont des finalités différentes. Elles sont non pas au niveau des fins, elles sont au niveau des moyens. On va former des codeurs. Alors il y a des tas de gens qui vous disent il faut former des informaticiens pour exister dans la compétition internationale. Sans doute, mais ce n&#8217;est pas le plus urgent. Et puis former des consommateurs qui savent s&#8217;adapter à ce qu&#8217;il y a, à ce qu&#8217;on leur vend. Et là il y a du monde&#160;! Il y a du monde pour conseiller les ministres, pour conseiller les gouvernements, pour conseiller les partis&#160;: vous comprenez bien, s&#8217;ils veulent faire des achats lucides, s&#8217;ils veulent choisir les bons produits, il faut les aider, il faut les initier tout de suite. Et d&#8217;ailleurs on vous organise des programmes quasiment gratuits, on vous fournit les machines. La première dose est gratuite&#160;!</p>\n\n\n<p>Alors le problème c&#8217;est qu&#8217;on ne peut plus se contenter d&#8217;un tableau noir. On est passé autour de 2004 du siècle de l’automobile au siècle de l&#8217;information. 2004 les investissements dans l&#8217;informatique et les nouvelles technologies ont dépassé les investissements dans l’automobile. On a quitté le siècle de l’automobile pour entrer dans le siècle de l’information. Au passage 2004 c&#8217;est aussi la date où le nombre de téléphones portables embarqués sur des machines a dépassé le nombre de téléphones portables embarqués sur les êtres humains. C&#8217;est bon à savoir, vos imprimantes, vos machines à café sont pleines de mobiles, il y en a plus dans les machines que sur vous. Ça aussi il faut y réfléchir. Alors on a 3 manières de faire entrer l&#8217;informatique à l&#8217;école. Je vous le disais on n&#8217;a pas besoin de tableau numérique pour enseigner l&#8217;informatique elle-même pour enseigner la science. De la même façon on n&#8217;a pas besoin de machine à calculer pour enseigner les mathématiques. Évidemment&#160;! On n&#8217;a pas besoin d&#8217;une machine à calculer pour savoir faire une division. Au contraire, surtout pas&#160;! On peut aussi enseigner l&#8217;informatique comme technologie, apprendre à programmer, à gérer les réseaux et on peut aussi se contenter d&#8217;utiliser, apprendre l’utilisation dans les fameuses <a href=\"http://fr.wikipedia.org/wiki/Technologies_de_l&#039;information_et_de_la_communication_pour_l&#039;enseignement\">TICE</a>. Seulement on n&#8217;a plus le choix&#160;! On n&#8217;a plus le choix parce qu&#8217;arrive la vague de ce qu&#8217;on appelle le numérique, c&#8217;est-à-dire que tous les savoirs sont maintenant numérisés et que le tableau noir et bien il va falloir résister pour n&#8217;utiliser que le tableau et on va devoir utiliser le numérique, alors ça pose problème.</p>\n\n\n<p>Déjà je m’arrête un instant, on a dépassé un fait de base. Il faut cesser d&#8217;opposer l&#8217;enseignement de la programmation d&#8217;une part et l&#8217;enseignement des usages, c&#8217;est important mais ça c&#8217;est l’école des maîtres et des esclaves. Ce qu&#8217;il faut enseigner, vite et à tous, c&#8217;est la science, pas la technologie ou l&#8217;usage. C&#8217;est en amont de la programmation, l&#8217;algorithmique. C&#8217;est, en amont de telle instanciation, du codage, du chiffrement, la théorie, quelque chose qui comme les maths n&#8217;ont besoin que d&#8217;une craie et d&#8217;un tableau noir.</p>\n\n\n<p>Seulement le numérique arrive et on ne peut plus se contenter d&#8217;un tableau noir. Il paraît que le numérique est partout, que tous les supports de transmission de l&#8217;information et tous les supports d&#8217;information sont maintenant numérisés. Et donc ça pose un problème très particulier. Ça pose un problème particulier parce qu&#8217;il y a une interaction très forte entre les trois. Comme si on devait enseigner la physique dans une voiture, si je reprends l&#8217;analogie. On peut enseigner la physique avec un tableau noir, mais là dans le cas de l’informatique, il faut enseigner la physique dans une voiture. Autrement dit l&#8217;école est le lieu, l&#8217;enjeu d&#8217;un affrontement colossal entre ceux qui voudraient ceux qui voudraient qu&#8217;elle reste l&#8217;école de la liberté et ceux qui voudraient en faire autre chose, une école qui serait cliente captive d&#8217;un marché, des industries numériques pour l&#8217;éducation. Parce que la technologie elle englobe les usages et il faudrait qu&#8217;on enseigne la science dans cette espèce de gangue, dans cette espèce de caverne où on vous projette des ombres avec des matériels particuliers, avec des formats particuliers. Comment faire&#160;? Comment essayer de rester honnête et faire correctement les choses. La caverne est revenue&#160;!</p>\n\n\n<p>Alors je vais citer une deuxième fois Marx, il n&#8217;y a plus que les libéraux pour citer Marx aujourd&#8217;hui&#160;: «&#160;Les armes de la critique passent par la critique des armes.&#160;» C&#8217;est hors contexte, car c’était dans la <a href=\"http://fr.wikipedia.org/wiki/Critique_de_la_philosophie_du_droit_de_Hegel\">Critique de la philosophie du droit de Hengel</a>, ça n&#8217;a rien à voir mais la phrase est pratique.</p>\n\n\n<p>On peut difficilement enseigner la liberté avec des outils qui cherchent à dominer. Ça va être compliqué d&#8217;utiliser des outils qui sont faits pour ne pas être partagés pour apprendre à des élèves à partager. Ça va être compliqué d&#8217;enseigner à des élèves comment il faut protéger ses données en utilisant des réseaux sociaux qui sont faits pour justement les capturer. Bref apprendre l’ouverture avec ce qui est fait pour fermer, c&#8217;est compliqué. Donc on est dans une impasse, dans une contradiction. Alors je vais prendre la formule de Bernard Lang. Il encourageait à réfléchir sur les risques potentiels de ces nouveaux modes de médiation dans l&#8217;appréhension de la connaissance. Le numérique devient la médiation pour apprendre la science qui est amont du numérique. On doit enseigner la physique dans la voiture. Et vous le savez quand le sage montre la lune, l&#8217;ignorant regarde le doigt. Il n&#8217;entend pas ce qu&#8217;on lui dit. Les enfants ne regardent pas ce qu&#8217;il y a sous l&#8217;ordinateur, ils regardent l&#8217;ordinateur. Ils ne regardent pas ce qu&#8217;ils ont à lire, ils regardent la manipulation, ils ne savent pas ce qu&#8217;il y a à regarder.</p>\n\n\n<p>Alors je vais prendre quelques exemples taquins. Premier exemple taquin&#160;: on fait une exposition sur les OGM, on mange bio à la cantine, pardon, au restaurant scolaire, mais par contre on fait l&#8217;affiche de l&#8217;exposition sur Mac ou sous Windows. Cherchez l&#8217;erreur. Il y a un petit souci. Je disais à une syndicaliste, vous aurez du mal à faire la révolution avec Word. Elle n&#8217;a pas compris&#160;! J’avais été invité à une université d&#8217;été d&#8217;Attac, c&#8217;était assez bizarre un libéral invité à Attac et là je leur avais dit «&#160;Je ne vais plus au MacDo mais vous êtes encore sous Windows&#160;».</p>\n\n\n<p>Deuxième exemple taquin, toujours à l&#8217;école. L&#8217;école est l&#8217;endroit où on dit le plus de mal de Wikipédia, il faut le savoir. Par contre on dit beaucoup de bien de Diderot, de l&#8217;Encyclopédie, du siècle des Lumières. Embêtant quand même, parce que moi je suis persuadé que Diderot adorerait Wikipédia. Mais il n’adorerait pas Wikipédia pour lire mais pour écrire dedans. Il ne s&#8217;agit pas d&#8217;apprendre aux enfants à se méfier de ce qu&#8217;on lit dans Wikipédia, il faut leur apprendre à écrire dans Wikipédia. Mais ça il faut du temps.</p>\n\n\n<p>Troisième exemple taquin&#160;: le tableau numérique interactif&#160;; ça c&#8217;est la catastrophe, l&#8217;absurdité totale. Avec une craie et un tableau noir, je suis à égalité avec un élève. Il va au tableau, il prend la craie&#160;; la craie c&#8217;est du calcaire, c&#8217;est comme dans son jardin. L&#8217;ardoise, il y en a sur son toit. Il n&#8217;y a pas d’interface technologique qui le sépare du savoir. Avec le tableau numérique interactif, Pythagore est de retour&#160;! Vous ne pourrez faire des mathématiques simples, poser une division, que si vous disposez d&#8217;une interface extrêmement compliquée, si vous avez du 220, si vous avez du réseau, sinon la division va être compliquée. J’ai le souvenir de professeurs de physique qui pour étudier la chute des corps prenaient une capture avec une caméra numérique de l&#8217;objet qui tombait, moulinait ça, détection de mouvement et ensuite tout ça apparaissait dans un tableur avec quelques lignes. Je leur avais expliqué qu&#8217;avec une feuille de papier de chocolat, une prise RS232, on arrivait à faire beaucoup plus précis, 400&#160;000 fois par seconde, mais non ce n&#8217;était pas bien, il fallait du dispositif&#160;!</p>\n\n\n<p>Alors il y a des alternatives. Il y a une alternative qui essaye d&#8217;exploiter les outils numériques mais de manière intelligente. Par exemple prenez un smartphone et vous le connectez à votre PC de classe, il projette ça avec un vidéo-projecteur et puis vous transportez le tableau numérique interactif, vous le posez sur la table de l&#8217;élève, il peut écrire, c&#8217;est le même que son smartphone, c&#8217;est l&#8217;ardoise et la craie. Il n&#8217;y a de <a href=\"http://fr.wikipedia.org/wiki/Tableau_blanc_interactif\">TNI</a> chez lui mais il a aussi peut être un smartphone et puis là tout le monde peut écrire dessus. Voilà.</p>\n\n\n<p>On peut arriver à subvertir ces médiations pour trouver plus intelligent. Alors je vais revenir au logiciel libre. L&#8217;école a tout à apprendre de la culture des hackers. Il faut apprendre à travailler comme des hackers. Nietzsche a une formule magnifique il dit «&#160;Plutôt périr que travailler sans joie&#160;». On peut vouloir travailler comme un maître ou travailler comme un esclave. On peut aussi faire de sa vie quelque chose de plus joyeux, aimer son travail. On peut apprendre à aimer son travail à l&#8217;école. On peut apprendre à exister par la valeur de ce qu&#8217;on fait, par la valeur de ce qu&#8217;on montre, par l&#8217;image qu&#8217;on a, et pour ça, et bien le logiciel libre pourrait nous aider pour refonder l&#8217;école, pour apprendre à collaborer, pour apprendre à partager, pour apprendre à bricoler, produire ses propres outils, se former, se former sans cesse, être en veille permanente.</p>\n\n\n<p>Toutes ces qualités qui sont celles des hackers ce sont celles qu&#8217;on attend d&#8217;un élève. Et donc il y a bien des rapports entre l&#8217;école les outils, les contenus. Mais pas simplement sur l&#8217;utilisation du logiciel libre. Puisque le numérique est partout, il n&#8217;y a vraiment plus que 2 écoles possibles&#160;: soit l&#8217;école programmée, c&#8217;est pour ça que j&#8217;avais sous-titré cette conférence «&#160;Programmer ou être programmé&#160;», c&#8217;est la devise des hackers. Soit l&#8217;école programmée. Le numérique sera partout dans le système éducatif, il sera désormais impossible de réguler quoi que ce soit, l’école sera un client captif. Les outils, les contenus seront produits par une sorte d’industrie numérique qui sera complètement extérieure à l&#8217;école et qui va lui dicter sa loi, qui va la transformer en autre chose.</p>\n\n\n<p>Soit l&#8217;école de la liberté. Mais pour ça il faudra utiliser une technologie et des usages qui permettent d&#8217;enseigner la science de l&#8217;informatique. Autrement dit, la question n&#8217;est pas d&#8217;utiliser le logiciel libre, ce n&#8217;est pas la question. On ne peut utiliser que ce qui existe, ce n&#8217;est déjà pas beaucoup. Il s&#8217;agit de développer les logiciels libres dont a besoin l&#8217;école. Il s&#8217;agit de produire des contenus, partagés, qui pourraient être produits par des enseignants, ils sont quand même mieux placés que d&#8217;autres pour les produire, mais de manière collaborative pour libérer l&#8217;école de cette menace de l&#8217;industrie numérique éducative. Au passage, l&#8217;argent public pourrait être mieux utilisé qu&#8217;en achetant des produits qui en général sont faits par les mêmes enseignants mais avec une autre casquette.</p>\n\n\n<p>Alors je reviens à Marx. Au 19ème siècle, il avait posé une bonne question&#160;: «&#160;À qui appartiennent les moyens de production&#160;?&#160;» Et bien les moyens de production des contenus et des outils de l&#8217;école doivent appartenir à l&#8217;école. Donc la question du logiciel libre n&#8217;est pas une petite question, c&#8217;est la question même de l&#8217;école. Et la question n&#8217;est pas à l&#8217;utilisation. C&#8217;est de se mettre à l&#8217;école de ce mode de production, pour produire les savoirs, les contenus, pour rendre possible une éducation, une instruction des élèves qui leur permette d&#8217;accéder à la liberté, non par la technologie ou par les usages, mais par la science.</p>\n\n\n<p>Je vous remercie.</p>\n<div class=\"footnotes\"><h4>Notes</h4>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/11/francois-elie-education-conference#rev-pnote-1645-1\" id=\"pnote-1645-1\">1</a>] François Elie <a href=\"http://www.framablog.org/index.php/tag/Elie\">sur le Framabog</a>.</p>\n<p>[<a href=\"http://www.framablog.org/index.php/post/2013/06/11/francois-elie-education-conference#rev-pnote-1645-2\" id=\"pnote-1645-2\">2</a>] <a href=\"http://wiki.april.org/w/Ecole_societe_information_Fran%C3%A7ois_Elie\">URL d&#8217;origine</a> de la transcription avec les questions réponses en bonus.</p></div>\n          ','SHA1:00aec625cc3d845da8aa4f2e897924afe0d34cf6','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(19,'Sensibilisation ou propagande ? Quand Hadopi souhaite s\'incruster dans nos écoles','SHA1:72eb5c644ca55b73894da22904322a85d83185d0','http://www.framablog.org/index.php/post/2013/06/10/hadopi-education','2013-06-10 15:00:00','\n\n      \n      	   <p>On nous a fait parvenir cette lettre d&#8217;un responsable d&#8217;Hadopi qui ne perd pas de temps et souhaite s&#8217;inviter dans l&#8217;Éducation nationale en animant des ateliers de «&#160;sensibilisation&#160;» en direction des professeurs et des élèves. Pour ce faire (et c&#8217;est malin), on contacte les personnes en charge de la <a href=\"http://fr.wikipedia.org/wiki/Conseil_des_d%C3%A9l%C3%A9gu%C3%A9s_pour_la_vie_lyc%C3%A9enne\">vie lycéenne</a> dans les rectorats.</p>\n\n\n<p>Nous nous sommes dits que cela pouvait vous intéresser&#8230;</p>\n\n\n<p><em>N&#8217;hésitez pas à manifester votre approbation ou réprobation dans les commentaires ;)</em></p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/jayneandd_cc-by.jpg\" alt=\"Jayneandd - CC by\" style=\"display:block; margin:0 auto;\" title=\"Jayneandd - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Lettre d&#8217;Hadopi</h3>\n\n\n<p>Madame la déléguée,</p>\n\n\n<p>Hier, mercredi 5 juin, l&#8217;Assemblée nationale a adopté définitivement le projet de loi d&#8217;orientation et de programmation pour la refondation de l&#8217;école de la République.</p>\n\n\n<p>Ce texte est porteur d&#8217;un formidable élan pour le numérique à l&#8217;école.</p>\n\n\n<p>Il modifie notamment la rédaction de l&#8217;article L. 312-9 du code de l&#8217;éducation qui prévoit désormais que la formation à l&#8217;utilisation des outils et des ressources numériques «&#160;comporte une sensibilisation aux droits et aux devoirs liés à l&#8217;usage de l&#8217;internet et des réseaux, dont la protection de la vie privée et le respect de la propriété intellectuelle&#160;».</p>\n\n\n<p>Il précise également que la prise en compte du numérique sera inscrite dans les plans académiques et nationaux de formation des enseignants et des corps d&#8217;inspection et d&#8217;encadrement.</p>\n\n\n<p>Dans ce contexte, l’Hadopi souhaite contribuer à l’information et à la sensibilisation de la communauté éducative et des élèves au droit d’auteur et à la création artistique.</p>\n\n\n<p>Aussi, nous vous proposons d&#8217;animer au sein de votre académie un atelier de sensibilisation à l&#8217;attention des enseignants, référents TICE, documentalistes et personnel d&#8217;encadrement. Ces ateliers sont composés de différents modules pédagogiques qui visent à apporter à la communauté éducative un éclairage clair et précis sur des enjeux relatifs au droit d’auteur, à la création artistique et aux usages responsables sur Internet mais aussi à répondre à des questions concrètes auxquelles les enseignants sont confrontés dans le cadre de leurs enseignements. Si ce projet vous paraît utile, nous vous proposerons de choisir parmi les 10 modules que nous proposons ceux qui paraissent le plus adaptés aux besoins dans votre académie.</p>\n\n\n<p>Par ailleurs, nous vous proposons également d&#8217;animer un atelier d&#8217;information destiné aux élèves de collège / lycée, avec la possibilité éventuelle d&#8217;inviter un artiste à présenter son métier et la chaîne de création artistique.</p>\n\n\n<p>Je me tiens à votre entière disposition pour vous apporter tout renseignement complémentaire et vous prie, Madame la déléguée, d&#8217;agréer l&#8217;expression de mes salutations distinguées.</p>\n\n\n<p>XXX</p>\n\n\n<p>Hadopi<br />\n4 rue du Texel<br />\n75014 Paris</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/jayneandd/4849107531/\">Jayneandd</a> (Creative Commons By)</em></p>          ','SHA1:cc0cbdcb1e2db8c3787e6855c716b9a5fee47aab','',0,'2013-06-24 11:54:00','2013-06-24 13:48:45',0,'','','aKa'),(20,'Des milliers de morts, des millions privés de libertés civiles ? Stallman (2001)','SHA1:6da23e3a700b827620d612cefb3d1d57e6ccb90d','http://www.framablog.org/index.php/post/2013/06/09/stallman-2001','2013-06-09 13:53:00','\n\n      \n      	   <p>À l&#8217;heure où les USA sont empêtrés dans <a href=\"http://www.ecrans.fr/NSA-FBI-pour-espionner-le-monde,16499.html\">une sombre histoire d&#8217;espionnage généralisé à grande échelle</a>, il nous a paru intéressant de déterrer et traduire un article de <a href=\"http://www.framablog.org/index.php/tag/Stallman\">Richard Stallman</a> rédigé en 2001 juste après le 11 septembre.</p>\n\n\n<p>Force est de reconnaître qu&#8217;une fois de plus il avait pressenti les conséquences néfastes que nous subissons aujourd&#8217;hui.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/sigg3net_cc-by.jpg\" alt=\"Sigg3net - CC by\" style=\"display:block; margin:0 auto;\" title=\"Sigg3net - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Des milliers de morts, des millions privés de libertés civiles&#160;?</h3>\n\n\n<p><strong><a href=\"http://stallman.org/millions.html\">Thousands dead, millions deprived of civil liberties?</a></strong></p>\n\n\n<p><em>Richard Stallman - 2001 - Site personnel</em><br />\n<em>(Traduction&#160;: Lamessen, Slystone, Sky, Amine Brikci-N, Asta)</em></p>\n\n\n<p>Dans de nombreux cas, les dommages les plus sévères que cause une lésion nerveuse sont secondaires&#160;; ils se produisent dans les heures qui suivent le traumatisme initial, car la réaction du corps à ces dommages tue davantage de cellules nerveuses. Les chercheurs commencent à découvrir des façons de prévenir ces lésions secondaires et réduire les dommages ultimes.</p>\n\n\n<p>Si nous ne faisons pas attention, les attaques meurtrières sur New York et Washington vont conduire à des effets secondaires bien pire encore, si le congrès étasunien adopte des «&#160;mesures préventives&#160;» qui écartent la liberté que l&#8217;Amérique représente.</p>\n\n\n<p>Je ne parle pas de fouilles dans les aéroports ici. Les fouilles de personnes ou de bagages, tant qu&#8217;ils ne cherchent pas autre chose que des armes et ne gardent pas de traces de ces fouilles, est juste un désagrément&#160;: elles ne mettent pas en danger vos libertés civiles. C&#8217;est la surveillance massive de tous les aspects de nos vies qui m&#8217;inquiète&#160;: de nos appels téléphoniques, nos courriels et nos déplacements physiques.</p>\n\n\n<p>Ces mesures sont susceptibles d&#8217;être recommandées indépendamment du fait qu&#8217;elles seraient efficaces pour leur objectif déclaré. Un dirigeant d&#8217;une entreprise développant un logiciel de reconnaissance faciale est dit avoir annoncé à des journalistes que le déploiement massif de caméras embarquant un système de reconnaissance faciale aurait empêché les attaques. Le New York Times du 15 septembre cite un congressiste prônant cette  «&#160;solution&#160;». Étant donné que la reconnaissance humaine du visage effectuée par les agents d&#8217;accueil n&#8217;a pas permis de stopper les pirates, il n&#8217;y a pas de raison de penser que les caméras à reconnaissance faciale informatisée aurait été d&#8217;une quelconque aide. Mais cela n&#8217;arrête pas les agences qui ont toujours voulu mettre en place plus de surveillance de pousser ce plan aujourd&#8217;hui, ainsi que beaucoup d&#8217;autres plans similaires. Il faudra l&#8217;opposition du public pour les stopper.</p>\n\n\n<p>Encore plus inquiétant, une <a href=\"http://www.wired.com/news/politics/0,1283,46816,00.html\">proposition</a> visant à exiger des portes dérobées gouvernementales dans les logiciels de chiffrement a déjà fait son apparition.</p>\n\n\n<p>Pendant ce temps, le Congrès s&#8217;est empressé de voter une résolution donnant à Bush les pleins pouvoirs d&#8217;utilisation de la force militaire en représailles des attaques. Les représailles peuvent être justifiées, si les auteurs des attaques peuvent être identifiés et ciblés avec soin, mais le Congrès a le devoir d&#8217;examiner les mesures spécifiques lorsqu&#8217;elles sont proposées. Donner carte blanche au président dans un moment de colère est exactement l&#8217;erreur qui a conduit les États-Unis dans la guerre du Vietnam.</p>\n\n\n<p>S&#8217;il vous plait, laissez vos représentants élus et votre président non élu savoir que vous ne voulez pas que vos libertés civiles deviennent les prochaines victimes du terrorisme. N&#8217;attendez pas, Les lois sont déjà en cours d&#8217;écriture.</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/sigg3net/3305369446/\">Sigg3net</a> (Creative Commons By)</em></p>          ','SHA1:1fdd2d9789bcff40d950e465fc6cfb53de55f8cc','',0,'2013-06-24 11:54:00','2013-06-24 12:38:33',0,'','','aKa'),(21,'Quelle entreprise peut encore faire confiance à Microsoft ? par Glyn Moody','SHA1:dbec1df64edd5fd6987fd602077d4ced76932c7a','http://www.framablog.org/index.php/post/2013/06/24/microsoft-confiance-entreprise','2013-06-24 12:16:00','\n\n      \n      	   <p>Le titre se suffit à lui-même ici. On pourrait ajouter aux entreprises, les institutions et les particuliers, bref tout le monde.</p>\n\n\n<p>Non content d&#8217;avoir été accusé par le passé de réserver dans Windows des <a href=\"http://fr.wikipedia.org/wiki/Porte_d%C3%A9rob%C3%A9e\">portes dérobées</a> à la NSA, non content d&#8217;être fortement suspecté de laisser les autorités américaines collecter nos données dans Skype, Microsft est maintenant soupçonné de différer la publication de ses <a href=\"http://fr.wikipedia.org/wiki/Patch_(informatique)\">patchs</a> de sécurité pour en informer d&#8217;abord les mêmes autorités américaines&#160;!</p>\n\n\n<p>Tout <a href=\"http://fr.wikipedia.org/wiki/Directeur_des_syst%C3%A8mes_d%27information\">DSI</a> normalement constiué(e) devrait lire cet article et en tirer avec sa direction ses propres conclusions.</p>\n\n\n<p><br /></p>\n\n\n<p><img src=\"http://www.framablog.org/public/_img/flickr/cambodia4kidsorg.jpg\" alt=\"Cambodia4kidsorg - CC by\" style=\"display:block; margin:0 auto;\" title=\"Cambodia4kidsorg - CC by\" /></p>\n\n\n<p><br /></p>\n\n\n<h3>Quelle entreprise peut encore faire confiance à Microsoft&#160;?</h3>\n\n\n<p><strong><a href=\"http://blogs.computerworlduk.com/open-enterprise/2013/06/how-can-any-company-ever-trust-microsoft-again/\">How Can Any Company Ever Trust Microsoft Again?</a></strong></p>\n\n\n<p><em>Glyn Moddy - juin 2013 - Open Enterprise (Computer World)</em><br />\n<em>(Traduction&#160;: Slystone, Luo, lamessen, Antoine, sinma, Pouhiou, Sky, Fe-lor, aKa, Asta, audionuma + anonymes)</em></p>\n\n\n<p>Quels que soient les détails des récentes révélations sur l&#8217;espionnage de masse de la part des États-Unis fournis par <a href=\"http://fr.wikipedia.org/wiki/Edward_Snowden\">Edward Snowden</a> dans le Guardian, il y a déjà un énorme bénéfice collatéral. D&#8217;un côté, le gouvernement des États-Unis se replie sur lui-même, niant certaines allégations en offrant sa propre version de l&#8217;histoire. Cela, et pour la première fois, nous donne des détails officiels sur des programmes dont nous n&#8217;étions (au mieux) informés que par fuites et rumeurs, voire pas du tout. De plus, la précipitation indécente et l&#8217;histoire sans cesse changeante des autorités américaines est une confirmation, si elle était encore nécessaire, que ce que Snowden a révélé est important — vous ne provoquez pas un tel tapage pour rien.</p>\n\n\n<p>Mais peut-être encore plus crucial, d&#8217;autres journalistes, poussés par la honte et leur culpabilisation, ont finalement posé des questions qu&#8217;ils auraient dû poser des années voire des décennies plus tôt. Cela a abouti à une série d&#8217;articles extrêmement intéressants à propos de l&#8217;espionnage de la NSA, dont beaucoup contiennent des informations auxiliaires qui sont aussi intéressantes que l&#8217;histoire principale. Voici <a href=\"http://www.bloomberg.com/news/2013-06-14/u-s-agencies-said-to-swap-data-with-thousands-of-firms.html\">un bel exemple</a> de ce qui est apparu durant le week-end sur le site de Bloomberg.</p>\n\n\n<p>Entre autres choses, il s&#8217;agit de Microsoft, et d&#8217;évaluer dans quelle mesure ils ont aidé la NSA à espionner le monde. Bien sûr, cette crainte n&#8217;est pas nouvelle. Dès 1999, <a href=\"http://www.heise.de/tp/artikel/5/5263/1.html\">il était déjà dit</a> que des portes dérobées avaient été codées dans Windows&#160;:</p>\n\n\n<blockquote><p>Une erreur d&#8217;inattention de programmeurs Microsoft a révélé qu&#8217;un code d&#8217;accès spécial préparé par l&#8217;agence nationale de sécurité étasunienne (NSA) avait été secrètement implémenté dans Windows. Le système d&#8217;accès de la NSA est implémenté sous toutes les versions de Windows actuellement utilisées, à l&#8217;exception des premières versions de Windows 95 (et ses prédécesseurs). La découverte suivait de près les révélations survenues un peu plus tôt cette année concernant un autre géant du logiciel étasunien, Lotus, qui avait implémenté une trappe «&#160;d&#8217;aide à l&#8217;information&#160;» pour la NSA dans son système Notes. Des fonctions de sécurité dans d&#8217;autres logiciels systèmes avaient été délibérément paralysées.</p></blockquote>\n\n\n<p>Plus récemment, il y eut des craintes au sujet de Skype, <a href=\"http://www.guardian.co.uk/technology/2011/may/10/microsoft-buys-skype-biggest-gamble-yet\">racheté par Microsoft</a> en mai 2011. En 2012, il y a eu des <a href=\"http://www.forbes.com/sites/anthonykosner/2012/07/18/did-microsoft-change-the-architecture-of-skype-to-make-it-easier-to-snoop/\">discussions</a> pendant lesquelles on s’est demandé si Microsoft avait changé l’architecture de Skype pour rendre l’espionnage plus facile (l’entreprise a même un brevet sur l’idée). Les récentes fuites semblent confirmer que ces craintes étaient bien fondées, comme le <a href=\"http://www.slate.com/blogs/future_tense/2013/06/13/nsa_surveillance_leaks_suggest_microsoft_may_have_misled_public_on_skype.html\">signale</a> Slate&#160;:</p>\n\n\n<blockquote><p>Le scoop du Washington Post sur PRISM et ses possibilités présente plusieurs points frappants, mais pour moi un en particulier s&#8217;est démarqué du reste. The Post, citant une diapositive Powerpoint confidentielle de la NSA, a écrit que l&#8217;agence avait un guide d&#8217;utilisation spécifique «&#160;pour la collecte de données Skype dans le cadre du programme PRISM&#160;» qui met en évidence les possibilités d&#8217;écoutes sur Skype «&#160;lorsque l&#8217;un des correspondants utilise un banal téléphone et lorsque deux utilisateurs du service réalisent un appel audio, vidéo, font du chat ou échangent des fichiers.&#160;»</p></blockquote>\n\n\n<p>Mais même cela devient dérisoire comparé aux <a href=\"http://www.bloomberg.com/news/2013-06-14/u-s-agencies-said-to-swap-data-with-thousands-of-firms.html\">dernières informations</a> obtenues par Bloomberg&#160;:</p>\n\n\n<blockquote><p>D&#8217;après deux personnes qui connaissent bien le processus, Microsoft, la plus grande compagnie de logiciels au monde, fournit aux services de renseignement des informations sur les bogues dans ses logiciels populaires avant la publication d’un correctif. Ces informations peuvent servir à protéger les ordinateurs du gouvernement ainsi qu&#8217;à accéder à ceux de terroristes ou d&#8217;armées ennemies.</p>\n<p>\nLa firme de Redmond basée à Washington, Microsoft, ainsi que d&#8217;autres firmes œuvrant dans le logiciel ou la sécurité, était au courant que ce genre d&#8217;alertes précoces permettaient aux États-Unis d&#8217;exploiter des failles dans les logiciels vendus aux gouvernements étrangers, selon deux fonctionnaires d&#8217;État. Microsoft ne demande pas et ne peut pas savoir comment le gouvernement utilise de tels tuyaux, ont dit les fonctionnaires, qui ne souhaitent pas que leur identité soit révélée au vu de la confidentialité du sujet.</p>\n<p>\nFrank Shaw, un porte-parole de Microsoft, a fait savoir que ces divulgations se font en coopération avec d&#8217;autres agences, et sont conçues pour donner  aux gouvernements «&#160;une longueur d&#8217;avance&#160;» sur l&#8217;évaluation des risques et des <a href=\"http://fr.wikipedia.org/wiki/Mitigation\">mitigations</a>.</p></blockquote>\n\n\n<p>Réfléchissons-y donc un moment.</p>\n\n\n<p>Des entreprises et des gouvernements achètent des logiciels à Microsoft, se reposant sur la compagnie pour créer des programmes qui sont sûrs et sans risque. Aucun logiciel n&#8217;est complètement exempt de bogues, et des failles sérieuses sont trouvées régulièrement dans le code de Microsoft (et dans l&#8217;open source, aussi, bien sûr). Donc le problème n&#8217;est pas de savoir si les logiciels ont des failles, tout bout de code non-trivial en a, mais de savoir comment les auteurs du code réagissent.</p>\n\n\n<p>Ce que veulent les gouvernements et les compagnies, c&#8217;est que ces failles soient corrigées le plus vite possible, de manière à ce qu&#8217;elles ne puissent pas être exploitées par des criminels pour causer des dégâts sur leurs systèmes. Et pourtant, nous apprenons maintenant que l&#8217;une des premières choses que fait Microsoft, c&#8217;est d&#8217;envoyer des informations au sujet de ces failles à de multiples agences, en incluant sans doute la NSA et la CIA. En outre, nous savons aussi que «&#160;ce type d&#8217;alerte précoce a permis aux U.S.A. d&#8217;exploiter des failles dans les logiciels vendus aux gouvernements étrangers&#160;»</p>\n\n\n<p>Et rappelez-vous que «&#160;gouvernements étrangers&#160;» signifie ceux des pays européens aussi bien que les autres (le fait que le gouvernement du Royaume-Uni ait <a href=\"http://www.guardian.co.uk/uk/2013/jun/16/gchq-intercepted-communications-g20-summits\">espionné</a> des pays «&#160;alliés&#160;» souligne que tout le monde le fait). Il serait également naïf de penser que les agences de renseignement américaines exploitent ces failles «&#160;jour 0&#160;» seulement pour pénétrer dans les systèmes des gouvernements&#160;; l&#8217;espionnage industriel représentait une partie de l&#8217;ancien <a href=\"http://en.wikipedia.org/wiki/ECHELON#Controversy\">programme de surveillance Echelon</a>, et il n&#8217;y a aucune raison de penser que les U.S.A. vont se limiter aujourd&#8217;hui (s&#8217;il y a eu un changement, les choses ont empiré).</p>\n\n\n<p>Il est donc fortement probable que les faiblesses des produits Microsoft soient régulièrement utilisées pour s&#8217;infiltrer et pratiquer toutes sortes d&#8217;espionnage dans les gouvernements et sociétés étrangères. Ainsi, chaque fois qu&#8217;une entreprise installe un nouveau correctif d&#8217;une faille majeure provenant de Microsoft, il faut garder à l&#8217;esprit que quelqu&#8217;un a pu avoir utilisé cette faiblesse à des fins malveillantes.</p>\n\n\n<p>Les conséquences de cette situation sont très profondes. Les entreprises achètent des produits Microsoft pour plusieurs raisons, mais toutes supposent que la compagnie fait de son mieux pour les protéger. Les dernières révélations montrent que c’est une hypothèse fausse&#160;: Microsoft transmet consciencieusement et régulièrement des informations sur la manière de percer les sécurités de ses produits aux agences américaines. Ce qui arrive à ces informations plus tard est, évidemment, un secret. Pas à cause du «&#160;terrorisme&#160;», mais parce qu’il est presque certain que des attaques illégales sont menées contre d’autres pays (et leurs entreprises) en dehors des États-Unis.</p>\n\n\n<p>Ce n’est rien d’autre qu’une trahison de la confiance que les utilisateurs placent en Microsoft, et je me demande comment un responsable informatique peut encore sérieusement recommander l’utilisation de produits Microsoft maintenant que nous sommes presque sûrs qu&#8217;ils sont un vecteur d’attaques par les agences d’espionnage américaines qui peuvent potentiellement causer d’énormes pertes aux entreprises concernées (comme ce qui est arrivé avec Echelon).</p>\n\n\n<p>Mais il y a un autre angle intéressant. Même si peu de choses ont été écrites à ce sujet — même par moi, à ma grande honte — un nouvel accord législatif portant sur les attaques en ligne est en cours d’élaboration par l’Union Européenne. Voici <a href=\"http://www.europarl.europa.eu/sides/getDoc.do?pubRef=-%2f%2fEP%2f%2fTEXT%2bIM-PRESS%2b20130603IPR11005%2b0%2bDOC%2bXML%2bV0%2f%2fEN&amp;language=EN\">un aspect</a> de cet accord&#160;:</p>\n\n\n<blockquote><p>Ce texte demandera aux États membres de fixer leur peine maximale d’emprisonnement à au moins deux ans pour les crimes suivants&#160;: accéder à ou interférer illégalement avec des systèmes d’informations, interférer illégalement avec les données, intercepter illégalement des communications ou produire et vendre intentionnellement des outils utilisés pour commettre ces infractions.</p></blockquote>\n\n\n<p>«&#160;Accéder ou interférer illégalement avec des systèmes d’informations&#160;» semble être précisément ce que le gouvernement des États-Unis fait aux systèmes étrangers, dont probablement ceux de l’Union Européenne. Donc, cela indiquerait que le gouvernement américain va tomber sous le coup de ces nouvelles réglementations. Mais peut-être que Microsoft aussi, car c’est lui qui en premier lieu a rendu possible l’«&nbsp;accès illégal&#160;».</p>\n\n\n<p>Et il y a un autre aspect. Supposons que les espions américains utilisent des failles dans les logiciels de Microsoft pour entrer dans un réseau d&#8217;entreprise et y espionner des tiers. Je me demande si ces entreprises peuvent elles-mêmes se trouver accusées de toute sorte d&#8217;infractions dont elles ne savaient rien&#160;; et finir au tribunal. Prouver son innocence ici risque d&#8217;être difficile, car en ce cas les réseaux d&#8217;entreprise seraient effectivement utilisés pour espionner.</p>\n\n\n<p>Au final, ce risque est encore une autre bonne raison de ne jamais utiliser des logiciels de Microsoft, avec toutes les autres qui ont été écrites ici ces dernières années. Ce n&#8217;est pas uniquement que l&#8217;open source est généralement moins cher (particulièrement si vous prenez en considération le prix de l’enfermement livré avec les logiciels Microsoft), mieux écrit, plus rapide, plus sûr et plus sécurisé. Mais par-dessus tout, le logiciel libre respecte ses utilisateurs, les plaçant solidement aux commandes.</p>\n\n\n<p>Cela vous ôte toute crainte que l&#8217;entreprise vous ayant fourni un programme donne en secret à des tiers la possibilité de retourner contre vous ce logiciel que vous avez payé assez cher. Après tout, la plupart des résolutions des bogues dans l&#8217;open source est effectuée par des codeurs qui ont un peu d&#8217;amour pour l&#8217;autorité verticale, de sorte que la probabilité qu&#8217;ils donnent régulièrement les failles à la NSA, comme le fait Microsoft, doit être extrêmement faible.</p>\n\n\n<p><em>Crédit photo&#160;: <a href=\"http://www.flickr.com/photos/cambodia4kidsorg/4645032158/\">Cambodia4kidsorg</a> (Creative Commons By)</em></p>          ','SHA1:5856328c89f902c6b6695f4434cb4c9b3cac9612','',0,'2013-06-24 13:48:00','2013-06-24 13:48:45',0,'','','aKa');
/*!40000 ALTER TABLE `ttrss_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_entry_comments`
--

DROP TABLE IF EXISTS `ttrss_entry_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_entry_comments` (
  `id` int(11) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  `private` tinyint(1) NOT NULL DEFAULT '0',
  `date_entered` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ref_id` (`ref_id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_entry_comments`
--

LOCK TABLES `ttrss_entry_comments` WRITE;
/*!40000 ALTER TABLE `ttrss_entry_comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_entry_comments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_error_log`
--

DROP TABLE IF EXISTS `ttrss_error_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_error_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) DEFAULT NULL,
  `errno` int(11) NOT NULL,
  `errstr` text NOT NULL,
  `filename` text NOT NULL,
  `lineno` int(11) NOT NULL,
  `context` text NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_error_log`
--

LOCK TABLES `ttrss_error_log` WRITE;
/*!40000 ALTER TABLE `ttrss_error_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_error_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_feed_categories`
--

DROP TABLE IF EXISTS `ttrss_feed_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_feed_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) NOT NULL,
  `title` varchar(200) NOT NULL,
  `collapsed` tinyint(1) NOT NULL DEFAULT '0',
  `order_id` int(11) NOT NULL DEFAULT '0',
  `parent_cat` int(11) DEFAULT NULL,
  `view_settings` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `parent_cat` (`parent_cat`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_feed_categories`
--

LOCK TABLES `ttrss_feed_categories` WRITE;
/*!40000 ALTER TABLE `ttrss_feed_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_feed_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_feedbrowser_cache`
--

DROP TABLE IF EXISTS `ttrss_feedbrowser_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_feedbrowser_cache` (
  `feed_url` text NOT NULL,
  `site_url` text NOT NULL,
  `title` text NOT NULL,
  `subscribers` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_feedbrowser_cache`
--

LOCK TABLES `ttrss_feedbrowser_cache` WRITE;
/*!40000 ALTER TABLE `ttrss_feedbrowser_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_feedbrowser_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_feeds`
--

DROP TABLE IF EXISTS `ttrss_feeds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_feeds` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) NOT NULL,
  `title` varchar(200) NOT NULL,
  `cat_id` int(11) DEFAULT NULL,
  `feed_url` text NOT NULL,
  `icon_url` varchar(250) NOT NULL DEFAULT '',
  `update_interval` int(11) NOT NULL DEFAULT '0',
  `purge_interval` int(11) NOT NULL DEFAULT '0',
  `last_updated` datetime DEFAULT '0000-00-00 00:00:00',
  `last_error` varchar(250) NOT NULL DEFAULT '',
  `favicon_avg_color` varchar(11) DEFAULT NULL,
  `site_url` varchar(250) NOT NULL DEFAULT '',
  `auth_login` varchar(250) NOT NULL DEFAULT '',
  `auth_pass` varchar(250) NOT NULL DEFAULT '',
  `parent_feed` int(11) DEFAULT NULL,
  `private` tinyint(1) NOT NULL DEFAULT '0',
  `rtl_content` tinyint(1) NOT NULL DEFAULT '0',
  `hidden` tinyint(1) NOT NULL DEFAULT '0',
  `include_in_digest` tinyint(1) NOT NULL DEFAULT '1',
  `cache_images` tinyint(1) NOT NULL DEFAULT '0',
  `hide_images` tinyint(1) NOT NULL DEFAULT '0',
  `cache_content` tinyint(1) NOT NULL DEFAULT '0',
  `auth_pass_encrypted` tinyint(1) NOT NULL DEFAULT '0',
  `last_viewed` datetime DEFAULT NULL,
  `last_update_started` datetime DEFAULT NULL,
  `always_display_enclosures` tinyint(1) NOT NULL DEFAULT '0',
  `update_method` int(11) NOT NULL DEFAULT '0',
  `order_id` int(11) NOT NULL DEFAULT '0',
  `mark_unread_on_update` tinyint(1) NOT NULL DEFAULT '0',
  `update_on_checksum_change` tinyint(1) NOT NULL DEFAULT '0',
  `strip_images` tinyint(1) NOT NULL DEFAULT '0',
  `view_settings` varchar(250) NOT NULL DEFAULT '',
  `pubsub_state` int(11) NOT NULL DEFAULT '0',
  `favicon_last_checked` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`),
  KEY `cat_id` (`cat_id`),
  KEY `parent_feed` (`parent_feed`),
  KEY `ttrss_feeds_owner_uid_index` (`owner_uid`),
  KEY `ttrss_feeds_cat_id_idx` (`cat_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_feeds`
--

LOCK TABLES `ttrss_feeds` WRITE;
/*!40000 ALTER TABLE `ttrss_feeds` DISABLE KEYS */;
INSERT INTO `ttrss_feeds` VALUES (3,1,'Framablog',NULL,'http://www.framablog.org/index.php/feed/atom','',0,0,'2013-06-24 13:48:45','','','http://www.framablog.org/index.php/feed/','','',NULL,0,0,0,1,0,0,0,0,'2013-06-24 13:48:44','2013-06-24 13:48:44',0,0,0,0,0,0,'',0,'2013-06-24 11:54:23');
/*!40000 ALTER TABLE `ttrss_feeds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_filter_actions`
--

DROP TABLE IF EXISTS `ttrss_filter_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_filter_actions` (
  `id` int(11) NOT NULL,
  `name` varchar(120) NOT NULL,
  `description` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `description` (`description`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_filter_actions`
--

LOCK TABLES `ttrss_filter_actions` WRITE;
/*!40000 ALTER TABLE `ttrss_filter_actions` DISABLE KEYS */;
INSERT INTO `ttrss_filter_actions` VALUES (1,'filter','Delete article'),(2,'catchup','Mark as read'),(3,'mark','Set starred'),(4,'tag','Assign tags'),(5,'publish','Publish article'),(6,'score','Modify score'),(7,'label','Assign label'),(8,'stop','Stop / Do nothing');
/*!40000 ALTER TABLE `ttrss_filter_actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_filter_types`
--

DROP TABLE IF EXISTS `ttrss_filter_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_filter_types` (
  `id` int(11) NOT NULL,
  `name` varchar(120) NOT NULL,
  `description` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `description` (`description`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_filter_types`
--

LOCK TABLES `ttrss_filter_types` WRITE;
/*!40000 ALTER TABLE `ttrss_filter_types` DISABLE KEYS */;
INSERT INTO `ttrss_filter_types` VALUES (1,'title','Title'),(2,'content','Content'),(3,'both','Title or Content'),(4,'link','Link'),(5,'date','Article Date'),(6,'author','Author'),(7,'tag','Article Tags');
/*!40000 ALTER TABLE `ttrss_filter_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_filters2`
--

DROP TABLE IF EXISTS `ttrss_filters2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_filters2` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) NOT NULL,
  `match_any_rule` tinyint(1) NOT NULL DEFAULT '0',
  `enabled` tinyint(1) NOT NULL DEFAULT '1',
  `inverse` tinyint(1) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `order_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_filters2`
--

LOCK TABLES `ttrss_filters2` WRITE;
/*!40000 ALTER TABLE `ttrss_filters2` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_filters2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_filters2_actions`
--

DROP TABLE IF EXISTS `ttrss_filters2_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_filters2_actions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filter_id` int(11) NOT NULL,
  `action_id` int(11) NOT NULL DEFAULT '1',
  `action_param` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `filter_id` (`filter_id`),
  KEY `action_id` (`action_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_filters2_actions`
--

LOCK TABLES `ttrss_filters2_actions` WRITE;
/*!40000 ALTER TABLE `ttrss_filters2_actions` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_filters2_actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_filters2_rules`
--

DROP TABLE IF EXISTS `ttrss_filters2_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_filters2_rules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filter_id` int(11) NOT NULL,
  `reg_exp` varchar(250) NOT NULL,
  `inverse` tinyint(1) NOT NULL DEFAULT '0',
  `filter_type` int(11) NOT NULL,
  `feed_id` int(11) DEFAULT NULL,
  `cat_id` int(11) DEFAULT NULL,
  `cat_filter` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `filter_id` (`filter_id`),
  KEY `filter_type` (`filter_type`),
  KEY `feed_id` (`feed_id`),
  KEY `cat_id` (`cat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_filters2_rules`
--

LOCK TABLES `ttrss_filters2_rules` WRITE;
/*!40000 ALTER TABLE `ttrss_filters2_rules` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_filters2_rules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_labels2`
--

DROP TABLE IF EXISTS `ttrss_labels2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_labels2` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) NOT NULL,
  `caption` varchar(250) NOT NULL,
  `fg_color` varchar(15) NOT NULL DEFAULT '',
  `bg_color` varchar(15) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_labels2`
--

LOCK TABLES `ttrss_labels2` WRITE;
/*!40000 ALTER TABLE `ttrss_labels2` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_labels2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_linked_feeds`
--

DROP TABLE IF EXISTS `ttrss_linked_feeds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_linked_feeds` (
  `feed_url` text NOT NULL,
  `site_url` text NOT NULL,
  `title` text NOT NULL,
  `created` datetime NOT NULL,
  `updated` datetime NOT NULL,
  `instance_id` int(11) NOT NULL,
  `subscribers` int(11) NOT NULL,
  KEY `instance_id` (`instance_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_linked_feeds`
--

LOCK TABLES `ttrss_linked_feeds` WRITE;
/*!40000 ALTER TABLE `ttrss_linked_feeds` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_linked_feeds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_linked_instances`
--

DROP TABLE IF EXISTS `ttrss_linked_instances`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_linked_instances` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `last_connected` datetime NOT NULL,
  `last_status_in` int(11) NOT NULL,
  `last_status_out` int(11) NOT NULL,
  `access_key` varchar(250) NOT NULL,
  `access_url` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `access_key` (`access_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_linked_instances`
--

LOCK TABLES `ttrss_linked_instances` WRITE;
/*!40000 ALTER TABLE `ttrss_linked_instances` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_linked_instances` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_plugin_storage`
--

DROP TABLE IF EXISTS `ttrss_plugin_storage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_plugin_storage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  `content` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_plugin_storage`
--

LOCK TABLES `ttrss_plugin_storage` WRITE;
/*!40000 ALTER TABLE `ttrss_plugin_storage` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_plugin_storage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_prefs`
--

DROP TABLE IF EXISTS `ttrss_prefs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_prefs` (
  `pref_name` varchar(250) NOT NULL,
  `type_id` int(11) NOT NULL,
  `section_id` int(11) NOT NULL DEFAULT '1',
  `access_level` int(11) NOT NULL DEFAULT '0',
  `def_value` text NOT NULL,
  PRIMARY KEY (`pref_name`),
  KEY `type_id` (`type_id`),
  KEY `section_id` (`section_id`),
  KEY `ttrss_prefs_pref_name_idx` (`pref_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_prefs`
--

LOCK TABLES `ttrss_prefs` WRITE;
/*!40000 ALTER TABLE `ttrss_prefs` DISABLE KEYS */;
INSERT INTO `ttrss_prefs` VALUES ('PURGE_OLD_DAYS',3,1,0,'60'),('DEFAULT_UPDATE_INTERVAL',3,1,0,'30'),('DEFAULT_ARTICLE_LIMIT',3,2,0,'30'),('ALLOW_DUPLICATE_POSTS',1,1,0,'false'),('ENABLE_FEED_CATS',1,2,0,'true'),('SHOW_CONTENT_PREVIEW',1,2,1,'true'),('SHORT_DATE_FORMAT',2,3,0,'M d, G:i'),('LONG_DATE_FORMAT',2,3,0,'D, M d Y - G:i'),('COMBINED_DISPLAY_MODE',1,2,0,'true'),('HIDE_READ_FEEDS',1,2,0,'false'),('ON_CATCHUP_SHOW_NEXT_FEED',1,2,1,'false'),('FEEDS_SORT_BY_UNREAD',1,2,0,'false'),('REVERSE_HEADLINES',1,2,0,'false'),('DIGEST_ENABLE',1,4,0,'false'),('CONFIRM_FEED_CATCHUP',1,2,0,'true'),('CDM_AUTO_CATCHUP',1,2,0,'false'),('_DEFAULT_VIEW_MODE',2,1,0,'adaptive'),('_DEFAULT_VIEW_LIMIT',3,1,0,'30'),('_PREFS_ACTIVE_TAB',2,1,0,''),('STRIP_UNSAFE_TAGS',1,3,0,'true'),('BLACKLISTED_TAGS',2,3,0,'main, generic, misc, uncategorized, blog, blogroll, general, news'),('FRESH_ARTICLE_MAX_AGE',3,2,1,'24'),('DIGEST_CATCHUP',1,4,0,'false'),('CDM_EXPANDED',1,2,1,'true'),('PURGE_UNREAD_ARTICLES',1,3,0,'true'),('HIDE_READ_SHOWS_SPECIAL',1,2,1,'true'),('VFEED_GROUP_BY_FEED',1,2,1,'false'),('STRIP_IMAGES',1,2,0,'false'),('_DEFAULT_VIEW_ORDER_BY',2,1,0,'default'),('ENABLE_API_ACCESS',1,1,0,'false'),('_COLLAPSED_SPECIAL',1,1,0,'false'),('_COLLAPSED_LABELS',1,1,0,'false'),('_COLLAPSED_UNCAT',1,1,0,'false'),('_COLLAPSED_FEEDLIST',1,1,0,'false'),('_MOBILE_ENABLE_CATS',1,1,0,'false'),('_MOBILE_SHOW_IMAGES',1,1,0,'false'),('_MOBILE_HIDE_READ',1,1,0,'false'),('_MOBILE_SORT_FEEDS_UNREAD',1,1,0,'false'),('_THEME_ID',2,1,0,'0'),('USER_TIMEZONE',2,1,0,'Automatic'),('USER_STYLESHEET',2,2,0,''),('SORT_HEADLINES_BY_FEED_DATE',1,2,1,'false'),('_MOBILE_BROWSE_CATS',1,1,0,'true'),('SSL_CERT_SERIAL',2,3,0,''),('DIGEST_PREFERRED_TIME',2,4,0,'00:00'),('_PREFS_SHOW_EMPTY_CATS',1,1,0,'false'),('_DEFAULT_INCLUDE_CHILDREN',1,1,0,'false'),('AUTO_ASSIGN_LABELS',1,3,1,'false'),('_ENABLED_PLUGINS',2,1,0,''),('_MOBILE_REVERSE_HEADLINES',1,1,0,'false'),('USER_CSS_THEME',2,2,0,''),('USER_LANGUAGE',2,2,0,'');
/*!40000 ALTER TABLE `ttrss_prefs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_prefs_sections`
--

DROP TABLE IF EXISTS `ttrss_prefs_sections`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_prefs_sections` (
  `id` int(11) NOT NULL,
  `order_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_prefs_sections`
--

LOCK TABLES `ttrss_prefs_sections` WRITE;
/*!40000 ALTER TABLE `ttrss_prefs_sections` DISABLE KEYS */;
INSERT INTO `ttrss_prefs_sections` VALUES (1,0),(2,1),(3,3),(4,2);
/*!40000 ALTER TABLE `ttrss_prefs_sections` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_prefs_types`
--

DROP TABLE IF EXISTS `ttrss_prefs_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_prefs_types` (
  `id` int(11) NOT NULL,
  `type_name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_prefs_types`
--

LOCK TABLES `ttrss_prefs_types` WRITE;
/*!40000 ALTER TABLE `ttrss_prefs_types` DISABLE KEYS */;
INSERT INTO `ttrss_prefs_types` VALUES (1,'bool'),(2,'string'),(3,'integer');
/*!40000 ALTER TABLE `ttrss_prefs_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_sessions`
--

DROP TABLE IF EXISTS `ttrss_sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_sessions` (
  `id` varchar(250) NOT NULL,
  `data` text,
  `expire` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_sessions`
--

LOCK TABLES `ttrss_sessions` WRITE;
/*!40000 ALTER TABLE `ttrss_sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_settings_profiles`
--

DROP TABLE IF EXISTS `ttrss_settings_profiles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_settings_profiles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(250) NOT NULL,
  `owner_uid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_settings_profiles`
--

LOCK TABLES `ttrss_settings_profiles` WRITE;
/*!40000 ALTER TABLE `ttrss_settings_profiles` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_settings_profiles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_tags`
--

DROP TABLE IF EXISTS `ttrss_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner_uid` int(11) NOT NULL,
  `tag_name` varchar(250) NOT NULL,
  `post_int_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `post_int_id` (`post_int_id`),
  KEY `owner_uid` (`owner_uid`)
) ENGINE=MyISAM AUTO_INCREMENT=161 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_tags`
--

LOCK TABLES `ttrss_tags` WRITE;
/*!40000 ALTER TABLE `ttrss_tags` DISABLE KEYS */;
INSERT INTO `ttrss_tags` VALUES (1,1,'framasoft',1),(2,1,'debat',1),(3,1,'education',1),(4,1,'planet',1),(5,1,'rezotic',1),(6,1,'temoignage',1),(7,1,'apple google microsoft',2),(8,1,'confidentialite',2),(9,1,'docu',2),(10,1,'facebook',2),(11,1,'google',2),(12,1,'planet',2),(13,1,'rezotic',2),(14,1,'traduction',2),(15,1,'twitter',2),(16,1,'video',2),(17,1,'vieprivee',2),(18,1,'hors-sujet... ou presque',3),(19,1,'rezotic',3),(20,1,'traduction',3),(21,1,'web',3),(22,1,'libertés numériques',4),(23,1,'europe',4),(24,1,'marketing',4),(25,1,'partipirate',4),(26,1,'rezotic',4),(27,1,'surveillance',4),(28,1,'traduction',4),(29,1,'éducation',5),(30,1,'cc',5),(31,1,'collaboration',5),(32,1,'communaute',5),(33,1,'github',5),(34,1,'innovation',5),(35,1,'librevolution',5),(36,1,'planet',5),(37,1,'planetedu',5),(38,1,'rezotic',5),(39,1,'traduction',5),(40,1,'universite',5),(41,1,'framasoft',6),(42,1,'adullact',6),(43,1,'aful',6),(44,1,'europe',6),(45,1,'planet',6),(46,1,'politique',6),(47,1,'presse',6),(48,1,'rezotic',6),(49,1,'venteliee',6),(50,1,'geektionnerd',7),(51,1,'artwork',7),(52,1,'bd',7),(53,1,'google',7),(54,1,'planet',7),(55,1,'vieprivee',7),(56,1,'logiciel libre',8),(57,1,'code',8),(58,1,'interview',8),(59,1,'opensource',8),(60,1,'planet',8),(61,1,'rezotic',8),(62,1,'framasoft',9),(63,1,'education',9),(64,1,'framadvd',9),(65,1,'planet',9),(66,1,'planetedu',9),(67,1,'rezotic',9),(68,1,'libertés numériques',10),(69,1,'doctorow',10),(70,1,'planet',10),(71,1,'politique',10),(72,1,'rezotic',10),(73,1,'surveillance',10),(74,1,'traduction',10),(75,1,'usa',10),(76,1,'vieprivee',10),(77,1,'logiciel libre',11),(78,1,'gpl',11),(79,1,'licence',11),(80,1,'planet',11),(81,1,'traduction',11),(82,1,'free culture',12),(83,1,'doityourself',12),(84,1,'hardware',12),(85,1,'impression3d',12),(86,1,'librevolution',12),(87,1,'planet',12),(88,1,'rezotic',12),(89,1,'sante',12),(90,1,'traduction',12),(91,1,'logiciel libre',13),(92,1,'firefox',13),(93,1,'firefoxos',13),(94,1,'librevolution',13),(95,1,'mozilla',13),(96,1,'nitot',13),(97,1,'planet',13),(98,1,'politique',13),(99,1,'rezotic',13),(100,1,'video',13),(101,1,'geektionnerd',14),(102,1,'artwork',14),(103,1,'bd',14),(104,1,'hadopi',14),(105,1,'planet',14),(106,1,'rezotic',14),(107,1,'libertés numériques',15),(108,1,'bigbrother',15),(109,1,'mozilla',15),(110,1,'nsa',15),(111,1,'obama',15),(112,1,'planet',15),(113,1,'rezotic',15),(114,1,'traduction',15),(115,1,'usa',15),(116,1,'logiciel libre',16),(117,1,'communaute',16),(118,1,'opensource',16),(119,1,'planet',16),(120,1,'rezotic',16),(121,1,'traduction',16),(122,1,'weneedyou',16),(123,1,'wikipédia',17),(124,1,'education',17),(125,1,'planetedu',17),(126,1,'rezotic',17),(127,1,'universite',17),(128,1,'éducation',18),(129,1,'cafephilo',18),(130,1,'conference',18),(131,1,'elie',18),(132,1,'planet',18),(133,1,'planetedu',18),(134,1,'rezotic',18),(135,1,'video',18),(136,1,'éducation',19),(137,1,'copyfight',19),(138,1,'hadopi',19),(139,1,'planet',19),(140,1,'planetedu',19),(141,1,'rezotic',19),(142,1,'libertés numériques',20),(143,1,'bigbrother',20),(144,1,'nsa',20),(145,1,'obama',20),(146,1,'planet',20),(147,1,'rezotic',20),(148,1,'sopa',20),(149,1,'stallman',20),(150,1,'traduction',20),(151,1,'usa',20),(152,1,'apple google microsoft',21),(153,1,'confidentialite',21),(154,1,'entreprise',21),(155,1,'microsoft',21),(156,1,'moody',21),(157,1,'planet',21),(158,1,'rezotic',21),(159,1,'traduction',21),(160,1,'vieprivee',21);
/*!40000 ALTER TABLE `ttrss_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_user_entries`
--

DROP TABLE IF EXISTS `ttrss_user_entries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_user_entries` (
  `int_id` int(11) NOT NULL AUTO_INCREMENT,
  `ref_id` int(11) NOT NULL,
  `uuid` varchar(200) NOT NULL,
  `feed_id` int(11) DEFAULT NULL,
  `orig_feed_id` int(11) DEFAULT NULL,
  `owner_uid` int(11) NOT NULL,
  `marked` tinyint(1) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `tag_cache` text NOT NULL,
  `label_cache` text NOT NULL,
  `last_read` datetime DEFAULT NULL,
  `score` int(11) NOT NULL DEFAULT '0',
  `note` longtext,
  `last_marked` datetime DEFAULT NULL,
  `last_published` datetime DEFAULT NULL,
  `unread` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`int_id`),
  KEY `ref_id` (`ref_id`),
  KEY `feed_id` (`feed_id`),
  KEY `orig_feed_id` (`orig_feed_id`),
  KEY `owner_uid` (`owner_uid`),
  KEY `ttrss_user_entries_owner_uid_index` (`owner_uid`),
  KEY `ttrss_user_entries_ref_id_index` (`ref_id`),
  KEY `ttrss_user_entries_feed_id` (`feed_id`),
  KEY `ttrss_user_entries_unread_idx` (`unread`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_user_entries`
--

LOCK TABLES `ttrss_user_entries` WRITE;
/*!40000 ALTER TABLE `ttrss_user_entries` DISABLE KEYS */;
INSERT INTO `ttrss_user_entries` VALUES (1,1,'',3,NULL,1,0,0,'framasoft,debat,education,planet,rezotic,temoignage','{\"no-labels\":1}','2013-06-24 12:44:49',0,NULL,'2013-06-24 12:44:39','2013-06-24 12:44:44',0),(2,2,'',3,NULL,1,0,0,'apple google microsoft,confidentialite,docu,facebook,google,planet,rezotic,traduction,twitter,video,vieprivee','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(3,3,'',3,NULL,1,0,0,'hors-sujet... ou presque,rezotic,traduction,web','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(4,4,'',3,NULL,1,0,0,'libertés numériques,europe,marketing,partipirate,rezotic,surveillance,traduction','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(5,5,'',3,NULL,1,0,0,'éducation,cc,collaboration,communaute,github,innovation,librevolution,planet,planetedu,rezotic,traduction,universite','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(6,6,'',3,NULL,1,0,0,'framasoft,adullact,aful,europe,planet,politique,presse,rezotic,venteliee','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(7,7,'',3,NULL,1,0,0,'geektionnerd,artwork,bd,google,planet,vieprivee','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(8,8,'',3,NULL,1,0,0,'logiciel libre,code,interview,opensource,planet,rezotic','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(9,9,'',3,NULL,1,0,0,'framasoft,education,framadvd,planet,planetedu,rezotic','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(10,10,'',3,NULL,1,0,0,'libertés numériques,doctorow,planet,politique,rezotic,surveillance,traduction,usa,vieprivee','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(11,11,'',3,NULL,1,0,0,'logiciel libre,gpl,licence,planet,traduction','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(12,12,'',3,NULL,1,0,0,'free culture,doityourself,hardware,impression3d,librevolution,planet,rezotic,sante,traduction','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(13,13,'',3,NULL,1,0,0,'logiciel libre,firefox,firefoxos,librevolution,mozilla,nitot,planet,politique,rezotic,video','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(14,14,'',3,NULL,1,0,0,'geektionnerd,artwork,bd,hadopi,planet,rezotic','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(15,15,'',3,NULL,1,0,0,'libertés numériques,bigbrother,mozilla,nsa,obama,planet,rezotic,traduction,usa','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(16,16,'',3,NULL,1,0,0,'logiciel libre,communaute,opensource,planet,rezotic,traduction,weneedyou','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(17,17,'',3,NULL,1,0,0,'wikipédia,education,planetedu,rezotic,universite,wikipedia','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(18,18,'',3,NULL,1,0,0,'éducation,cafephilo,conference,education,elie,planet,planetedu,rezotic,video','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(19,19,'',3,NULL,1,0,0,'éducation,copyfight,education,hadopi,planet,planetedu,rezotic','{\"no-labels\":1}','2013-06-24 11:55:06',0,NULL,NULL,NULL,0),(20,20,'',3,NULL,1,0,0,'libertés numériques,bigbrother,nsa,obama,planet,rezotic,sopa,stallman,traduction,usa','{\"no-labels\":1}','2013-06-24 12:38:37',0,NULL,NULL,NULL,0),(21,21,'',3,NULL,1,0,0,'apple google microsoft,confidentialite,entreprise,microsoft,moody,planet,rezotic,traduction,vieprivee','{\"no-labels\":1}',NULL,0,NULL,NULL,NULL,1);
/*!40000 ALTER TABLE `ttrss_user_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_user_labels2`
--

DROP TABLE IF EXISTS `ttrss_user_labels2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_user_labels2` (
  `label_id` int(11) NOT NULL,
  `article_id` int(11) NOT NULL,
  KEY `label_id` (`label_id`),
  KEY `article_id` (`article_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_user_labels2`
--

LOCK TABLES `ttrss_user_labels2` WRITE;
/*!40000 ALTER TABLE `ttrss_user_labels2` DISABLE KEYS */;
/*!40000 ALTER TABLE `ttrss_user_labels2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_user_prefs`
--

DROP TABLE IF EXISTS `ttrss_user_prefs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_user_prefs` (
  `owner_uid` int(11) NOT NULL,
  `pref_name` varchar(250) DEFAULT NULL,
  `value` longtext NOT NULL,
  `profile` int(11) DEFAULT NULL,
  KEY `profile` (`profile`),
  KEY `owner_uid` (`owner_uid`),
  KEY `pref_name` (`pref_name`),
  KEY `ttrss_user_prefs_owner_uid_index` (`owner_uid`),
  KEY `ttrss_user_prefs_pref_name_idx` (`pref_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_user_prefs`
--

LOCK TABLES `ttrss_user_prefs` WRITE;
/*!40000 ALTER TABLE `ttrss_user_prefs` DISABLE KEYS */;
INSERT INTO `ttrss_user_prefs` VALUES (1,'PURGE_OLD_DAYS','60',NULL),(1,'DEFAULT_UPDATE_INTERVAL','30',NULL),(1,'DEFAULT_ARTICLE_LIMIT','30',NULL),(1,'ALLOW_DUPLICATE_POSTS','false',NULL),(1,'ENABLE_FEED_CATS','true',NULL),(1,'SHOW_CONTENT_PREVIEW','true',NULL),(1,'SHORT_DATE_FORMAT','M d, G:i',NULL),(1,'LONG_DATE_FORMAT','D, M d Y - G:i',NULL),(1,'COMBINED_DISPLAY_MODE','true',NULL),(1,'HIDE_READ_FEEDS','false',NULL),(1,'ON_CATCHUP_SHOW_NEXT_FEED','false',NULL),(1,'FEEDS_SORT_BY_UNREAD','false',NULL),(1,'REVERSE_HEADLINES','false',NULL),(1,'DIGEST_ENABLE','false',NULL),(1,'CONFIRM_FEED_CATCHUP','true',NULL),(1,'CDM_AUTO_CATCHUP','false',NULL),(1,'_DEFAULT_VIEW_MODE','adaptive',NULL),(1,'_DEFAULT_VIEW_LIMIT','30',NULL),(1,'_PREFS_ACTIVE_TAB','',NULL),(1,'STRIP_UNSAFE_TAGS','true',NULL),(1,'BLACKLISTED_TAGS','main, generic, misc, uncategorized, blog, blogroll, general, news',NULL),(1,'FRESH_ARTICLE_MAX_AGE','24',NULL),(1,'DIGEST_CATCHUP','false',NULL),(1,'CDM_EXPANDED','true',NULL),(1,'PURGE_UNREAD_ARTICLES','false',NULL),(1,'HIDE_READ_SHOWS_SPECIAL','true',NULL),(1,'VFEED_GROUP_BY_FEED','false',NULL),(1,'STRIP_IMAGES','false',NULL),(1,'_DEFAULT_VIEW_ORDER_BY','default',NULL),(1,'ENABLE_API_ACCESS','false',NULL),(1,'_COLLAPSED_SPECIAL','false',NULL),(1,'_COLLAPSED_LABELS','false',NULL),(1,'_COLLAPSED_UNCAT','false',NULL),(1,'_COLLAPSED_FEEDLIST','true',NULL),(1,'_MOBILE_ENABLE_CATS','false',NULL),(1,'_MOBILE_SHOW_IMAGES','false',NULL),(1,'_MOBILE_HIDE_READ','false',NULL),(1,'_MOBILE_SORT_FEEDS_UNREAD','false',NULL),(1,'_THEME_ID','0',NULL),(1,'USER_TIMEZONE','Automatic',NULL),(1,'USER_STYLESHEET','',NULL),(1,'SORT_HEADLINES_BY_FEED_DATE','false',NULL),(1,'_MOBILE_BROWSE_CATS','true',NULL),(1,'SSL_CERT_SERIAL','',NULL),(1,'DIGEST_PREFERRED_TIME','00:00',NULL),(1,'_PREFS_SHOW_EMPTY_CATS','false',NULL),(1,'_DEFAULT_INCLUDE_CHILDREN','false',NULL),(1,'AUTO_ASSIGN_LABELS','true',NULL),(1,'_ENABLED_PLUGINS','',NULL),(1,'_MOBILE_REVERSE_HEADLINES','false',NULL),(1,'USER_CSS_THEME','default.css',NULL),(1,'USER_LANGUAGE','fr_FR',NULL);
/*!40000 ALTER TABLE `ttrss_user_prefs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_users`
--

DROP TABLE IF EXISTS `ttrss_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(120) NOT NULL,
  `pwd_hash` varchar(250) NOT NULL,
  `last_login` datetime DEFAULT NULL,
  `access_level` int(11) NOT NULL DEFAULT '0',
  `theme_id` int(11) DEFAULT NULL,
  `email` varchar(250) NOT NULL DEFAULT '',
  `full_name` varchar(250) NOT NULL DEFAULT '',
  `email_digest` tinyint(1) NOT NULL DEFAULT '0',
  `last_digest_sent` datetime DEFAULT NULL,
  `salt` varchar(250) NOT NULL DEFAULT '',
  `created` datetime DEFAULT NULL,
  `twitter_oauth` longtext,
  `otp_enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `login` (`login`),
  KEY `theme_id` (`theme_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_users`
--

LOCK TABLES `ttrss_users` WRITE;
/*!40000 ALTER TABLE `ttrss_users` DISABLE KEYS */;
INSERT INTO `ttrss_users` VALUES (1,'admin','MODE2:cc37215043d78ce7762d5d4b090e85fcb195b75362fde160df0d5e048bbc08b9','2013-06-24 13:48:05',10,NULL,'','',0,NULL,'ac9ffa7536f6141542b313c74314dea79063be4d96d7d80501ff26f7faf698f3b1dcc3dce8b1856d21467a9b0253cbc815102f6c3eb9832a5db4f5a332cd7791921dec7911d99b212929416b6194746061fe79737113eb3910c7303c9c610742229e84441742d7e09684dcf1eaf0ab6986a956ff4a74a68750ee81669e',NULL,NULL,0);
/*!40000 ALTER TABLE `ttrss_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ttrss_version`
--

DROP TABLE IF EXISTS `ttrss_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ttrss_version` (
  `schema_version` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ttrss_version`
--

LOCK TABLES `ttrss_version` WRITE;
/*!40000 ALTER TABLE `ttrss_version` DISABLE KEYS */;
INSERT INTO `ttrss_version` VALUES (121);
/*!40000 ALTER TABLE `ttrss_version` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-06-24 15:50:46
